create or replace PROCEDURE IMPORTA_ENTRADA_DEVO
IS
   V_NROORD       VARCHAR2(40);
   V_NROITMORD    VARCHAR2(04);
   V_CODMER       VARCHAR2(20);
   V_VLRQTDMER    FLOAT;
   V_VLRQTDMERREA FLOAT;
   V_IDCTRSITMORD FLOAT;
   -- CONTROLE --
   V_FLAPRC       VARCHAR2(5);
   V_DIFERENCA    FLOAT;
   V_FECHAMENTO   VARCHAR2(40) := NULL;
   V_CONTROLE     VARCHAR2(40) := ' ';
   /* NOTA FISCAL */
   V_CDFILIAL     VARCHAR2(4);
   V_NRLANCTONF   VARCHAR2(10);
   V_DTPROCESSA   DATE;
   /* ITENS DA NOTA*/
   V_CDPRODUTO    VARCHAR2(10);
   V_VRFATOCONV   FLOAT;
   V_NRSEQITPROD  VARCHAR2(4);
   V_QTITEMPROD   FLOAT;
   V_CDPRODEMIS   VARCHAR2(20);
   V_DSPRODEMIS   VARCHAR2(400);
   V_CDALMOXARIFE VARCHAR2(6);
   V_CDLOCALESTOQ VARCHAR2(6);
   V_VRUNITITEM   FLOAT;
   V_VRDESCITEM   FLOAT;
   V_NRLOTEESTQ   VARCHAR2(20);
   V_NRSUBLOTE    VARCHAR2(4);
   V_CDPRODESTO   VARCHAR2(10);
   
   /* DEVOLUCAO */
   V_QTDEVOLUCAO  FLOAT;
   V_VRFATORSKU   FLOAT;
   V_NRLANCESTQ   VARCHAR2(20);
   V_NRLANCDEVO   VARCHAR2(20);
   V_CDEMPRESA    VARCHAR2(2);
   V_CDFILIRECE   VARCHAR2(4);
   V_CDSERIEENTR  VARCHAR2(5);
   V_CDFORNECED   VARCHAR2(21);
   
   /* LANCAMENTO DE ESTOQUE */
   V_CDFILIMOVI   VARCHAR2(4);
   V_NRLANCESTORI VARCHAR2(10);
   V_DTLANCESTQ   DATE;
   V_NRSEQPROD_IT VARCHAR2(4);
   V_CDPRODUTO_IT VARCHAR2(10);
   V_QTITEM_IT    FLOAT;
   V_CDALMOX_IT   VARCHAR2(6);
   V_CDLOCAL_IT   VARCHAR2(6);
   V_CDTIPOOPER   VARCHAR(2);
   V_RESULT_GERA  VARCHAR2(50);
   V_ERRO         VARCHAR2(500);
   V_SEQUENCIAL   INTEGER;
   V_IDPRODMENSU  VARCHAR2(1);
   V_QTDEESTO     FLOAT;
   V_VALRESTO     FLOAT;
   V_VALRBRUT     FLOAT;
   V_CDFILIALDEVO VARCHAR2(4);
   V_NRLANCTODEVO VARCHAR2(12);
   V_GEROUDEVOLUVAO BOOLEAN;

   CURSOR C_TRSITMORDENTSAI IS
      SELECT T.NROORD, LPAD(RTRIM(TO_CHAR(T.NROITMORD)),4,0), T.CODMER, T.VLRQTDMER, T.VLRQTDMERREA, T.FLAPRC, T.IDCTRSITMORDENTSAI--, M.IDCSITORD
        FROM INT_TRSITMORDENTSAI T
       WHERE IDCTIPORD = 1
         AND FLAPRC = '0'
       ORDER BY NROORD, NROITMORD;

   CURSOR C_NOTAFISCAL(C_CDFILIAL IN VARCHAR2, C_NRLANCTONF IN VARCHAR2) IS
      SELECT CDFILIRECE, CDFORNECED
        FROM NOTAFISCAL N
       WHERE N.CDFILIAL    = C_CDFILIAL
         AND N.NRLANCTONF  = C_NRLANCTONF;

   CURSOR C_ITEMPRODUTO(C_CDFILIAL IN VARCHAR2, C_NRLANCTONF IN VARCHAR2, C_CDPRODUTO IN VARCHAR2, C_NRSEQITPROD IN VARCHAR2) IS
      SELECT I.QTITEMPROD, I.CDPRODUTO, I.CDPRODEMIS, I.DSPRODEMIS, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.VRUNITITEM, I.VRDESCITEM,
             I.NRLOTEESTQ, I.NRSUBLOTE, NVL(P.VRFATOCONV, 1)
        FROM ITEMPRODUTO I, PRODUTO P
       WHERE I.CDFILIAL   = C_CDFILIAL
         AND I.NRLANCTONF = C_NRLANCTONF
         AND I.CDPRODUTO  = P.CDPRODUTO
         AND P.CDPRODESTO = C_CDPRODUTO
         AND I.NRSEQITPROD = C_NRSEQITPROD;
   
   CURSOR C_ITLANCTOEST(C_FILIAL IN VARCHAR2, C_LANCTONF IN VARCHAR2, C_CDFILIRECE IN VARCHAR2) IS
      SELECT IP.NRSEQITPROD, IP.CDPRODUTO, IP.QTITEMPROD, NVL(IP.CDALMOXARIFE, ' ') CDALMOXARIFE, NVL(IP.CDLOCALESTOQ, ' ') CDLOCALESTOQ,
             NF.CDTIPOOPER
        FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF, NOTAFISCAL NF
       WHERE IP.CDFILIAL   = NF.CDFILIAL
         AND IP.NRLANCTONF = NF.NRLANCTONF
         AND P.CDPRODUTO   = IP.CDPRODUTO
         AND PF.CDPRODUTO  = P.CDPRODESTO
         AND IP.CDFILIAL   = C_FILIAL
         AND IP.NRLANCTONF = C_LANCTONF
         AND PF.CDFILIAL   = C_CDFILIRECE
         AND NVL(IDCNTRESTOQ, 'S') = 'S';

   PROCEDURE ATU_ESTOQ
   IS
   BEGIN

      /* Atualizacao de estoque da notas */
      ATUALIZA_ESTOQUE(P_FILIMOVI   => V_CDFILIMOVI,
                       P_DTINICIAL  => TO_DATE(V_DTLANCESTQ),
                       P_DTFINAL    => TO_DATE(SYSDATE),
                       P_FILILANCTO => V_CDFILIAL,
                       P_NRLANCTO   => V_NRLANCESTORI);
   END;
   
   PROCEDURE CORRIGE_ESTOQUE
   IS
      V_CDFILIAL     VARCHAR2(4);
      V_NRLANCTONF   VARCHAR2(10);
      V_CDFILIMOVI   VARCHAR2(4);
      V_NRLANCESTORI VARCHAR2(10);
      V_DTLANCESTQ   DATE;
      
      V_NRSEQPROD_IT VARCHAR2(4);
      V_CDPRODUTO_IT VARCHAR2(10);
      V_QTITEM_IT    FLOAT;
      V_CDALMOX_IT   VARCHAR2(6);
      V_CDLOCAL_IT   VARCHAR2(6);
      V_CDTIPOOPER   VARCHAR(2);
      
      V_RESULT_GERA  VARCHAR2(50);
      
      CURSOR C_NOTAS_S_ATU IS
         SELECT N.CDFILIAL, N.NRLANCTONF, L.CDFILIMOVI, L.NRLANCESTQ, L.DTLANCESTQ
           FROM NOTAFISCAL N, LANCTOESTOQ L
          WHERE N.CDFILIRECE = '9996'
            AND N.DTENTRSAID BETWEEN '01/01/2017' AND SYSDATE
            AND N.IDENTRSAIDOP = 'E'
            AND L.CDFILIAL = N.CDFILIAL
            AND L.NRLANCTONF = N.NRLANCTONF
            AND EXISTS (SELECT NROORD FROM INT_TRSITMORDENTSAI WHERE NROORD = '1'||N.CDFILIAL||N.NRLANCTONF)
            AND NOT EXISTS (SELECT I.CDFILIAL 
                              FROM ITLANCTOEST I 
                             WHERE I.CDFILIAL = L.CDFILIAL 
                               AND I.NRLANCESTQ = L.NRLANCESTQ);
                               
      CURSOR C_PROD_ATU(C_CDFILIAL IN VARCHAR2, C_NRLANCTONF IN VARCHAR2, C_CDFILIRECE IN VARCHAR2) IS             
         SELECT IP.NRSEQITPROD, IP.CDPRODUTO, IP.QTITEMPROD, NVL(IP.CDALMOXARIFE, ' ') CDALMOXARIFE, NVL(IP.CDLOCALESTOQ, ' ') CDLOCALESTOQ,
                NF.CDTIPOOPER
           FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF, NOTAFISCAL NF
          WHERE IP.CDFILIAL   = NF.CDFILIAL
            AND IP.NRLANCTONF = NF.NRLANCTONF
            AND P.CDPRODUTO   = IP.CDPRODUTO
            AND PF.CDPRODUTO  = P.CDPRODESTO
            AND IP.CDFILIAL   = C_CDFILIAL
            AND IP.NRLANCTONF = C_NRLANCTONF
            AND PF.CDFILIAL   = C_CDFILIRECE
            AND NVL(IDCNTRESTOQ, 'S') = 'S';
   BEGIN
      OPEN C_NOTAS_S_ATU;
      LOOP
         FETCH C_NOTAS_S_ATU INTO V_CDFILIAL, V_NRLANCTONF, V_CDFILIMOVI, V_NRLANCESTORI, V_DTLANCESTQ;
         EXIT WHEN C_NOTAS_S_ATU%NOTFOUND;
         
         OPEN C_PROD_ATU(V_CDFILIAL, V_NRLANCTONF, V_CDFILIMOVI);
         LOOP
            FETCH C_PROD_ATU INTO V_NRSEQPROD_IT, V_CDPRODUTO_IT, V_QTITEM_IT, V_CDALMOX_IT, V_CDLOCAL_IT,
                                  V_CDTIPOOPER;
            EXIT WHEN C_PROD_ATU%NOTFOUND;
                  
            BEGIN
               GERA_EST_DISTRIBUICAO(V_CDFILIAL, V_NRLANCTONF, V_NRSEQPROD_IT, V_NRLANCESTORI,
                                     V_CDTIPOOPER, '2', V_DTLANCESTQ, V_CDFILIMOVI,
                                     V_CDPRODUTO_IT, V_QTITEM_IT, V_CDALMOX_IT, V_CDLOCAL_IT,
                                     NULL, NULL, V_RESULT_GERA);
            EXCEPTION
               WHEN OTHERS THEN
                  CLOSE C_PROD_ATU;
                  V_CDFILIMOVI   := '';
                  V_CDFILIAL     := '';
                  V_NRLANCESTORI := '';
                  ROLLBACK;
                  EXIT;
            END;
         END LOOP;
         
         ATUALIZA_ESTOQUE(P_FILIMOVI   => V_CDFILIMOVI,
                          P_DTINICIAL  => TO_DATE(V_DTLANCESTQ),
                          P_DTFINAL    => TO_DATE(SYSDATE),
                          P_FILILANCTO => V_CDFILIAL,
                          P_NRLANCTO   => V_NRLANCESTORI);
         
         CLOSE C_PROD_ATU;
      END LOOP;
      CLOSE C_NOTAS_S_ATU;
      COMMIT;
   EXCEPTION
     WHEN OTHERS THEN
        ROLLBACK;
        IF C_PROD_ATU%ISOPEN THEN
           CLOSE C_PROD_ATU;
        END IF;
        IF C_NOTAS_S_ATU%ISOPEN THEN
           CLOSE C_NOTAS_S_ATU;
        END IF;
   END;

   PROCEDURE CORRIGE_LANC_DEVO
   IS
      V_NROORD      VARCHAR2(40);
      V_CDFILIAL    VARCHAR2(4);
      --V_CDFIL_N_DEL VARCHAR2(4);
      V_NRLAN_N_DEL VARCHAR2(10);
      
      CURSOR C_INT_S_DEVO IS 
         SELECT NROORD, SUBSTR(NROORD, 2, 4) CDFILIAL
           FROM INT_TRSITMORDENTSAI
          WHERE NROORD NOT IN(SELECT '1'||CDFILIALIT||NRLANCTONFIT 
                                FROM ITEMNOTAFISC)
            AND VLRQTDMER > VLRQTDMERREA
            AND FLAPRC = '1'
            AND IDCTIPORD = 1
            AND LENGTH(NROORD) < 16
          GROUP BY NROORD;
      
      CURSOR C_NOTAS_DEL(C_CDFILIAL IN VARCHAR2) IS
         SELECT /*CDFILIAL,*/ NRLANCTONF 
           FROM NOTAFISCAL N
          WHERE N.CDFILIAL     = C_CDFILIAL
            AND N.IDENTRSAIDOP = 'S'
            AND N.CDTIPOOPER   = '06'
            AND N.DTENTRSAID BETWEEN '01/01/2017' AND SYSDATE
            AND NOT EXISTS (SELECT I.CDFILIAL, I.NRLANCTONF
                              FROM ITEMNOTAFISC I
                             WHERE I.CDFILIAL = N.CDFILIAL
                               AND I.NRLANCTONF = N.NRLANCTONF);
   BEGIN
      OPEN C_INT_S_DEVO;
      LOOP
         FETCH C_INT_S_DEVO INTO V_NROORD, V_CDFILIAL;
         EXIT WHEN C_INT_S_DEVO%NOTFOUND;
         
         UPDATE INT_TRSITMORDENTSAI
            SET FLAPRC = '0', DATULTPRC = NULL, DSCERR = NULL
          WHERE NROORD = V_NROORD;
         
         OPEN C_NOTAS_DEL(V_CDFILIAL);
         LOOP
            FETCH C_NOTAS_DEL INTO /*V_CDFIL_N_DEL,*/ V_NRLAN_N_DEL;
            EXIT WHEN C_NOTAS_DEL%NOTFOUND;
            
            DELETA_NF(V_CDFILIAL, V_NRLAN_N_DEL);
         END LOOP;
         CLOSE C_NOTAS_DEL;
      END LOOP;
      CLOSE C_INT_S_DEVO;
      
      COMMIT;
   EXCEPTION
      WHEN OTHERS THEN
         ROLLBACK;
         IF C_INT_S_DEVO%ISOPEN THEN
            CLOSE C_INT_S_DEVO;
         END IF;
         IF C_NOTAS_DEL%ISOPEN THEN
            CLOSE C_NOTAS_DEL;
         END IF;
   END;   
BEGIN
   V_FECHAMENTO := '  ';
   V_ERRO := NULL;
   V_GEROUDEVOLUVAO := FALSE;
   OPEN C_TRSITMORDENTSAI;
   LOOP
      FETCH C_TRSITMORDENTSAI INTO V_NROORD, V_NROITMORD, V_CODMER, V_VLRQTDMER, V_VLRQTDMERREA, V_FLAPRC, V_IDCTRSITMORD;
      IF ((V_FECHAMENTO <> V_NROORD) OR (C_TRSITMORDENTSAI%NOTFOUND)) THEN
         /* ATUALIZA ESTOQUE DA NOTA DE ORIGEM */
         IF NOT((C_TRSITMORDENTSAI%NOTFOUND)) THEN
            V_ERRO := NULL;
            --V_NRLANCDEVO := NULL;
            --V_FECHAMENTO := NULL;
            V_CDFILIAL   := SUBSTR(V_NROORD, 2, 4); /* CDFILIAL da nota de origem */
            V_NRLANCTONF := SUBSTR(V_NROORD, 6, 10); /* NRLANCTONF da nota de origem */
            SELECT CDFILIMOVI, NRLANCESTQ, DTLANCESTQ
              INTO V_CDFILIMOVI, V_NRLANCESTORI, V_DTLANCESTQ
              FROM LANCTOESTOQ
             WHERE CDFILIAL   = V_CDFILIAL
               AND NRLANCTONF = V_NRLANCTONF;

            DELETE FROM ITLANCTOEST
             WHERE CDFILIAL  = V_CDFILIAL
              AND NRLANCESTQ = V_NRLANCESTORI;

            V_SEQUENCIAL := 1;
            OPEN C_ITLANCTOEST(V_CDFILIAL, V_NRLANCTONF, V_CDFILIMOVI);
            LOOP
               FETCH C_ITLANCTOEST INTO V_NRSEQPROD_IT, V_CDPRODUTO_IT, V_QTITEM_IT, V_CDALMOX_IT, V_CDLOCAL_IT,
                                        V_CDTIPOOPER;
               EXIT WHEN C_ITLANCTOEST%NOTFOUND;

               GERA_EST_DISTRIBUICAO(V_CDFILIAL, V_NRLANCTONF, V_NRSEQPROD_IT, V_NRLANCESTORI,
                                     V_CDTIPOOPER, '2', V_DTLANCESTQ, V_CDFILIMOVI,
                                     V_CDPRODUTO_IT, V_QTITEM_IT, V_CDALMOX_IT, V_CDLOCAL_IT,
                                     NULL, NULL, V_RESULT_GERA);
            END LOOP;
            CLOSE C_ITLANCTOEST;
            
            ATU_ESTOQ;
         END IF;

         IF (V_ERRO IS NULL) THEN
            /* NOTA DE DEVOLUCAO */
            IF (V_NRLANCDEVO IS NOT NULL) THEN
               /* FECHA NOTA FISCAL */
               GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIAL   => V_CDFILIALDEVO,
                                          P_NRLANCTONF => V_NRLANCDEVO,
                                          P_NRLANCESTQ => V_NRLANCESTQ);
               
               ATU_ESTOQ;
               
               /* Atualizar a Itlanctoest para no evoluir estoque caso encontre erro ao atualizar o estoque */
               FOR C_PRODIRREG IN (SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                                          CDPRODUTO, NRLOTEESTQ, NRSUBLOTE
                                     FROM MOVILOTE
                                    WHERE NRMOVILOTE = V_CDFILIALDEVO||V_NRLANCDEVO
                                      AND CDFILIAL   = V_CDFILIMOVI) LOOP
                  UPDATE ITLANCTOEST
                     SET IDEVOLESTOQ  = 'N'
                   WHERE CDFILIAL     = V_CDFILIALDEVO
                     AND NRLANCESTQ   = V_NRLANCDEVO
                     AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
                     AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
                     AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
                     AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
                     AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;
                  
                     V_ERRO := 'Algum(ns) produto(s) tornariam o estoque irregular.';
               END LOOP;
               
               DELETE MOVILOTE
                WHERE NRMOVILOTE = V_CDFILIALDEVO||V_NRLANCDEVO;
               
               IF (V_ERRO IS NULL) THEN
                  /* RELACIONAMENTO DA ORIGEM COM A DEVOLUCAO */
                  INSERT INTO ITEMNOTAFISC(CDFILIAL, NRLANCTONF, NRSEQUITNOTA, CDFILIALIT, NRLANCTONFIT)
                  VALUES(V_CDFILIALDEVO, V_NRLANCDEVO, LPAD(V_SEQUENCIAL, 3, '0'), V_CDFILIALDEVO, V_NRLANCTODEVO);

                  /* ATUALIZA ESTOQUE DA NOTA DE DEVOLUCAO */
                  UPDATE NOTAFISCAL
                     SET DTEXPNFSAGA = SYSDATE
                   WHERE CDFILIAL   = V_CDFILIALDEVO
                     AND NRLANCTONF = V_NRLANCDEVO;

                  V_NRLANCESTORI := V_NRLANCESTQ;

                  V_SEQUENCIAL := V_SEQUENCIAL + 1;
               ELSE
                  UPDATE INT_TRSITMORDENTSAI
                     SET FLAPRC = 2,
                         DATULTPRC = SYSDATE,
                         DSCERR = V_ERRO
                   WHERE NROORD = V_FECHAMENTO
                     AND DSCERR IS NULL;
               END IF;
            END IF;

            /*IF TRIM(V_FECHAMENTO) IS NOT NULL THEN
               UPDATE INT_TRSITMORDENTSAI
                  SET FLAPRC = 1,
                      DATULTPRC = SYSDATE,
                      DSCERR = V_CDFILIAL||'-'||NVL(V_NRLANCDEVO, 'No gerou devoluo')||'-'||V_NRLANCESTQ
                WHERE NROORD = V_FECHAMENTO;
               COMMIT;
            END IF;*/

            V_NRLANCDEVO := NULL;
            V_NRLANCESTQ := NULL;
            V_ERRO := NULL;
         ELSE
            UPDATE INT_TRSITMORDENTSAI
               SET FLAPRC = 2,
                   DATULTPRC = SYSDATE,
                   DSCERR = 'Algum(ns) produto(s) com erro(s)'
             WHERE NROORD = V_FECHAMENTO
               AND DSCERR IS NULL;
         END IF;
      ELSE
         IF (V_ERRO IS NOT NULL) THEN
            UPDATE INT_TRSITMORDENTSAI
               SET FLAPRC = 2,
                   DATULTPRC = SYSDATE,
                   DSCERR = 'Algum(ns) produto(s) com erro(s)'
             WHERE NROORD = V_FECHAMENTO
               AND DSCERR IS NULL;
         END IF;
      END IF;

      EXIT WHEN C_TRSITMORDENTSAI%NOTFOUND;

      V_FECHAMENTO := V_NROORD;
      V_DIFERENCA  := 0;

      V_GEROUDEVOLUVAO := FALSE;
      V_DIFERENCA := V_VLRQTDMER - V_VLRQTDMERREA;
      IF (V_DIFERENCA > 0) THEN
         BEGIN
            SELECT CDPRODESTO
              INTO V_CDPRODUTO
              FROM PRODUTO
             WHERE CDARVPROD = V_CODMER;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDPRODUTO  := NULL;
         END;

         IF (V_CDPRODUTO IS NOT NULL) THEN
            OPEN C_NOTAFISCAL(V_CDFILIAL, V_NRLANCTONF);
            FETCH C_NOTAFISCAL INTO V_CDFILIRECE, V_CDFORNECED;
            CLOSE C_NOTAFISCAL;

            SELECT F.CDSERIE, F.CDEMPRESA, TO_DATE(TO_CHAR(NVL(P.DTPROCESSA, TO_DATE(SYSDATE)), 'DD/MM/YYYY')) DTPROCESSA
              INTO V_CDSERIEENTR, V_CDEMPRESA, V_DTPROCESSA
              FROM FILIAL F, PARAMFILIAL P
             WHERE F.CDFILIAL = P.CDFILIAL
               AND F.CDFILIAL = V_CDFILIRECE;
            
            BEGIN
               SELECT MAX(QTESTOQDIA)--, MAX(DTPOSIESTQ)
                 INTO V_QTDEESTO--, V_DTPOSIESTQ
                 FROM POSESTDIA P
                WHERE P.CDFILIAL  = V_CDFILIRECE
                  AND P.CDPRODUTO = V_CDPRODUTO
                  AND P.QTESTOQDIA <> 0
                  AND P.DTPOSIESTQ <= (SELECT MAX(DTPOSIESTQ)
                                         FROM POSESTDIA
                                        WHERE CDFILIAL = P.CDFILIAL
                                          AND CDALMOXARIFE = P.CDALMOXARIFE
                                          AND CDLOCALESTOQ = P.CDLOCALESTOQ
                                          AND NRLOTEESTQ = P.NRLOTEESTQ
                                          AND NRSUBLOTE = P.NRSUBLOTE
                                          AND CDPRODUTO = P.CDPRODUTO
                                          AND DTPOSIESTQ <= TO_DATE(V_DTPROCESSA)+1);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_QTDEESTO := 0;
            END;
            
            /* GERAR NOTA DE DEVOLUCAO */
          --  IF (V_QTDEESTO >= V_DIFERENCA) THEN
               IF (V_CONTROLE <> V_NROORD)  THEN /* GERA CORPO */
                  SELECT F.CDSERIE, F.CDEMPRESA, TO_DATE(TO_CHAR(NVL(P.DTPROCESSA, TO_DATE(SYSDATE)), 'DD/MM/YYYY')) DTPROCESSA
                    INTO V_CDSERIEENTR, V_CDEMPRESA, V_DTPROCESSA
                    FROM FILIAL F, PARAMFILIAL P
                   WHERE F.CDFILIAL = P.CDFILIAL
                     AND F.CDFILIAL = V_CDFILIRECE;

                  V_CONTROLE := V_NROORD;
                  V_CDFILIALDEVO := V_CDFILIAL;
                  V_NRLANCTODEVO := V_NRLANCTONF;
                  NOVO_CODIGO_SC('LANCNF/FILIAL'||V_CDFILIAL, V_NRLANCDEVO);
                  NOVO_CODIGO_SC('LANCTOEST'||V_CDFILIAL, V_NRLANCESTQ);

                  V_NRLANCDEVO := SUBSTR(V_NRLANCDEVO, 11, 10);
                  V_NRLANCESTQ := SUBSTR(V_NRLANCESTQ, 11, 10);

                  GERA_NOTAFISCAL_CORPO(P_CDFILIAL    => V_CDFILIAL,
                                        P_CDFILIEMIT  => V_CDFILIRECE,
                                        P_CDEMPRESA   => V_CDEMPRESA,
                                        P_CDTIPOOPER  => '06',
                                        P_DTENTRSAID  => TO_DATE(V_DTLANCESTQ),
                                        P_IDSISTEMA   => 'DFS',
                                        P_PRXLANCTONF => V_NRLANCDEVO,
                                        P_PRXLANCESTQ => V_NRLANCESTQ,
                                        P_CDSERIE     => V_CDSERIEENTR,
                                        P_CDCLIENTE   => V_CDFORNECED,
                                        P_NRLANCTONF  => V_NRLANCDEVO,
                                        P_NRLANCESTQ  => V_NRLANCESTQ);
               END IF;

               IF (V_QTDEESTO >= V_DIFERENCA) THEN
                  /* GERA ITENS */
               OPEN C_ITEMPRODUTO(V_CDFILIAL, V_NRLANCTONF, V_CDPRODUTO, V_NROITMORD);
               LOOP
                  FETCH C_ITEMPRODUTO INTO V_QTITEMPROD, V_CDPRODUTO, V_CDPRODEMIS, V_DSPRODEMIS, V_CDALMOXARIFE, V_CDLOCALESTOQ, V_VRUNITITEM, V_VRDESCITEM,
                                           V_NRLOTEESTQ, V_NRSUBLOTE, V_VRFATOCONV;
                  EXIT WHEN C_ITEMPRODUTO%NOTFOUND;

                  IF (V_ERRO IS NULL) THEN
                     BEGIN
                        SELECT CDPRODESTO
                          INTO V_CDPRODESTO
                          FROM PRODUTO
                         WHERE CDPRODUTO = V_CDPRODUTO;
                        
                        SELECT P.VRFATOCONV, NVL(C.IDPRODMENSU, 'N') IDPRODMENSU
                          INTO V_VRFATORSKU, V_IDPRODMENSU
                          FROM PRODUTO P, CARACPRODSAGA C
                         WHERE P.CDPRODESTO = V_CDPRODESTO
                         --P.CDPRODESTO = V_CDPRODUTO
                           AND P.CDPRODUTO  = C.CDPRODUTO
                           AND C.IDUNIDPADRSAGA = 'S';
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN BEGIN
                          V_VRFATORSKU := 1;
                          V_IDPRODMENSU := 'N';
                        END;
                     END;
                    
                     IF V_CDPRODESTO <> V_CDPRODUTO THEN
                        IF (V_IDPRODMENSU = 'N') THEN
                           IF (V_VRFATORSKU > 0) THEN
                              V_QTDEVOLUCAO := ((V_DIFERENCA * V_VRFATORSKU)/ V_VRFATOCONV);
                           ELSE
                              V_QTDEVOLUCAO := (V_DIFERENCA / V_VRFATOCONV);
                           END IF;
                        ELSE
                           V_QTDEVOLUCAO := (V_DIFERENCA / V_VRFATOCONV);
                        END IF;
                     ELSE
                        V_QTDEVOLUCAO := V_DIFERENCA;
                     END IF;
                     
                     GERA_NOTAFISCAL_PRODUTO(P_CDFILIAL     => V_CDFILIAL,
                                             P_NRLANCTONF   => V_NRLANCDEVO,
                                             P_CDPRODUTO    => V_CDPRODUTO,
                                             P_CDPRODEMIS   => V_CDPRODEMIS,
                                             P_DSPRODEMIS   => V_DSPRODEMIS,
                                             P_VRUNITITEM   => V_VRUNITITEM,
                                             P_VRDESCITEM   => V_VRDESCITEM, 
                                             P_CDALMOXARIFE => V_CDALMOXARIFE,
                                             P_CDLOCALESTOQ => V_CDLOCALESTOQ,
                                             P_NRLOTEESTQ   => V_NRLOTEESTQ,
                                             P_NRSUBLOTE    => V_NRSUBLOTE,
                                             P_QTITEMPROD   => V_QTDEVOLUCAO);
                  END IF;
                      
               END LOOP;
               CLOSE C_ITEMPRODUTO;
               V_GEROUDEVOLUVAO := TRUE;
            ELSE
               ROLLBACK;
               DELETA_NF(V_CDFILIAL, V_NRLANCDEVO);
               V_ERRO := 'Produto '||V_CODMER||', em estoque: '||V_QTDEESTO||', quantidade a ser devolvida '||V_DIFERENCA;
               UPDATE INT_TRSITMORDENTSAI
                  SET FLAPRC = 2,
                      DATULTPRC = SYSDATE,
                      DSCERR = V_ERRO
                WHERE NROORD = V_NROORD
                  AND CODMER = V_CODMER;
            END IF; -- VALOR A DEVOLVER MAIOR QUE ZERO
         END IF;
      END IF; -- PRODUTO EXISTE
      IF (V_ERRO IS NULL) THEN
         IF NOT V_GEROUDEVOLUVAO THEN
            UPDATE INT_TRSITMORDENTSAI
               SET FLAPRC = 1,
                   DATULTPRC = SYSDATE,
                   DSCERR = V_CDFILIAL||'-'||NVL(V_NRLANCDEVO, 'No gerou devoluo')||'-'||V_NRLANCESTQ
             WHERE NROORD = V_NROORD
               AND NROITMORD = LTRIM(V_NROITMORD, '0');
         ELSE
            UPDATE INT_TRSITMORDENTSAI
               SET FLAPRC = 1,
                   DATULTPRC = SYSDATE,
                   DSCERR = NULL
             WHERE NROORD = V_NROORD
               AND NROITMORD = LTRIM(V_NROITMORD, '0');
         END IF;
      END IF;
   END LOOP;
   
   CLOSE C_TRSITMORDENTSAI;
   COMMIT;
   CORRIGE_ESTOQUE;
   CORRIGE_LANC_DEVO;
EXCEPTION
   WHEN OTHERS THEN
      V_ERRO := SQLERRM(SQLCODE);
      
      UPDATE INT_TRSITMORDENTSAI
         SET FLAPRC = 2,
             DATULTPRC = SYSDATE,
             DSCERR = V_ERRO
       WHERE NROORD = V_NROORD;
      COMMIT;
      
      CLOSE C_TRSITMORDENTSAI;
      IF C_NOTAFISCAL%ISOPEN THEN
         CLOSE C_NOTAFISCAL;
      END IF;
      IF C_ITEMPRODUTO%ISOPEN THEN
         CLOSE C_ITEMPRODUTO;
      END IF;
      IF C_ITLANCTOEST%ISOPEN THEN
         CLOSE C_ITLANCTOEST;
      END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_ENTRADA_DEVO','6.05.xxx'); END;
/
