/* Sistemas Integrados TECNISA
   Financeiro

Nome: 1040_RECSTP_INCLUI_ERRCNABR.SQL

Descrio:
Stored procedure auxiliar para preenchimento da tabela ERRCNABR.

P_CDBANCCNAB - Cdigo oficial do banco
P_CDERRCNABR - Cdigo do erro
P_DSERRCNABR - Descrio do erro

Para aplicar, executar e debugar
-- @C:\WIN_PRJ\SQL\END_CONV\ORACLE\1040_RECSTP_INCLUI_ERRCNABR.SQL
-- EXECUTE INCLUI_ERRCNABR('237', '0200', '[ENTRADA CONFIRMADA] OCORRNCIA ACEITA');
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
05/05/00 - Ederson
*/

CREATE OR REPLACE
PROCEDURE INCLUI_ERRCNABR
  (P_CDBANCCNAB IN VARCHAR2,
   P_CDERRCNABR IN VARCHAR2,
   P_DSERRCNABR IN VARCHAR2) IS

   V_CDBANCO BANCO.CDBANCO%TYPE;
BEGIN
   FOR C_BANCO IN (SELECT CDBANCO
                     FROM BANCO
                    WHERE CDBANCCNAB = P_CDBANCCNAB
                      AND CDBANCO IS NOT NULL) LOOP

      /*DELETA O BANCO DA TABELA ANTES DE INSERIR PARA NO D ERRO DE PK*/
      SELECT MAX(CDBANCO)
        INTO V_CDBANCO
        FROM ERRCNABR
       WHERE CDBANCO    = C_BANCO.CDBANCO
         AND CDERRCNABR = P_CDERRCNABR;

      IF V_CDBANCO IS NOT NULL THEN
         DELETE FROM ERRCNABR
          WHERE CDBANCO    = C_BANCO.CDBANCO
            AND CDERRCNABR = P_CDERRCNABR;
      END IF;

      INSERT INTO ERRCNABR (CDBANCO, CDERRCNABR, DSERRCNABR) VALUES (C_BANCO.CDBANCO, P_CDERRCNABR, P_DSERRCNABR);

   END LOOP;
END;
/

BEGIN
-- BANCO BRADESCO 237

   INCLUI_ERRCNABR('237', '0200', '[ENTRADA CONFIRMADA] OCORRNCIA ACEITA');
   INCLUI_ERRCNABR('237', '0217', '[ENTRADA CONFIRMADA] DATA VENCIMENTO ANTERIOR A DATA DE EMISSO');
   INCLUI_ERRCNABR('237', '0221', '[ENTRADA CONFIRMADA] ESPCIE DO TTULO INVLIDO');
   INCLUI_ERRCNABR('237', '0224', '[ENTRADA CONFIRMADA] DATA DA EMISSO INVLIDA');
   INCLUI_ERRCNABR('237', '0238', '[ENTRADA CONFIRMADA] PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('237', '0239', '[ENTRADA CONFIRMADA] PEDIDO P.PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('237', '0243', '[ENTRADA CONFIRMADA] PRAZO PARA BAIXA DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('237', '0245', '[ENTRADA CONFIRMADA] NOME DO SACADO INVALIDO');
   INCLUI_ERRCNABR('237', '0246', '[ENTRADA CONFIRMADA] TIPO/NUM. DE INSCRIO DO SACADO INVLIDOS');
   INCLUI_ERRCNABR('237', '0247', '[ENTRADA CONFIRMADA] ENDEREO DO SACADO INVLIDO');
   INCLUI_ERRCNABR('237', '0248', '[ENTRADA CONFIRMADA] CEP INVLIDO');
   INCLUI_ERRCNABR('237', '0250', '[ENTRADA CONFIRMADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('237', '0253', '[ENTRADA CONFIRMADA] N INCR. SACADOR/AVALISTA INVLIDOS (CNPJ/CPF)');
   INCLUI_ERRCNABR('237', '0254', '[ENTRADA CONFIRMADA] SACADOR/AVALISTA NO INFORMADO');
   INCLUI_ERRCNABR('237', '0267', '[ENTRADA CONFIRMADA] DB. AUTOMTICO AGENDADO');
   INCLUI_ERRCNABR('237', '0268', '[ENTRADA CONFIRMADA] DB. NO AGENDADO ERRO NOS DADOS DE REMESSA');
   INCLUI_ERRCNABR('237', '0269', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - SACADO NO CONSTA NO CAD. AUTORIZANTE');
   INCLUI_ERRCNABR('237', '0270', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - CEDENTE NO AUTORIZADO PELO SACADO');
   INCLUI_ERRCNABR('237', '0271', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - CEDENTE NO CADASTRADO P/ DBITO AUTOMTICO');
   INCLUI_ERRCNABR('237', '0272', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - CDIGO DE MOEDA DIFERENTE DE R$');
   INCLUI_ERRCNABR('237', '0273', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('237', '0275', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - TIPO NMERO DE INSCRIO DO DEBITADO INVLIDO');
   INCLUI_ERRCNABR('237', '0286', '[ENTRADA CONFIRMADA] SEU NMERO INVLIDO');
   INCLUI_ERRCNABR('237', '0302', '[ENTRADA REJEITADA] CDIGO DO REGISTRO DETALHE INVLIDO');
   INCLUI_ERRCNABR('237', '0303', '[ENTRADA REJEITADA] CDIGO DA OCORRNCIA INVLIDO');
   INCLUI_ERRCNABR('237', '0304', '[ENTRADA REJEITADA] CD. DA OCORR. NO PERMITIDA P/A CARTEIRA');
   INCLUI_ERRCNABR('237', '0305', '[ENTRADA REJEITADA] CD. DA OCORRNCIA NO NUMRICA');
   INCLUI_ERRCNABR('237', '0308', '[ENTRADA REJEITADA] NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('237', '0309', '[ENTRADA REJEITADA] NOSSO NMERO DUPLICADO');
   INCLUI_ERRCNABR('237', '0310', '[ENTRADA REJEITADA] CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('237', '0316', '[ENTRADA REJEITADA] DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('237', '0318', '[ENTRADA REJEITADA] VENCIMENTO FORA DO PRAZO DE OPERAO');
   INCLUI_ERRCNABR('237', '0320', '[ENTRADA REJEITADA] VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('237', '0321', '[ENTRADA REJEITADA] ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('237', '0322', '[ENTRADA REJEITADA] ESPCIE NO PERMITIDA P/ CARTEIRA');
   INCLUI_ERRCNABR('237', '0324', '[ENTRADA REJEITADA] DATA DE EMISSO INVLIDA');
   INCLUI_ERRCNABR('237', '0350', '[ENTRADA REJEITADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('237', '0363', '[ENTRADA REJEITADA] ENTRADA P/TTULO J CADASTRADO');
   INCLUI_ERRCNABR('237', '0368', '[ENTRADA REJEITADA] DB. NO AGENDADO - ERRO NOS DADOS DE REMESSA');
   INCLUI_ERRCNABR('237', '0369', '[ENTRADA REJEITADA] DB. NO AGENDADO - SACADO NO CONSTA NO CAD. DE AUTORIZANTE');
   INCLUI_ERRCNABR('237', '0370', '[ENTRADA REJEITADA] DB. NO AGENDADO - CEDENTE NO AUTORIZADO PELO SACADO');
   INCLUI_ERRCNABR('237', '0371', '[ENTRADA REJEITADA] DB. NO AGENDADO - CEDENTE NO CADASTRADO P/ DBITO AUTOMTICO');
   INCLUI_ERRCNABR('237', '0372', '[ENTRADA REJEITADA] DB. NO AGENDADO - CDIGO DE MOEDA DIFERENTE DE R$');
   INCLUI_ERRCNABR('237', '0373', '[ENTRADA REJEITADA] DB. NO AGENDADO - DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('237', '0374', '[ENTRADA REJEITADA] DB. NO AGENDADO, CONFORME SEU PEDIDO, TTULO NO REGISTRADO');
   INCLUI_ERRCNABR('237', '0375', '[ENTRADA REJEITADA] DB. NO AGENDADO - TIPO NMERO DE INSCRIO DO DEBITADO INVLIDO');
   INCLUI_ERRCNABR('237', '06  ', '[LIQUIDAO NORMAL] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '0910', '[BAIXADO AUT. VIA ARQUIVO] BAIXA COMANDADA PELO CLIENTE');
   INCLUI_ERRCNABR('237', '1000', '[BAIXADO CONF. INST. AG.] BAIXA COMANDADA');
   INCLUI_ERRCNABR('237', '1014', '[BAIXADO CONF. INST. AG.] TTULO  PROTESTADO');
   INCLUI_ERRCNABR('237', '1015', '[BAIXADO CONF. INST. AG.] TTULO EXCLUDO');
   INCLUI_ERRCNABR('237', '11  ', '[EM SER (TTULO PENDENTE)] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '12  ', '[ABATIMENTO CONCEDIDO] -SEM MOTIVO');
   INCLUI_ERRCNABR('237', '13  ', '[ABATIMENTO CANCELADO] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '14  ', '[VENCIMENTO ALTERADO] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '15  ', '[LIQUIDAO EM CARTRIO] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '17  ', '[LIQUIDAO APS BAIXA] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '18  ', '[ACERTO DE DEPOSITRIA] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '19  ', '[CONF.RECEB.INST. PROTESTO ] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '20  ', '[CONF.RECEB.INST.SUST.PROT.] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '21  ', '[ACERTO CONT. PARTICIPANTE] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '23  ', '[ENTRADA TTULO EM CARTRIO] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '2448', '[ENTRADA REJEITADA] CEP INVLIDO');
   INCLUI_ERRCNABR('237', '2707', '[BAIXA REJEITADA] AGNCIA/CONTA/DV. INVLIDO');
   INCLUI_ERRCNABR('237', '2708', '[BAIXA REJEITADA] NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('237', '2710', '[BAIXA REJEITADA] CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('237', '2715', '[BAIXA REJEITADA] CARTEIRA/AG./CONTA/NUM. INVLIDOS');
   INCLUI_ERRCNABR('237', '2740', '[BAIXA REJEITADA] TTULO COM ORDEM DE PROTESTO');
   INCLUI_ERRCNABR('237', '2742', '[BAIXA REJEITADA] CDIGO P/BAIXA/DEV; VIA TELEB. INVLIDO');
   INCLUI_ERRCNABR('237', '2760', '[BAIXA REJEITADA] MOVIMENTO P/TTULO NO CADASTRADO');
   INCLUI_ERRCNABR('237', '2803', '[DB. DE TARIFAS/CUSTOS] TARIFA DE SUSTAO(valor informado-posio 176  188)');
   INCLUI_ERRCNABR('237', '2808', '[DB. DE TARIFAS/CUSTOS] CUSTAS DE PROTESTO(valor informado-posio 189  201)');
   INCLUI_ERRCNABR('237', '2804', '[DB. DE TARIFAS/CUSTOS] TARIFA DE PROTESTO (valor informado-posio 176  188)');
   INCLUI_ERRCNABR('237', '3001', '[ALTERAO/DADOS REJEITADOS] CDIGO DO BANCO INVLIDO');
   INCLUI_ERRCNABR('237', '3004', '[ALTERAO/DADOS REJEITADOS] CDIGO DE OCORRNCIA NO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('237', '3005', '[ALTERAO/DADOS REJEITADOS] CDIGO DA OCORRNCIA NO NUMRICO');
   INCLUI_ERRCNABR('237', '3008', '[ALTERAO/DADOS REJEITADOS] NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('237', '3015', '[ALTERAO/DADOS REJEITADOS] CARACTERSTICAS  DA COBRANA INCOMPATVEIS');
   INCLUI_ERRCNABR('237', '3016', '[ALTERAO/DADOS REJEITADOS] DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('237', '3017', '[ALTERAO/DADOS REJEITADOS] DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSO');
   INCLUI_ERRCNABR('237', '3018', '[ALTERAO/DADOS REJEITADOS] VENCIMENTO FORA DO PRAZO DE OPERAO');
   INCLUI_ERRCNABR('237', '3024', '[ALTERAO/DADOS REJEITADOS] DATA DA EMISSO INVLIDA');
   INCLUI_ERRCNABR('237', '3029', '[ALTERAO/DADOS REJEITADOS] VALOR DESC. MAIOR/IGUAL AO VALOR DO TTULO');
   INCLUI_ERRCNABR('237', '3030', '[ALTERAO/DADOS REJEITADOS] DESCONTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('237', '3031', '[ALTERAO/DADOS REJEITADOS] CONCESSO DE DESCONTO J EXISTENTE - DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('237', '3033', '[ALTERAO/DADOS REJEITADOS] VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('237', '3034', '[ALTERAO/DADOS REJEITADOS] VALOR ABAT. MAIOR/IGUAL VALOR DO TTULO');
   INCLUI_ERRCNABR('237', '3038', '[ALTERAO/DADOS REJEITADOS] PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('237', '3039', '[ALTERAO/DADOS REJEITADOS] PEDIDO DE PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('237', '3040', '[ALTERAO/DADOS REJEITADOS] TTULO COM ORDEM DE PROTESTO EMITIDO');
   INCLUI_ERRCNABR('237', '3042', '[ALTERAO/DADOS REJEITADOS] CDIGO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('237', '3060', '[ALTERAO/DADOS REJEITADOS] MOVIMENTO PARA TTULO NO CADASTRADO');
   INCLUI_ERRCNABR('237', '3085', '[ALTERAO/DADOS REJEITADOS] TTULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('237', '3201', '[INSTRUO REJEITADA] CDIGO DO BANCO INVLIDO');
   INCLUI_ERRCNABR('237', '3204', '[INSTRUO REJEITADA] CDIGO DE OCORRNCIA NO PERMITIDO PARA A CARTEIRA');
   INCLUI_ERRCNABR('237', '3215', '[INSTRUO REJEITADA] CARACTERSTICAS DA COBRANA INCOMPATVEIS');
   INCLUI_ERRCNABR('237', '3216', '[INSTRUO REJEITADA] DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('237', '3217', '[INSTRUO REJEITADA] DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSO');
   INCLUI_ERRCNABR('237', '3218', '[INSTRUO REJEITADA] VENCIMENTO FORA DO PRAZO DE OPERAO');
   INCLUI_ERRCNABR('237', '3220', '[INSTRUO REJEITADA] VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('237', '3221', '[INSTRUO REJEITADA] ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('237', '3223', '[INSTRUO REJEITADA] ACEITE INVLIDO');
   INCLUI_ERRCNABR('237', '3224', '[INSTRUO REJEITADA] DATA DE EMISSO INVLIDA');
   INCLUI_ERRCNABR('237', '3228', '[INSTRUO REJEITADA] CDIGO DO DESCONTO INVLIDO');
   INCLUI_ERRCNABR('237', '3229', '[INSTRUO REJEITADA] VALOR DO DESCONTO MAIOR/IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('237', '3230', '[INSTRUO REJEITADA] DESCONTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('237', '3231', '[INSTRUO REJEITADA] CONCESSO DE DESCONTO-J EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('237', '3233', '[INSTRUO REJEITADA] VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('237', '3234', '[INSTRUO REJEITADA] VALOR DO ABATIMENTO MAIOR/IGUAL AO VALOR ANTERIOR');
   INCLUI_ERRCNABR('237', '3236', '[INSTRUO REJEITADA] CONCESSO DE ABATIMENTO-J EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('237', '3238', '[INSTRUO REJEITADA] PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('237', '3239', '[INSTRUO REJEITADA] PEDIDO DE PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('237', '3240', '[INSTRUO REJEITADA] TTULO COM ORDEM DE PROTESTO EMITIDO');
   INCLUI_ERRCNABR('237', '3241', '[INSTRUO REJEITADA] PEDIDO DE CANCELAMENTO P/ TTULOS S/INSTRUO PROTESTO');
   INCLUI_ERRCNABR('237', '3242', '[INSTRUO REJEITADA] CDIGO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('237', '3245', '[INSTRUO REJEITADA] NOME DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('237', '3246', '[INSTRUO REJEITADA] TIPO/NMERO DE INCRIO DO SACADO INVLIDOS');
   INCLUI_ERRCNABR('237', '3247', '[INSTRUO REJEITADA] ENDEREO DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('237', '3248', '[INSTRUO REJEITADA] CEP INVLIDO');
   INCLUI_ERRCNABR('237', '3250', '[INSTRUO REJEITADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('237', '3253', '[INSTRUO REJEITADA] TIPO/NMERO DE INSCRIO DO SACADOR AVALISTA INVLIDOS');
   INCLUI_ERRCNABR('237', '3260', '[INSTRUO REJEITADA] MOVIMENTO PARA TTULO NO CADASTRADO');
   INCLUI_ERRCNABR('237', '3285', '[INSTRUO REJEITADA] TTULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('237', '3286', '[INSTRUO REJEITADA] SEU NMERO INVLIDO');
   INCLUI_ERRCNABR('237', '33  ', '[CONFIRMAO ALTERAO DADOS] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '34  ', '[RETIRADO CARTRIO E PENDENTE] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '3581', '[CANCELAMENTO DEB. AUTOM.] TENTATIVAS ESGOTADAS, BAIXADO');
   INCLUI_ERRCNABR('237', '3582', '[CANCELAMENTO DEB. AUTOM.] TENTATIVAS ESGOTADAS, PENDENTE');
   COMMIT;
END;
/
BEGIN
-- BANCO ITA 341

   INCLUI_ERRCNABR('341', '0303  ', '[Entradas Rejeitadas][AG. COBRADORA] NO FOI POSSVEL ATRIBUIR A AGNCIA  PELO CEP OU CEP INVLIDO');
   INCLUI_ERRCNABR('341', '0304  ', '[Entradas Rejeitadas][ESTADO] SIGLA DO ESTADO INVLIDA');
   INCLUI_ERRCNABR('341', '0305  ', '[Entradas Rejeitadas][DATA VENCIMENTO] PRAZO DA OPERAO MENOR QUE PRAZO MNIMO OU MAIOR QUE O MXIMO');
   INCLUI_ERRCNABR('341', '0307  ', '[Entradas Rejeitadas][VALOR DO TTULO] VALOR DO TTULO MAIOR QUE 10.000.000,00');
   INCLUI_ERRCNABR('341', '0308  ', '[Entradas Rejeitadas][NOME DO SACADO] NO INFORMADO OU DESLOCADO');
   INCLUI_ERRCNABR('341', '0309  ', '[Entradas Rejeitadas][AGNCIA/CONTA] AGNCIA ENCERRADA');
   INCLUI_ERRCNABR('341', '0310  ', '[Entradas Rejeitadas][LOGRADOURO] NO INFORMADO OU DESLOCADO');
   INCLUI_ERRCNABR('341', '0311  ', '[Entradas Rejeitadas][CEP] CEP NO NUMRICO');
   INCLUI_ERRCNABR('341', '0312  ', '[Entradas Rejeitadas][SACADOR AVALISTA] NOME NO INFORMADO OU DESLOCADO (BANCOS CORRESPONDENTES)');
   INCLUI_ERRCNABR('341', '0313  ', '[Entradas Rejeitadas][ESTADO/CEP] CEP INCOMPATVEL COM A SIGLA DO ESTADO');
   INCLUI_ERRCNABR('341', '0314  ', '[Entradas Rejeitadas][NOSSO NMERO] NOSSO NMERO J REGISTRADO NO CADASTRO DO BANCO OU FORA DA FAIXA');
   INCLUI_ERRCNABR('341', '0315  ', '[Entradas Rejeitadas][NOSSO NMERO] NOSSO NMERO EM DUPLICIDADE NO MESMO MOVIMENTO');
   INCLUI_ERRCNABR('341', '0318  ', '[Entradas Rejeitadas][DATA DE ENTRADA] DATA DE ENTRADA INVLIDA PARA O OPERAR COM ESTA CARTEIRA');
   INCLUI_ERRCNABR('341', '0319  ', '[Entradas Rejeitadas][OCORRNCIA] OCORRNCIA INVLIDA');
   INCLUI_ERRCNABR('341', '0321  ', '[Entradas Rejeitadas][AG. COBRADORA] CARTEIRA NO ACEITA DEPOSITRIA CORRESPONDENTE / ESTADO DA AGNCIA DIFERENTE DO ESTADO DO SACADO / AG. COBRADORA NO CONSTA NO CADASTRO OU  ENCERRANDO');
   INCLUI_ERRCNABR('341', '0322  ', '[Entradas Rejeitadas][CARTEIRA] CARTEIRA NO PERMITIDA (NECESSRIO CADASTRAR FAIXA LIVRE)');
   INCLUI_ERRCNABR('341', '0327  ', '[Entradas Rejeitadas][CGC INAPTO] CGC DO CEDENTE INAPTO');
   INCLUI_ERRCNABR('341', '0329  ', '[Entradas Rejeitadas][CDIGO EMPRESA] CATEGORIA DA CONTA INVLIDA');
   INCLUI_ERRCNABR('341', '0335  ', '[Entradas Rejeitadas][VALOR DO IOF] IOF MAIOR QUE 5%');
   INCLUI_ERRCNABR('341', '0336  ', '[Entradas Rejeitadas][QTDADE DE MOEDA] QUANTIDADE DE MOEDA INCOMPATVEL COM VALOR DO TTULO');
   INCLUI_ERRCNABR('341', '0337  ', '[Entradas Rejeitadas][CGC/CPF DO SACADO] NO NUMRICO OU IGUAL A ZEROS');
   INCLUI_ERRCNABR('341', '0342  ', '[Entradas Rejeitadas][NOSSO NMERO] NOSSO NMERO FORA DE FAIXA');
   INCLUI_ERRCNABR('341', '0352  ', '[Entradas Rejeitadas][AG. COBRADORA] EMPRESA NO ACEITA BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('341', '0353  ', '[Entradas Rejeitadas][AG. COBRADORA] EMPRESA NO ACEITA BANCO CORRESPONDENTE  - COBRANA MENSAGEM');
   INCLUI_ERRCNABR('341', '0354  ', '[Entradas Rejeitadas][DATA DE VENCTO] BANCO CORRESPONDENTE - TTULO COM VENCIMENTO INFERIOR A 15 DIAS');
   INCLUI_ERRCNABR('341', '0355  ', '[Entradas Rejeitadas][DEP/BCO CORRESP] CEP NO PERTENCENTE A DEPOSITRIO INFORMADO');
   INCLUI_ERRCNABR('341', '0356  ', '[Entradas Rejeitadas][DT.VENCTO/BCO CORRESP] VENCTO. SUPERIOR A 180 DIAS DA DATA DE ENTRADA');
   INCLUI_ERRCNABR('341', '0357  ', '[Entradas Rejeitadas][DATA DE VENCTO] CEP S DEPOSITRIA BCO DO BRASIL COM VENCTO INFERIOR A 8 DIAS');
   INCLUI_ERRCNABR('341', '0360  ', '[Entradas Rejeitadas][ABATIMENTO] VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('341', '0361  ', '[Entradas Rejeitadas][JUROS DE MORA] JUROS DE MORA MAIOR QUE O PERMITIDO');
   INCLUI_ERRCNABR('341', '0362  ', '[Entradas Rejeitadas][DESCONTO] VALOR DO DESCONTO MAIOR QUE O VALOR DO TTULO');
   INCLUI_ERRCNABR('341', '0363  ', '[Entradas Rejeitadas][IMPORTNCIA POR DIA DE DESCONTO] NO PERMITIDO');
   INCLUI_ERRCNABR('341', '0364  ', '[Entradas Rejeitadas][EMISSO DO TTULO] DATA DE EMISSO DO TTULO INVLIDA (VENDOR)');
   INCLUI_ERRCNABR('341', '0365  ', '[Entradas Rejeitadas][TAXA FINANCTO] TAXA INVLIDA (VENDOR)');
   INCLUI_ERRCNABR('341', '0366  ', '[Entradas Rejeitadas][DATA DE VENCTO] INVALIDA/FORA DE PRAZO DE OPERAO (MNIMO OU MXIMO)');
   INCLUI_ERRCNABR('341', '0367  ', '[Entradas Rejeitadas][VALOR/QTIDADE] VALOR DO TTULO/QUANTIDADE DE MOEDA INVLIDO');
   INCLUI_ERRCNABR('341', '0368  ', '[Entradas Rejeitadas][CARTEIRA] CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('341', '0398  ', '[Entradas Rejeitadas][FLASH INVLIDO] REGISTRO MENSAGEM SEM FLASH CADASTRADO OU FLASH INFORMADO DIFERENTE DO CADASTRADO');
   INCLUI_ERRCNABR('341', '0399  ', '[Entradas Rejeitadas][FLASH INVLIDO] CONTA DE COBRANA COM FLASH CADASTRADO, E SEM REGISTRO DE MENSAGEM CORRESPONDENTE');
   INCLUI_ERRCNABR('341', '0391  ', '[Entradas Rejeitadas][DAC] DAC AGNCIA / CONTA CORRENTE INVLIDO');
   INCLUI_ERRCNABR('341', '0392  ', '[Entradas Rejeitadas][DAC] DAC AGNCIA/CONTA/CARTEIRA/NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('341', '0393  ', '[Entradas Rejeitadas][ESTADO] SIGLA ESTADO INVLIDA');
   INCLUI_ERRCNABR('341', '0394  ', '[Entradas Rejeitadas][ESTADO] SIGLA ESTADO INCOMPATVEL COM CEP DO SACADO');
   INCLUI_ERRCNABR('341', '0395  ', '[Entradas Rejeitadas][CEP] CEP DO SACADO NO NUMRICO OU INVLIDO');
   INCLUI_ERRCNABR('341', '0396  ', '[Entradas Rejeitadas][ENDEREO] ENDEREO / NOME / CIDADE SACADO INVLIDO');
   INCLUI_ERRCNABR('341', '1702  ', '[Alterao de dados rejeitados] AGNCIA COBRADORA INVLIDA OU COM O MESMO CONTEDO');
   INCLUI_ERRCNABR('341', '1704  ', '[Alterao de dados rejeitados] SIGLA DO ESTADO INVLIDA');
   INCLUI_ERRCNABR('341', '1705  ', '[Alterao de dados rejeitados] DATA DE VENCIMENTO INVLIDA OU COM O MESMO CONTEDO');
   INCLUI_ERRCNABR('341', '1706  ', '[Alterao de dados rejeitados] VALOR DO TTULO COM OUTRA ALTERAO SIMULTNEA');
   INCLUI_ERRCNABR('341', '1708  ', '[Alterao de dados rejeitados] NOME DO SACADO COM O MESMO CONTEDO');
   INCLUI_ERRCNABR('341', '1709  ', '[Alterao de dados rejeitados] AGNCIA/CONTA INCORRETOS');
   INCLUI_ERRCNABR('341', '1711  ', '[Alterao de dados rejeitados] CEP INVLIDO');
   INCLUI_ERRCNABR('341', '1713  ', '[Alterao de dados rejeitados] SEU NMERO COM O MESMO CONTEDO');
   INCLUI_ERRCNABR('341', '1716  ', '[Alterao de dados rejeitados] ABATIMENTO/ALTERAO DO VALOR DO TTULO OU SOLICITAO DE BAIXA BLOQUEADA');
   INCLUI_ERRCNABR('341', '1721  ', '[Alterao de dados rejeitados] AGNCIA COBRADORA NO CONSTA NO CADASTRO DE DEPOSITRIA OU EM ENCERRAMENTO');
   INCLUI_ERRCNABR('341', '1753  ', '[Alterao de dados rejeitados] INSTRUO COM O MESMO CONTEDO');
   INCLUI_ERRCNABR('341', '1754  ', '[Alterao de dados rejeitados] DATA VENCIMENTO PARA BANCOS CORRESPONDENTES INFERIOR AO ACEITO PELO BANCO');
   INCLUI_ERRCNABR('341', '1755  ', '[Alterao de dados rejeitados] ALTERAES IGUAIS PARA O MESMO CONTROLE (AGNCIA/CONTA/CARTEIRA/NOSSO NMERO)');
   INCLUI_ERRCNABR('341', '1756  ', '[Alterao de dados rejeitados] CGC/CPF INVLIDO NO NUMRICO OU ZERADO');
   INCLUI_ERRCNABR('341', '1757  ', '[Alterao de dados rejeitados] PRAZO DE VENCIMENTO INFERIOR A 15 DIAS');
   INCLUI_ERRCNABR('341', '1760  ', '[Alterao de dados rejeitados] VALOR DE IOF - ALTERAO NO PERMITIDA PARA CARTEIRAS DE N.S. - MOEDA VARIVEL');
   INCLUI_ERRCNABR('341', '1761  ', '[Alterao de dados rejeitados] TTULO J BAIXADO OU LIQUIDADO OU NO EXISTE TTULO CORRESPONDENTE NO SISTEMA');
   INCLUI_ERRCNABR('341', '1766  ', '[Alterao de dados rejeitados] ALTERAO NO PERMITIDA PARA CARTEIRAS DE NOTAS DE SEGUROS - MOEDA VARIVEL');
   INCLUI_ERRCNABR('341', '1781  ', '[Alterao de dados rejeitados] ALTERAO BLOQUEADA - TTULO COM PROTESTO');
   INCLUI_ERRCNABR('341', '1601  ', '[Instrues rejeitadas] INSTRUO/OCORRNCIA NO EXISTENTE');
   INCLUI_ERRCNABR('341', '1606  ', '[Instrues rejeitadas] NOSSO NMERO IGUAL A ZEROS');
   INCLUI_ERRCNABR('341', '1609  ', '[Instrues rejeitadas] CGC/CPF  DO SACADOR/AVALISTA INVLIDO');
   INCLUI_ERRCNABR('341', '1610  ', '[Instrues rejeitadas] VALOR DO ABATIMENTO IGUAL OU MAIOR QUE O VALOR DO TTULO');
   INCLUI_ERRCNABR('341', '1614  ', '[Instrues rejeitadas] REGISTRO EM DUPLICIDADE');
   INCLUI_ERRCNABR('341', '1615  ', '[Instrues rejeitadas] CGC/CPF INFORMADO SEM NOME DO SACADOR/AVALISTA');
   INCLUI_ERRCNABR('341', '1621  ', '[Instrues rejeitadas] TTULO NO REGISTRADO NO SISTEMA');
   INCLUI_ERRCNABR('341', '1622  ', '[Instrues rejeitadas] TTULO BAIXADO OU LIQUIDADO');
   INCLUI_ERRCNABR('341', '1623  ', '[Instrues rejeitadas] INSTRUO NO ACEITA POR TER SIDO EMITIDO LTIMO AVISO AO SACADO');
   INCLUI_ERRCNABR('341', '1624  ', '[Instrues rejeitadas] INSTRUO INCOMPATVEL - EXISTE INSTRUO DE PROTESTO PARA O TTULO');
   INCLUI_ERRCNABR('341', '1625  ', '[Instrues rejeitadas] INSTRUO INCOMPATVEL - NO EXISTE INSTRUO DE PROTESTO PARA O TTULO');
   INCLUI_ERRCNABR('341', '1626  ', '[Instrues rejeitadas] INSTRUO NO ACEITA POR TER SIDO EMITIDO LTIMO AVISO AO SACADO');
   INCLUI_ERRCNABR('341', '1627  ', '[Instrues rejeitadas] INSTRUO NO ACEITA POR NO TER SIDO EMITIDA A ORDEM DE PROTESTO AO CARTRIO');
   INCLUI_ERRCNABR('341', '1628  ', '[Instrues rejeitadas] J EXISTE UMA MESMA INSTRUO CADASTRADA ANTERIORMENTE PARA O TTULO');
   INCLUI_ERRCNABR('341', '1629  ', '[Instrues rejeitadas] VALOR LQUIDO + VALOR DO ABATIMENTO DIFERENTE DO VALOR DO TTULO REGISTRADO');
   INCLUI_ERRCNABR('341', '1630  ', '[Instrues rejeitadas] EXISTE UMA INSTRUO DE NO PROTESTAR ATIVA PARA O TTULO');
   INCLUI_ERRCNABR('341', '1631  ', '[Instrues rejeitadas] EXISTE UMA OCORRNCIA DO SACADO QUE BLOQUEIA A INSTRUO');
   INCLUI_ERRCNABR('341', '1632  ', '[Instrues rejeitadas] DEPOSITRIA DO TTULO = 9999 OU CARTEIRA NO ACEITA PROTESTO');
   INCLUI_ERRCNABR('341', '1633  ', '[Instrues rejeitadas] ALTERAO DE VENCIMENTO IGUAL  REGISTRADA NO SISTEMA OU QUE TORNA O TTULO VENCIDO');
   INCLUI_ERRCNABR('341', '1634  ', '[Instrues rejeitadas] INSTRUO DE EMISSO DE AVISO DE COBRANA PARA TTULO VENCIDO ANTES DO VENCIMENTO');
   INCLUI_ERRCNABR('341', '1635  ', '[Instrues rejeitadas] SOLICITAO DE CANCELAMENTO DE INSTRUO INEXISTENTE');
   INCLUI_ERRCNABR('341', '1636  ', '[Instrues rejeitadas] TTULO SOFRENDO ALTERAO DE CONTROLE (AGNCIA/CONTA/CARTEIRA/NOSSO NMERO)');
   INCLUI_ERRCNABR('341', '1637  ', '[Instrues rejeitadas] INSTRUO NO PERMITIDA PARA A CARTEIRA');
   INCLUI_ERRCNABR('341', '1501  ', '[Baixas rejeitadas] CARTEIRA/N NMERO NO NUMRICO');
   INCLUI_ERRCNABR('341', '1504  ', '[Baixas rejeitadas] NOSSO NMERO EM DUPLICIDADE NUM MESMO MOVIMENTO');
   INCLUI_ERRCNABR('341', '1505  ', '[Baixas rejeitadas] SOLICITAO DE BAIXA PARA TTULO J BAIXADO OU LIQUIDADO');
   INCLUI_ERRCNABR('341', '1506  ', '[Baixas rejeitadas] SOLICITAO DE BAIXA PARA TTULO NO REGISTRADO NO SISTEMA');
   INCLUI_ERRCNABR('341', '1507  ', '[Baixas rejeitadas] COBRANA PRAZO CURTO - SOLICITAO DE BAIXA P/ TTULO NO REGISTRADO NO SISTEMA');
   INCLUI_ERRCNABR('341', '1508  ', '[Baixas rejeitadas] SOLICITAO DE BAIXA PARA TTULO EM FLOATING');
   INCLUI_ERRCNABR('341', '1816  ', '[Alterao dados cobrana contratual rejeitada] ABATIMENTO/ALTERAO DO VALOR DO TTULO OU SOLICITAO DE BAIXAS BLOQUEADOS');
   INCLUI_ERRCNABR('341', '251313', '[Alegaes do sacado] SACADO SOLICITA A PRORROGAO DO VENCIMENTO PARA:');
   INCLUI_ERRCNABR('341', '251321', '[Alegaes do sacado] SACADO SOLICITA A DISPENSA DOS JUROS DE MORA');
   INCLUI_ERRCNABR('341', '251339', '[Alegaes do sacado] SACADO ALEGA QUE NO RECEBEU A MERCADORIA');
   INCLUI_ERRCNABR('341', '251347', '[Alegaes do sacado] SACADO ALEGA QUE A MERCADORIA CHEGOU ATRASADA');
   INCLUI_ERRCNABR('341', '251354', '[Alegaes do sacado] SACADO ALEGA QUE A MERCADORIA CHEGOU AVARIADA');
   INCLUI_ERRCNABR('341', '251362', '[Alegaes do sacado] SACADO ALEGA QUE A MERCADORIA CHEGOU INCOMPLETA');
   INCLUI_ERRCNABR('341', '251370', '[Alegaes do sacado] SACADO ALEGA QUE A MERCADORIA NO CONFERE COM O PEDIDO');
   INCLUI_ERRCNABR('341', '251388', '[Alegaes do sacado] SACADO ALEGA QUE A MERCADORIA EST  DISPOSIO');
   INCLUI_ERRCNABR('341', '251396', '[Alegaes do sacado] SACADO ALEGA QUE DEVOLVEU A MERCADORIA');
   INCLUI_ERRCNABR('341', '251404', '[Alegaes do sacado] SACADO ALEGA QUE NO RECEBEU A FATURA');
   INCLUI_ERRCNABR('341', '251412', '[Alegaes do sacado] SACADO ALEGA QUE A FATURA EST EM DESACORDO COM A NOTA FISCAL');
   INCLUI_ERRCNABR('341', '251420', '[Alegaes do sacado] SACADO ALEGA QUE O PEDIDO DE COMPRA FOI CANCELADO');
   INCLUI_ERRCNABR('341', '251438', '[Alegaes do sacado] SACADO ALEGA QUE A DUPLICATA FOI CANCELADA');
   INCLUI_ERRCNABR('341', '251446', '[Alegaes do sacado] SACADO ALEGA QUE NADA DEVE OU COMPROU');
   INCLUI_ERRCNABR('341', '251453', '[Alegaes do sacado] SACADO ALEGA QUE MANTM ENTENDIMENTOS COM O SACADOR');
   INCLUI_ERRCNABR('341', '251461', '[Alegaes do sacado] SACADO ALEGA QUE PAGAR O TTULO EM:');
   INCLUI_ERRCNABR('341', '251479', '[Alegaes do sacado] SACADO ALEGA QUE PAGOU O TTULO DIRETAMENTE AO CEDENTE EM:');
   INCLUI_ERRCNABR('341', '251487', '[Alegaes do sacado] SACADO ALEGA QUE PAGAR O TTULO DIRETAMENTE AO CEDENTE EM:');
   INCLUI_ERRCNABR('341', '251495', '[Alegaes do sacado] SACADO ALEGA QUE O VENCIMENTO CORRETO :');
   INCLUI_ERRCNABR('341', '251503', '[Alegaes do sacado] SACADO ALEGA QUE TEM DESCONTO OU ABATIMENTO DE:');
   INCLUI_ERRCNABR('341', '251719', '[Alegaes do sacado] SACADO NO FOI LOCALIZADO; CONFIRMAR ENDEREO');
   INCLUI_ERRCNABR('341', '251727', '[Alegaes do sacado] SACADO EST EM REGIME DE CONCORDATA');
   INCLUI_ERRCNABR('341', '251735', '[Alegaes do sacado] SACADO EST EM REGIME DE FALNCIA');
   INCLUI_ERRCNABR('341', '251750', '[Alegaes do sacado] SACADO SE RECUSA A PAGAR JUROS BANCRIOS');
   INCLUI_ERRCNABR('341', '251768', '[Alegaes do sacado] SACADO SE RECUSA A PAGAR COMISSO DE PERMANNCIA');
   INCLUI_ERRCNABR('341', '251776', '[Alegaes do sacado] NO FOI POSSVEL A ENTREGA DO BLOQUETO AO SACADO');
   INCLUI_ERRCNABR('341', '251784', '[Alegaes do sacado] BLOQUETO NO ENTREGUE, MUDOU-SE/DESCONHECIDO');
   INCLUI_ERRCNABR('341', '251792', '[Alegaes do sacado] BLOQUETO NO ENTREGUE, CEP ERRADO/INCOMPLETO');
   INCLUI_ERRCNABR('341', '251800', '[Alegaes do sacado] BLOQUETO NO ENTREGUE, NMERO NO EXISTE/ENDEREO INCOMPLETO');
   INCLUI_ERRCNABR('341', '243111', '[Ordem de protesto sustada] SUSTAO SOLICITADA AG. CEDENTE');
   INCLUI_ERRCNABR('341', '243228', '[Ordem de protesto sustada] ATOS DA CORREGEDORIA ESTADUAL');
   INCLUI_ERRCNABR('341', '243301', '[Ordem de protesto sustada] CGC/CPF DO SACADO INVLIDO/INCORRETO');
   INCLUI_ERRCNABR('341', '243319', '[Ordem de protesto sustada] SACADOR/AVALISTA E PESSOA FSICA');
   INCLUI_ERRCNABR('341', '243327', '[Ordem de protesto sustada] CEP DO SACADO INCORRETO');
   INCLUI_ERRCNABR('341', '243335', '[Ordem de protesto sustada] DEPOSITRIA INCOMPATVEL COM CEP DO SACADO');
   INCLUI_ERRCNABR('341', '243343', '[Ordem de protesto sustada] CGC/CPF SACADOR INVALIDO/INCORRETO');
   INCLUI_ERRCNABR('341', '243350', '[Ordem de protesto sustada] ENDEREO DO SACADO INSUFICIENTE');
   INCLUI_ERRCNABR('341', '243368', '[Ordem de protesto sustada] PRAA PAGTO INCOMPATVEL COM ENDEREO');
   INCLUI_ERRCNABR('341', '243376', '[Ordem de protesto sustada] FALTA NMERO/ESPCIE DO TTULO');
   INCLUI_ERRCNABR('341', '243384', '[Ordem de protesto sustada] TTULO ACEITO S/ ASSINATURA DO SACADOR');
   INCLUI_ERRCNABR('341', '243392', '[Ordem de protesto sustada] TTULO ACEITO S/ ENDOSSO CEDENTE OU IRREGULAR');
   INCLUI_ERRCNABR('341', '243400', '[Ordem de protesto sustada] TTULO SEM LOCAL OU DATA DE EMISSO');
   INCLUI_ERRCNABR('341', '243418', '[Ordem de protesto sustada] TTULO ACEITO VALOR EXTENSO DIFERENTE DO NUMRICO');
   INCLUI_ERRCNABR('341', '243426', '[Ordem de protesto sustada] TTULO ACEITO DEFINIR ESPCIE DA DUPLICATA');
   INCLUI_ERRCNABR('341', '243434', '[Ordem de protesto sustada] DATA EMISSO POSTERIOR AO VENCIMENTO');
   INCLUI_ERRCNABR('341', '243442', '[Ordem de protesto sustada] TTULO ACEITO DOCUMENTO NO PROSTESTVEL');
   INCLUI_ERRCNABR('341', '243459', '[Ordem de protesto sustada] TTULO ACEITO EXTENSO VENCIMENTO IRREGULAR');
   INCLUI_ERRCNABR('341', '243467', '[Ordem de protesto sustada] TTULO ACEITO FALTA NOME FAVORECIDO');
   INCLUI_ERRCNABR('341', '243475', '[Ordem de protesto sustada] TTULO ACEITO FALTA PRAA DE PAGAMENTO');
   INCLUI_ERRCNABR('341', '243483', '[Ordem de protesto sustada] TTULO ACEITO FALTA CPF ASSINANTE CHEQUE');
   COMMIT;
END;
/
BEGIN
-- BANCO HSBC 399

   INCLUI_ERRCNABR('399', '0301', '[ENTRADA REJEITADA] CDIGO DO BANCO INVLIDO');
   INCLUI_ERRCNABR('399', '0302', '[ENTRADA REJEITADA] CDIGO DO REGISTRO DETALHE INVLIDO');
   INCLUI_ERRCNABR('399', '0303', '[ENTRADA REJEITADA] CDIGO DO SEGMENTO INVLIDO');
   INCLUI_ERRCNABR('399', '0304', '[ENTRADA REJEITADA] CDIGO DO MOVIMENTO NO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('399', '0305', '[ENTRADA REJEITADA] CDIGO DE MOVIMENTO INVLIDO');
   INCLUI_ERRCNABR('399', '0306', '[ENTRADA REJEITADA] TIPO/NMERO DE INSCRIO DO CEDENTE INVLIDOS');
   INCLUI_ERRCNABR('399', '0307', '[ENTRADA REJEITADA] CDIGO DE CONVNIO INVLIDO OU NO CADASTRADO');
   INCLUI_ERRCNABR('399', '0308', '[ENTRADA REJEITADA] NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('399', '0309', '[ENTRADA REJEITADA] NOSSO NMERO DUPLICADO');
   INCLUI_ERRCNABR('399', '0310', '[ENTRADA REJEITADA] CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('399', '0311', '[ENTRADA REJEITADA] FORMA DE CADASTRAMENTO DO TTULO INVLIDO');
   INCLUI_ERRCNABR('399', '0312', '[ENTRADA REJEITADA] TIPO DE DOCUMENTO INVLIDO');
   INCLUI_ERRCNABR('399', '0313', '[ENTRADA REJEITADA] IDENTIFICAO DA EMISSO DO BLOQUETO INVLIDA');
   INCLUI_ERRCNABR('399', '0314', '[ENTRADA REJEITADA] IDENTIFICAO DA DISTRIBUIO DO BLOQUETO INVLIDA');
   INCLUI_ERRCNABR('399', '0315', '[ENTRADA REJEITADA] CARACTERSTICAS DA COBRANA INCOMPATVEIS');
   INCLUI_ERRCNABR('399', '0316', '[ENTRADA REJEITADA] DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('399', '0320', '[ENTRADA REJEITADA] VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('399', '0321', '[ENTRADA REJEITADA] ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('399', '0323', '[ENTRADA REJEITADA] ACEITE INVLIDO');
   INCLUI_ERRCNABR('399', '0324', '[ENTRADA REJEITADA] DATA DA EMISSO INVLIDA');
   INCLUI_ERRCNABR('399', '0326', '[ENTRADA REJEITADA] CDIGO DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('399', '0327', '[ENTRADA REJEITADA] VALOR/TAXA DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('399', '0328', '[ENTRADA REJEITADA] CDIGO DO DESCONTO INVLIDO');
   INCLUI_ERRCNABR('399', '0330', '[ENTRADA REJEITADA] DESCONTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('399', '0333', '[ENTRADA REJEITADA] VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('399', '0335', '[ENTRADA REJEITADA] ABATIMENTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('399', '0337', '[ENTRADA REJEITADA] CDIGO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('399', '0338', '[ENTRADA REJEITADA] PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('399', '0342', '[ENTRADA REJEITADA] CDIGO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('399', '0343', '[ENTRADA REJEITADA] PRAZO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('399', '0344', '[ENTRADA REJEITADA] CDIGO DA MOEDA INVLIDO');
   INCLUI_ERRCNABR('399', '0345', '[ENTRADA REJEITADA] NOME DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('399', '0346', '[ENTRADA REJEITADA] TIPO/NMERO DE INSCRIO DO SACADO INVLIDOS');
   INCLUI_ERRCNABR('399', '0347', '[ENTRADA REJEITADA] ENDEREO DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('399', '0348', '[ENTRADA REJEITADA] CEP INVLIDO');
   INCLUI_ERRCNABR('399', '0349', '[ENTRADA REJEITADA] CEP SEM PRAA DE COBRANA (NO LOCALIZADO)');
   INCLUI_ERRCNABR('399', '0350', '[ENTRADA REJEITADA] CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('399', '0352', '[ENTRADA REJEITADA] UNIDADE DA FEDERAO INVLIDA');
   INCLUI_ERRCNABR('399', '0357', '[ENTRADA REJEITADA] CDIGO DA MULTA INVLIDO');
   INCLUI_ERRCNABR('399', '0358', '[ENTRADA REJEITADA] DATA DA MULTA INVLIDA');
   INCLUI_ERRCNABR('399', '0359', '[ENTRADA REJEITADA] VALOR/PERCENTUAL DA MULTA INVLIDO');
   INCLUI_ERRCNABR('399', '0362', '[ENTRADA REJEITADA] TIPO DE IMPRESSO INVLIDO');
   INCLUI_ERRCNABR('399', '0363', '[ENTRADA REJEITADA] ENTRADA PARA TTULO J CADASTRADO');
   INCLUI_ERRCNABR('399', '2601', '[ENTRADA REJEITADA] CDIGO DO BANCO INVLIDO');
   INCLUI_ERRCNABR('399', '2602', '[ENTRADA REJEITADA] CDIGO DO REGISTRO DETALHE INVLIDO');
   INCLUI_ERRCNABR('399', '2603', '[ENTRADA REJEITADA] CDIGO DO SEGMENTO INVLIDO');
   INCLUI_ERRCNABR('399', '2604', '[ENTRADA REJEITADA] CDIGO DO MOVIMENTO NO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('399', '2605', '[ENTRADA REJEITADA] CDIGO DE MOVIMENTO INVLIDO');
   INCLUI_ERRCNABR('399', '2606', '[ENTRADA REJEITADA] TIPO/NMERO DE INSCRIO DO CEDENTE INVLIDOS');
   INCLUI_ERRCNABR('399', '2607', '[ENTRADA REJEITADA] CDIGO DE CONVNIO INVLIDO OU NO CADASTRADO');
   INCLUI_ERRCNABR('399', '2608', '[ENTRADA REJEITADA] NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('399', '2609', '[ENTRADA REJEITADA] NOSSO NMERO DUPLICADO');
   INCLUI_ERRCNABR('399', '2610', '[ENTRADA REJEITADA] CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('399', '2611', '[ENTRADA REJEITADA] FORMA DE CADASTRAMENTO DO TTULO INVLIDO');
   INCLUI_ERRCNABR('399', '2612', '[ENTRADA REJEITADA] TIPO DE DOCUMENTO INVLIDO');
   INCLUI_ERRCNABR('399', '2613', '[ENTRADA REJEITADA] IDENTIFICAO DA EMISSO DO BLOQUETO INVLIDA');
   INCLUI_ERRCNABR('399', '2614', '[ENTRADA REJEITADA] IDENTIFICAO DA DISTRIBUIO DO BLOQUETO INVLIDA');
   INCLUI_ERRCNABR('399', '2615', '[ENTRADA REJEITADA] CARACTERSTICAS DA COBRANA INCOMPATVEIS');
   INCLUI_ERRCNABR('399', '2616', '[ENTRADA REJEITADA] DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('399', '2620', '[ENTRADA REJEITADA] VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('399', '2621', '[ENTRADA REJEITADA] ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('399', '2623', '[ENTRADA REJEITADA] ACEITE INVLIDO');
   INCLUI_ERRCNABR('399', '2624', '[ENTRADA REJEITADA] DATA DA EMISSO INVLIDA');
   INCLUI_ERRCNABR('399', '2626', '[ENTRADA REJEITADA] CDIGO DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('399', '2627', '[ENTRADA REJEITADA] VALOR/TAXA DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('399', '2628', '[ENTRADA REJEITADA] CDIGO DO DESCONTO INVLIDO');
   INCLUI_ERRCNABR('399', '2630', '[ENTRADA REJEITADA] DESCONTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('399', '2633', '[ENTRADA REJEITADA] VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('399', '2635', '[ENTRADA REJEITADA] ABATIMENTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('399', '2637', '[ENTRADA REJEITADA] CDIGO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('399', '2638', '[ENTRADA REJEITADA] PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('399', '2642', '[ENTRADA REJEITADA] CDIGO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('399', '2643', '[ENTRADA REJEITADA] PRAZO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('399', '2644', '[ENTRADA REJEITADA] CDIGO DA MOEDA INVLIDO');
   INCLUI_ERRCNABR('399', '2645', '[ENTRADA REJEITADA] NOME DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('399', '2646', '[ENTRADA REJEITADA] TIPO/NMERO DE INSCRIO DO SACADO INVLIDOS');
   INCLUI_ERRCNABR('399', '2647', '[ENTRADA REJEITADA] ENDEREO DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('399', '2648', '[ENTRADA REJEITADA] CEP INVLIDO');
   INCLUI_ERRCNABR('399', '2649', '[ENTRADA REJEITADA] CEP SEM PRAA DE COBRANA (NO LOCALIZADO)');
   INCLUI_ERRCNABR('399', '2650', '[ENTRADA REJEITADA] CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('399', '2652', '[ENTRADA REJEITADA] UNIDADE DA FEDERAO INVLIDA');
   INCLUI_ERRCNABR('399', '2657', '[ENTRADA REJEITADA] CDIGO DA MULTA INVLIDO');
   INCLUI_ERRCNABR('399', '2658', '[ENTRADA REJEITADA] DATA DA MULTA INVLIDA');
   INCLUI_ERRCNABR('399', '2659', '[ENTRADA REJEITADA] VALOR/PERCENTUAL DA MULTA INVLIDO');
   INCLUI_ERRCNABR('399', '2662', '[ENTRADA REJEITADA] TIPO DE IMPRESSO INVLIDO');
   INCLUI_ERRCNABR('399', '2663', '[ENTRADA REJEITADA] ENTRADA PARA TTULO J CADASTRADO');
   INCLUI_ERRCNABR('399', '3001', '[ENTRADA REJEITADA] CDIGO DO BANCO INVLIDO');
   INCLUI_ERRCNABR('399', '3002', '[ENTRADA REJEITADA] CDIGO DO REGISTRO DETALHE INVLIDO');
   INCLUI_ERRCNABR('399', '3003', '[ENTRADA REJEITADA] CDIGO DO SEGMENTO INVLIDO');
   INCLUI_ERRCNABR('399', '3004', '[ENTRADA REJEITADA] CDIGO DO MOVIMENTO NO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('399', '3005', '[ENTRADA REJEITADA] CDIGO DE MOVIMENTO INVLIDO');
   INCLUI_ERRCNABR('399', '3006', '[ENTRADA REJEITADA] TIPO/NMERO DE INSCRIO DO CEDENTE INVLIDOS');
   INCLUI_ERRCNABR('399', '3007', '[ENTRADA REJEITADA] CDIGO DE CONVNIO INVLIDO OU NO CADASTRADO');
   INCLUI_ERRCNABR('399', '3008', '[ENTRADA REJEITADA] NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('399', '3009', '[ENTRADA REJEITADA] NOSSO NMERO DUPLICADO');
   INCLUI_ERRCNABR('399', '3010', '[ENTRADA REJEITADA] CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('399', '3011', '[ENTRADA REJEITADA] FORMA DE CADASTRAMENTO DO TTULO INVLIDO');
   INCLUI_ERRCNABR('399', '3012', '[ENTRADA REJEITADA] TIPO DE DOCUMENTO INVLIDO');
   INCLUI_ERRCNABR('399', '3013', '[ENTRADA REJEITADA] IDENTIFICAO DA EMISSO DO BLOQUETO INVLIDA');
   INCLUI_ERRCNABR('399', '3014', '[ENTRADA REJEITADA] IDENTIFICAO DA DISTRIBUIO DO BLOQUETO INVLIDA');
   INCLUI_ERRCNABR('399', '3015', '[ENTRADA REJEITADA] CARACTERSTICAS DA COBRANA INCOMPATVEIS');
   INCLUI_ERRCNABR('399', '3016', '[ENTRADA REJEITADA] DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('399', '3020', '[ENTRADA REJEITADA] VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('399', '3021', '[ENTRADA REJEITADA] ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('399', '3023', '[ENTRADA REJEITADA] ACEITE INVLIDO');
   INCLUI_ERRCNABR('399', '3024', '[ENTRADA REJEITADA] DATA DA EMISSO INVLIDA');
   INCLUI_ERRCNABR('399', '3026', '[ENTRADA REJEITADA] CDIGO DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('399', '3027', '[ENTRADA REJEITADA] VALOR/TAXA DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('399', '3028', '[ENTRADA REJEITADA] CDIGO DO DESCONTO INVLIDO');
   INCLUI_ERRCNABR('399', '3030', '[ENTRADA REJEITADA] DESCONTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('399', '3033', '[ENTRADA REJEITADA] VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('399', '3035', '[ENTRADA REJEITADA] ABATIMENTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('399', '3037', '[ENTRADA REJEITADA] CDIGO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('399', '3038', '[ENTRADA REJEITADA] PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('399', '3042', '[ENTRADA REJEITADA] CDIGO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('399', '3043', '[ENTRADA REJEITADA] PRAZO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('399', '3044', '[ENTRADA REJEITADA] CDIGO DA MOEDA INVLIDO');
   INCLUI_ERRCNABR('399', '3045', '[ENTRADA REJEITADA] NOME DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('399', '3046', '[ENTRADA REJEITADA] TIPO/NMERO DE INSCRIO DO SACADO INVLIDOS');
   INCLUI_ERRCNABR('399', '3047', '[ENTRADA REJEITADA] ENDEREO DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('399', '3048', '[ENTRADA REJEITADA] CEP INVLIDO');
   INCLUI_ERRCNABR('399', '3049', '[ENTRADA REJEITADA] CEP SEM PRAA DE COBRANA (NO LOCALIZADO)');
   INCLUI_ERRCNABR('399', '3050', '[ENTRADA REJEITADA] CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('399', '3052', '[ENTRADA REJEITADA] UNIDADE DA FEDERAO INVLIDA');
   INCLUI_ERRCNABR('399', '3057', '[ENTRADA REJEITADA] CDIGO DA MULTA INVLIDO');
   INCLUI_ERRCNABR('399', '3058', '[ENTRADA REJEITADA] DATA DA MULTA INVLIDA');
   INCLUI_ERRCNABR('399', '3059', '[ENTRADA REJEITADA] VALOR/PERCENTUAL DA MULTA INVLIDO');
   INCLUI_ERRCNABR('399', '3062', '[ENTRADA REJEITADA] TIPO DE IMPRESSO INVLIDO');
   INCLUI_ERRCNABR('399', '3063', '[ENTRADA REJEITADA] ENTRADA PARA TTULO J CADASTRADO');
   COMMIT;
END;
/
BEGIN
-- BANCO SAFRA 422

   INCLUI_ERRCNABR('422', '001', 'MOEDA INVLIDA');
   INCLUI_ERRCNABR('422', '002', 'MOEDA INVLIDA PARA CARTEIRA');
   INCLUI_ERRCNABR('422', '003', 'CARTEIRA 3 INVLIDA PARA TIPO DE MOEDA');
   INCLUI_ERRCNABR('422', '004', 'TIPO DE IOF INVLIDO PARA COBRAA DE SEGUROS');
   INCLUI_ERRCNABR('422', '005', 'TIPO DE IOF INVLIDO PARA VALOR DE IOF(SEGUROS)');
   INCLUI_ERRCNABR('422', '006', 'VALOR DE IOF INVLIDO(SEGUROS)');
   INCLUI_ERRCNABR('422', '007', 'CEP NO CORRESPONDENDE UF');
   INCLUI_ERRCNABR('422', '008', 'VALOR JUROS MAIOR QUE 5% DO VALOR DO TTULO');
   INCLUI_ERRCNABR('422', '009', 'SEU NUMERO - NO NUMRICO PARA CHEQUE');
   INCLUI_ERRCNABR('422', '010', 'USO EXCLUSIVO NO NUMRICO PARA COBRANA EXPRESS');
   INCLUI_ERRCNABR('422', '011', 'NOSSO NMERO FORA DA CAIXA');
   INCLUI_ERRCNABR('422', '012', 'CEP DE CIDADE INEXISTENTE');
   INCLUI_ERRCNABR('422', '013', 'CEP FORA DE FAIXA DA CIDADE');
   INCLUI_ERRCNABR('422', '014', 'UF INVLIDO PARA CEP DA CIDADE');
   INCLUI_ERRCNABR('422', '015', 'CEP ZERADO');
   INCLUI_ERRCNABR('422', '016', 'CEP NO CONSTA NA TABELA SAFRA');
   INCLUI_ERRCNABR('422', '017', 'CEP NO CONSTA TABELA BCO CORRESPONDENTE');
   INCLUI_ERRCNABR('422', '018', 'DADOS DO CHEQUE NO NUMRICO');
   INCLUI_ERRCNABR('422', '019', 'PROTESTO IMPRATICVEL');
   INCLUI_ERRCNABR('422', '020', 'PRIMEIRA INSTRUO DE COBRANA INVLIDA');
   INCLUI_ERRCNABR('422', '021', 'SEGUNDA INSTRUO DE COBRANA INVLIDA');
   INCLUI_ERRCNABR('422', '022', 'SEGUNDA INSTR(10) E TERCEIRA INSTR INVLIDA');
   INCLUI_ERRCNABR('422', '023', 'TERCEIRA INTRUO DE COBRANA INVLIDA ');
   INCLUI_ERRCNABR('422', '024', 'DIGITO VERIFICADOR C1 INVLIDO');
   INCLUI_ERRCNABR('422', '025', 'DIGITO VERIFICADOR C2 INVLIDO');
   INCLUI_ERRCNABR('422', '026', 'CDIGO DE OPERAO/ OCORRNCIA INVLIDO');
   INCLUI_ERRCNABR('422', '027', 'OPERAO INVLIDA PARA O CLIENTE');
   INCLUI_ERRCNABR('422', '028', 'NOSSO NMERO NO NMERICO OU ZERADO');
   INCLUI_ERRCNABR('422', '029', 'NOSSO NMERO COM DGITO DE CONTROLE ERRADO');
   INCLUI_ERRCNABR('422', '030', 'VALOR DE ABATIMENTO NO NMERICO OU ZERADO');
   INCLUI_ERRCNABR('422', '031', 'SEU NMERO EM BRANCO');
   INCLUI_ERRCNABR('422', '032', 'CDIGO DA CARTEIRA INVLIDO');
   INCLUI_ERRCNABR('422', '033', 'DIGITO VERIFICADOR C3 INVLIDO');
   INCLUI_ERRCNABR('422', '034', 'CDIGO DO TTULO INVLIDO');
   INCLUI_ERRCNABR('422', '035', 'DATA DE MOVIMENTO INVLIDA');
   INCLUI_ERRCNABR('422', '036', 'DATA DE EMISSO');
   INCLUI_ERRCNABR('422', '037', 'DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('422', '038', 'DEPOSITRIA INVLIDA');
   INCLUI_ERRCNABR('422', '039', 'DEPOSITRIA INVLIDA PARA O CLIENTE');
   INCLUI_ERRCNABR('422', '040', 'DEPOSITRIA NO CADASTRADA NO BANCO');
   INCLUI_ERRCNABR('422', '041', 'CDIGO DE ACEITE INVLIDO');
   INCLUI_ERRCNABR('422', '042', 'ESPCIE DE TTULO INVLIDO');
   INCLUI_ERRCNABR('422', '043', 'INSTRUO DE COBRANA INVLIDA');
   INCLUI_ERRCNABR('422', '044', 'VALOR DO TTULO NO NUMRICO OU ZERADO');
   INCLUI_ERRCNABR('422', '045', 'DATA DE OPERAO');
   INCLUI_ERRCNABR('422', '046', 'VALOR DE JUROS NO NMERICO OU ZERADO');
   INCLUI_ERRCNABR('422', '047', 'DATA LIMITE PARA DESCONTO INVLIDA');
   INCLUI_ERRCNABR('422', '048', 'VALOR DO DESCONTO INVLIDO');
   INCLUI_ERRCNABR('422', '049', 'VALOR IOF NO NUMRICO OU ZERADO(SEGUROS)');
   INCLUI_ERRCNABR('422', '050', 'ABATIMENTO COM VALOR PARA OPERAO "01"(ENTRADA DE TTULO)');
   INCLUI_ERRCNABR('422', '051', 'CDIGO DE INSCRIO DO SACADO INVLIDO');
   INCLUI_ERRCNABR('422', '052', 'CDIGO DE INSCRIO / NMERO DE INSCRIO DO SACADO INVLIDO');
   INCLUI_ERRCNABR('422', '053', 'NMERO DE INSCRIO DO SACADO NO NUMRICO OU DGITO ERRADO');
   INCLUI_ERRCNABR('422', '054', 'NOME DO SACADO EM BRANCO');
   INCLUI_ERRCNABR('422', '055', 'ENDEREO DO SACADO EM BRANCO');
   INCLUI_ERRCNABR('422', '056', 'CLIENTE NO RECADASTRADO');
   INCLUI_ERRCNABR('422', '057', 'CLIENTE BLOQUEADO');
   INCLUI_ERRCNABR('422', '058', 'PROCESSO DE CARTRIO INVLIDO');
   INCLUI_ERRCNABR('422', '059', 'ESTADO DO SACADO INVLIDO');
   INCLUI_ERRCNABR('422', '060', 'CEP / ENDEREO DIVERGEM DO CORREIO');
   INCLUI_ERRCNABR('422', '061', 'INSTRUO AGENDADA PARA AGNCIA');
   INCLUI_ERRCNABR('422', '062', 'OPERAO INVLIDA PARA A CARTEIRA');
   INCLUI_ERRCNABR('422', '063', 'CDIGO NO PREVISTO');
   INCLUI_ERRCNABR('422', '064', 'TTULO INEXISTENTE(TFC)');
   INCLUI_ERRCNABR('422', '065', 'OPERAO EXISTENTE PARA O TTULO');
   INCLUI_ERRCNABR('422', '066', 'TTULO J EXISTE (TFC)');
   INCLUI_ERRCNABR('422', '067', 'DATA DE VENCIMENTO INVLIDA PARA PROTESTO');
   INCLUI_ERRCNABR('422', '068', 'CEP DO SACADO NO CONSTA NA TABELA');
   INCLUI_ERRCNABR('422', '069', 'PRAA NO ATENDIA PELO SERVIO CARTRIO');
   INCLUI_ERRCNABR('422', '070', 'AGNCIA INVLIDA');
   INCLUI_ERRCNABR('422', '071', 'CLIENTE NO CADSATRADO');
   INCLUI_ERRCNABR('422', '072', 'TTULO J EXISTE (COB)');
   INCLUI_ERRCNABR('422', '073', 'TAXA OPERAO NO NUMRICA OU ZERADA (VENDOR)');
   INCLUI_ERRCNABR('422', '074', 'TTULO FORA DA SEQNCIA');
   INCLUI_ERRCNABR('422', '075', 'TAXA DE OPERAO ZERADA (VENDOR)');
   INCLUI_ERRCNABR('422', '076', 'EQUALIZAO NO NUMRICA OU INVLIDA (VENDOR)');
   INCLUI_ERRCNABR('422', '077', 'TAXA NEGOCIADA NO NUMRICA OU ZERDA (VENDOR)');
   INCLUI_ERRCNABR('422', '078', 'TTULO INEXISTENTE (COB)');
   INCLUI_ERRCNABR('422', '079', 'OPERAO NO CONCLUDA');
   INCLUI_ERRCNABR('422', '080', 'TTULO J CADASTRADO');
   INCLUI_ERRCNABR('422', '081', 'TTULO NO DESCONTADO');
   INCLUI_ERRCNABR('422', '082', 'INTERVALO ENTRE DATA DE OPRERAO E DATA VCTO MENOR QUE UM DIA');
   INCLUI_ERRCNABR('422', '083', 'PRORROGAO / ALTERAO DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('422', '084', 'MOVIMENTO IGUAL AO CADASTRADO DE EXISTNCIA DO COB');
   INCLUI_ERRCNABR('422', '085', 'CDIGO OPERAO COM PCB INVLIDO (OPREAO INVLIDA P/ CARTEIRA)');
   INCLUI_ERRCNABR('422', '086', 'ABATIMENTO MAIOR QUE O VALOR DO TTULO');
   INCLUI_ERRCNABR('422', '087', 'ALTERAO DE CATRIO INVLIDA');
   INCLUI_ERRCNABR('422', '088', 'TTULO RECUSADO COMO GARANTIA');
   INCLUI_ERRCNABR('422', '089', 'ALTERAO DE DATA DE PROTESTO INVLIDA');
   INCLUI_ERRCNABR('422', '090', 'MODALIDADE DE VENDOR INVLIDO');
   INCLUI_ERRCNABR('422', '091', 'PCB CTO INVLIDA');
   INCLUI_ERRCNABR('422', '092', 'DATA DE OPERAO CTO INVLIDA');
   INCLUI_ERRCNABR('422', '093', 'BAIXA DE TTULO DE OUTRA AGNCIA');
   INCLUI_ERRCNABR('422', '094', 'ENTRADA TTULO COBRANA DIRETA INVLIDA');
   INCLUI_ERRCNABR('422', '095', 'BAIXA DO TTULO INVLIDO');
   INCLUI_ERRCNABR('422', '096', 'VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('422', '097', 'MOEDA INVLIDA PARA BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('422', '098', 'PCB DO TFC DIVERGEMDA PCB DO COB');
   INCLUI_ERRCNABR('422', '099', 'INCLUSO DE TERCEIRA MOEDA INVLIDA');
   COMMIT;
END;
/
BEGIN
-- Banco UNIBANCO 409

   INCLUI_ERRCNABR('409', '05', 'TIPO DE TRANSAO / CDIGO DO MOVIMENTO INVLIDO');
   INCLUI_ERRCNABR('409', '07', 'AGNCIA / CONTA E DGITO INVLIDO');
   INCLUI_ERRCNABR('409', '08', 'NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('409', '09', 'NOSSO NMERO DUPLICADO');
   INCLUI_ERRCNABR('409', '10', 'CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('409', '11', 'FORMA DE CADASTRAMENTO DO TTULO INVLIDA(CLIENTE NO  TROCA DE FITAS)');
   INCLUI_ERRCNABR('409', '12', 'TIPO DE DOCUMENTO INVLIDO');
   INCLUI_ERRCNABR('409', '13', 'IDENTIFICAO DE EMISSO DE BLOQUETO INVLIDO');
   INCLUI_ERRCNABR('409', '15', 'CARACTERSTICA COBRANA INCOMPATVEL');
   INCLUI_ERRCNABR('409', '16', 'DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('409', '18', 'VENCIMENTO FORA DO PRAZO DE OPERAO');
   INCLUI_ERRCNABR('409', '20', 'VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('409', '21', 'ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('409', '23', 'ACEITE INVLIDO');
   INCLUI_ERRCNABR('409', '24', 'DATA DA EMISSO INVLIDA');
   INCLUI_ERRCNABR('409', '26', 'CDIGO DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('409', '27', 'VALOR/TAXA JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('409', '30', 'DESCONTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('409', '32', 'VALOR DO IOF INVLIDO');
   INCLUI_ERRCNABR('409', '33', 'VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('409', '34', 'VALOR DO ABATIMENTO MAIOR OU IGUAL AO VALOR DO TTULO');
   INCLUI_ERRCNABR('409', '35', 'ABATIMENTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('409', '36', 'ABATIMENTO J CONCEDIDO');
   INCLUI_ERRCNABR('409', '37', 'CDIGO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('409', '38', 'PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('409', '39', 'PEDIDO DE PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('409', '41', 'PEDIDO DE CANCELAMENTO/SITUAO DE PROTESTO PARA TTULOS SEM INSTRUO DE PROTESTO');
   INCLUI_ERRCNABR('409', '42', 'CDIGO PARA BAIXA/DEVOLUO INVLIDA');
   INCLUI_ERRCNABR('409', '43', 'PRAZO PARA BAIXA/DEVOLUO INVLIDA ');
   INCLUI_ERRCNABR('409', '44', 'CDIGO DA MOEDA INVLIDA');
   INCLUI_ERRCNABR('409', '46', 'TIPO/NMERO DE INSCRIO INVLIDO');
   INCLUI_ERRCNABR('409', '48', 'CEP INVLIDO');
   INCLUI_ERRCNABR('409', '53', 'TIPO/NMERO DE INCRIO DO SACADOR/AVALISTA INVLIDOS');
   INCLUI_ERRCNABR('409', '57', 'CDIGO DA MULTA INVLIDO');
   INCLUI_ERRCNABR('409', '58', 'DATA DA MULTA INVLIDA');
   INCLUI_ERRCNABR('409', '60', 'MOVIMENTO PARA TTULO NO CADSTRADO');
   INCLUI_ERRCNABR('409', '61', 'AGNCIA ENCARREGADA DA COBRANA INVLIDA / BANCO DEPOSITRIO  BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('409', '99', 'OUTROS');
   COMMIT;
END;
/
BEGIN
-- Banco de Boston 479

   INCLUI_ERRCNABR('479','101','DATA DE EMISSO INVLIDA');
   INCLUI_ERRCNABR('479','102','DATA DE EMISSO MAIOR QUE A DATA DA OPERAO');
   INCLUI_ERRCNABR('479','103','DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('479','105','PRMIO LQUIDO NO NUMRICO');
   INCLUI_ERRCNABR('479','106','PRMIO LQUIDO INCOMPATVEL COM ESPCIE');
   INCLUI_ERRCNABR('479','107','PRMIO LQUIDO NO INFORMADO');
   INCLUI_ERRCNABR('479','108','IOF NO NUMRICO');
   INCLUI_ERRCNABR('479','109','IOF INCOMPATVEL COM ESPCIE');
   INCLUI_ERRCNABR('479','110','VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('479','111','ACEITE INVLIDO');
   INCLUI_ERRCNABR('479','112','ACEITE NO PERMITIDO PARA ESPCIE');
   INCLUI_ERRCNABR('479','113','VALORES DE DESCONTOS NO NUMRICOS');
   INCLUI_ERRCNABR('479','114','ORDEM DO VALORES DESCONTOS INCOMPATVEIS');
   INCLUI_ERRCNABR('479','115','DATA DE VENCIMENTO MAIOR QUE DATA NEGOC. PARA DESCONTO');
   INCLUI_ERRCNABR('479','116','PERCENTUAL NO PERMITE VALOR ABATIMENTO');
   INCLUI_ERRCNABR('479','117','PERCENTUAL EXIGE DATA LIMITE');
   INCLUI_ERRCNABR('479','118','DATA DE DESCONTO INVLIDA');
   INCLUI_ERRCNABR('479','119','DATA DE DESCONTO MAIOR QUE DATA DE VENCIMENTO');
   INCLUI_ERRCNABR('479','120','DATA DE DESCONTO MENOR QUE DATA DE NEGOCIAO');
   INCLUI_ERRCNABR('479','121','DATA DESCONTO EXIGE ALGUM VALOR OU PERCENTUAL');
   INCLUI_ERRCNABR('479','122','VALOR BASE NO PERMITE VALOR DE ABATIMENTO');
   INCLUI_ERRCNABR('479','123','VALOE BASE EXIGE VALOR PERCENTUAL');
   INCLUI_ERRCNABR('479','124','VALOR BASE EXIGE DATA LIMITE');
   INCLUI_ERRCNABR('479','125','VALOR DO DESCONTO EXIGE DATA LIMITE');
   INCLUI_ERRCNABR('479','126','VALOR DO ABATIMENTO DEVE SER MENOR QUE O VALOR DO TTULO');
   INCLUI_ERRCNABR('479','127','VALOR DO ABATIMENTO NO PERMITE PERCENTUAL E VALOR BASE');
   INCLUI_ERRCNABR('479','128','NOME DO SACADO OBRIGATRIO');
   INCLUI_ERRCNABR('479','132','NOME DO SACADO NO DEVE SER INFORMADO PARA NOTA DE SEGURO');
   INCLUI_ERRCNABR('479','134','ENDEREO DO SACADO INVLIDO');
   INCLUI_ERRCNABR('479','137','CEP DO SACADO INVLIDO');
   INCLUI_ERRCNABR('479','138','IDENTIFICADOR DE REGISTRO INVLIDO');
   INCLUI_ERRCNABR('479','139','DIAS JURO/MULTA 1 MAIOR QUE DIAS JURO/MULTA 2');
   INCLUI_ERRCNABR('479','140','DIAS JURO/MULTA 2 MAIOR QUE DIAS JURO/MULTA 3');
   INCLUI_ERRCNABR('479','145','INSTRUO NA ENTRADA DO TTULO INVLIDA');
   INCLUI_ERRCNABR('479','146','NMERO DE DIAS NA ENTRADA INVLIDO');
   INCLUI_ERRCNABR('479','147','VALOR DE ABATIMENTO ENTRADA INVLIDO');
   INCLUI_ERRCNABR('479','148','VALOR DE ABATIMENTO ENTRADA TEM QUE SER MENOR QUE VALOR TTULO');
   INCLUI_ERRCNABR('479','156','TTULO DESCONTO  VISTA OU CONTRA APRESENTAO');
   INCLUI_ERRCNABR('479','158','NO EXISTE COTAO PARA MOEDA NA DATA DE EMISSO');
   INCLUI_ERRCNABR('479','159','DGITO DO NOSSO NMERO NO CONFERE');
   INCLUI_ERRCNABR('479','160','INTRUO INVLIDA - TTULO COM INSTRUO PROTESTAR');
   INCLUI_ERRCNABR('479','166','CEP NO PERTENCE AO BOSTON');
   INCLUI_ERRCNABR('479','181','MOEDA OU FATOR INVLIDO');
   INCLUI_ERRCNABR('479','187','CORR N/ TRAB C/ MOEDA FATOR OU CONTA N/ CAD CORRESPONDENTE');
   INCLUI_ERRCNABR('479','200','NOSSO NMERO NO RESERVADO PARA COBRANA RPIDA');
   INCLUI_ERRCNABR('479','202','CEP NO CADASTRADO');
   INCLUI_ERRCNABR('479','204','DATA DE NEGOCIAO NO  DIA TIL');
   INCLUI_ERRCNABR('479','205','ESPCIE TTULO PARA DESCONTO FUNC. ALTERADO PARA NP');
   INCLUI_ERRCNABR('479','207','TAXA DE DESCONTO INFORMADA PARA BORDER DE COBRANA/CAUO');
   INCLUI_ERRCNABR('479','208','CONTRATO NO LIGADO  CLIENTE');
   INCLUI_ERRCNABR('479','209','CONTRATO NO PERTENCE AO CLIENTE BORDER');
   INCLUI_ERRCNABR('479','210','TIPO DE BEM(FINANCIADO) NO CADASTRADO');
   INCLUI_ERRCNABR('479','213','NO FOI POSSVEL ENCONTRAR AG COBRADORA');
   INCLUI_ERRCNABR('479','214','NO EXISTE ESTADO-MUNICIPIO PARA O CEP');
   INCLUI_ERRCNABR('479','300','CDIGO DE MOVIMENTO INVLIDO');
   INCLUI_ERRCNABR('479','301','NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('479','302','VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('479','303','DESCONTO/ABATIMENTO INVLIDO ');
   INCLUI_ERRCNABR('479','304','OUTRAS REDUES INVLIDA');
   INCLUI_ERRCNABR('479','305','LIQUIDAO / BAIXA / INSTRUO INIBIDA');
   INCLUI_ERRCNABR('479','306','RESSARCIMENTO INVLIDO');
   INCLUI_ERRCNABR('479','307','VALOR LQUIDO INVLIDO');
   INCLUI_ERRCNABR('479','308','JUROS / MULTA INVLIDO');
   INCLUI_ERRCNABR('479','309','OUTROS ACRSCIMOS INVLIDO');
   INCLUI_ERRCNABR('479','310','CDIGO DE MOVIMENTO DIFERENTE DE 0407');
   INCLUI_ERRCNABR('479','311','SEU NMERO OBRIGATRIO');
   INCLUI_ERRCNABR('479','312','INSTRUO VIA FITA INVLIDA');
   INCLUI_ERRCNABR('479','313','VALOR DA INSTRUO INVLIDO');
   INCLUI_ERRCNABR('479','314','DATA DE VENCIMENTO INSTRUO INVLIDA');
   INCLUI_ERRCNABR('479','315','SEU NMERO DA ISNTRUO OBRIGATRIO');
   INCLUI_ERRCNABR('479','316','USO DA EMPRESA OBRIGATRIO');
   INCLUI_ERRCNABR('479','317','CLCULO DGITO MDULO 11 NO REALIZADO');
   INCLUI_ERRCNABR('479','318','BAIXA / LIQUIDAO DE TTULO INEXISTENTE');
   INCLUI_ERRCNABR('479','319','INSTRUO PARA TTULO INEXISTENTE');
   INCLUI_ERRCNABR('479','321','INSTRUO PRORROGAO DE VENCTO. P/ TTULO LIQUIDADO');
   INCLUI_ERRCNABR('479','322','TTULO J CADASTRADO');
   INCLUI_ERRCNABR('479','324','INSTRUO PRORROGAO DE VENCTO. P/ TTULO BAIXADO');
   INCLUI_ERRCNABR('479','325','INSTRUO PRORROGAO DE VENCTO. P/ TTULO PROTESTADO');
   INCLUI_ERRCNABR('479','326','INSTRUO PRORROGAO DE VENCTO. P/ TTULO EM CARTRIO');
   INCLUI_ERRCNABR('479','332','VALOR DESCONTO/ABATIMENTO NO CONFERE COM O SISTEMA');
   INCLUI_ERRCNABR('479','333','BAIXA CRDITO DIRETO NO PERMITIDO PARA DESCONTO');
   INCLUI_ERRCNABR('479','334','INSTRUO NO PERMITIDA PARA BATCH-USE ONLINE');
   INCLUI_ERRCNABR('479','335','DESCONTO/ABATIMENTO NO PERMITINDO PARA LIQ. PARCIAL');
   INCLUI_ERRCNABR('479','336','JUROS/MULTA NO PERMITIDO P/ LIQUIDAO PARCIAL');
   INCLUI_ERRCNABR('479','338','INSTRUO NO ACATADA');
   INCLUI_ERRCNABR('479','340','VALOR LQUIDO DIFERE DP PAGAMENTO PARCIAL');
   INCLUI_ERRCNABR('479','341','TTULO NO EST EM CARTRIO');
   INCLUI_ERRCNABR('479','342','TTULO EST EM CARTRIO');
   INCLUI_ERRCNABR('479','343','TTULO J LIQUIDADO');
   INCLUI_ERRCNABR('479','344','TTULO J LIQUIDADO NESTE MOVIMENTO');
   INCLUI_ERRCNABR('479','345','CDIGO DE AVALISTA (1 OU 2) NO NUMRICO');
   INCLUI_ERRCNABR('479','346','AVALISTA NO EXISTE COMO CLIENTE');
   INCLUI_ERRCNABR('479','347','AVALISTA NO CADASTRADO COMO CLIENTE');
   INCLUI_ERRCNABR('479','352','VALOR DO TTULO INFORMADO NO BATE COM SALDO DEVEDOR');
   INCLUI_ERRCNABR('479','355','VERIFICAR DATA DE VENCIMENTO/TAXA TT. S/ CRED. CED.');
   INCLUI_ERRCNABR('479','356','MOME DO SACADO CONTEM CARACTER INVLIDO');
   INCLUI_ERRCNABR('479','357','ENTARDA TTULO FITA/MICRO P/ CEP NO BKB');
   INCLUI_ERRCNABR('479','358','PRODUTO NO EXISTE NO CORRESPONDENTE');
   INCLUI_ERRCNABR('479','360','FILIAL NO CADASTRADA P/ CORRESPONDENTE INFORMADO');
   INCLUI_ERRCNABR('479','361','TTULO NO PERTENCE AP CONVNIO INFORMADO');
   INCLUI_ERRCNABR('479','366','DATA DE EMISSO MAIOR QUE A DATA DE VENCIMENTO');
   COMMIT;
END;
/

BEGIN
-- Banco Brasil 001

   INCLUI_ERRCNABR('001','01','CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('001','02','CODIGO DO REGISTRO DETALHE INVALIDO');
   INCLUI_ERRCNABR('001','03','CODIGO DO SEGMENTO INVALIDO');
   INCLUI_ERRCNABR('001','04','CODIGO DO MOVIMENTO NAO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('001','05','CODIGO DE MOVIMENTO INVALIDO.');
   INCLUI_ERRCNABR('001','06','TIPO/NUMERO DE INSCRICAO DO CEDENTE INVALIDOS');
   INCLUI_ERRCNABR('001','07','AGENCIA/CONTA/DV INVALIDO.');
   INCLUI_ERRCNABR('001','08','NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('001','09','NOSSO NUMERO DUPLICADO');
   INCLUI_ERRCNABR('001','10','CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('001','11','FORMA DE CADASTRAMENTO DO TITULO INVALIDO');
   INCLUI_ERRCNABR('001','12','TIPO DE DOCUMENTO INVALIDO');
   INCLUI_ERRCNABR('001','13','IDENTIFICACAO DA EMISSAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('001','14','IDENTIFICACAO DA DISTRIBUICAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('001','15','CARACTERISTICAS DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('001','16','DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('001','17','DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('001','18','VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('001','19','TITULO A CARGO DE BANCOS CORRESPONDENTES COM VENCIMENTO INFERIOR XX DIAS');
   INCLUI_ERRCNABR('001','20','VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('001','21','ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('001','22','ESPECIE NAO PERMITIDA PARA A CARTEIRA.');
   INCLUI_ERRCNABR('001','23','ACEITE INVALIDO');
   INCLUI_ERRCNABR('001','24','DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('001','25','DATA DA EMISSAO POSTERIOR A DATA');
   INCLUI_ERRCNABR('001','26','CODIGO DE JUROS DE MORA INVALIDO.');
   INCLUI_ERRCNABR('001','27','VALOR/TAXA DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('001','28','CODIGO DO DESCONTO INVALIDO');
   INCLUI_ERRCNABR('001','29','VALOR DO DESCONTO MAIOR OU IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('001','30','DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('001','31','CONCESSAO DE DESCONTO - JA EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('001','32','VALOR DO IOF INVALIDO');
   INCLUI_ERRCNABR('001','33','VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('001','34','VALOR DO ABATIMENTO MAIOR OU IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('001','35','ABATIMENTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('001','36','CONCESSAO DE ABATIMENTO - JA EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('001','37','CODIGO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('001','38','PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('001','39','PEDIDO DE PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('001','40','TITULO COM ORDEM DE PROTESTO EMITIDA');
   INCLUI_ERRCNABR('001','41','PEDIDO DE CANCELAMENTO/SUSTACAO PARA TITULOS SEM INSTRUCAO DE PROTESTO');
   INCLUI_ERRCNABR('001','42','CODIGO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('001','43','PRAZO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('001','44','CODIGO DA MOEDA INVALIDO');
   INCLUI_ERRCNABR('001','45','NOME DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('001','46','TIPO/NUMERO DE INSCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('001','47','ENDERECO DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('001','48','CEP INVALIDO');
   INCLUI_ERRCNABR('001','49','CEP SEM PRACA DE COBRANCA /NAO LOCALIZADO');
   INCLUI_ERRCNABR('001','50','CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('001','51','CEP INCOMPATIVEL COM A UNIDADE DA FEDERACCAO');
   INCLUI_ERRCNABR('001','52','UNIDADE DA FEDERACAO INVALIDA');
   INCLUI_ERRCNABR('001','53','TIPO/NUMERO DE INSCRICAO DO SACADOR/AVALISTA INVALIDOS');
   INCLUI_ERRCNABR('001','54','SACADOR/AVALISTA NAO INFORMADO');
   INCLUI_ERRCNABR('001','55','NOSSO NUMERO NO BANCO CORRESPONDENTE NAO INFORMADO');
   INCLUI_ERRCNABR('001','56','CODIGO DO BANCO CORRESPONDENTE NAO INFORMADO');
   INCLUI_ERRCNABR('001','57','CODIGO DA MULTA INVALIDO');
   INCLUI_ERRCNABR('001','58','DATA DA MULTA INVALIDA.');
   INCLUI_ERRCNABR('001','59','VALOR/PERCENTUAL DA MULTA INVALIDO');
   INCLUI_ERRCNABR('001','60','MOVIMENTO PARA TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('001','61','ALTERACAO DA AGENCIA COBRADORA/DV INVALIDA');
   INCLUI_ERRCNABR('001','62','TIPO DE IMPRESSAO INVALIDO');
   INCLUI_ERRCNABR('001','63','ENTRADA PARA TITULO JA CADASTRADO');
   INCLUI_ERRCNABR('001','64','NUMERO DA LINHA INVALIDO');
   INCLUI_ERRCNABR('001','65','CODIGO DO BANCO PARA DEBITO INVALIDO');
   INCLUI_ERRCNABR('001','66','AGENCIA/CONTA/DV PARA DEBITO INVALIDO');
   INCLUI_ERRCNABR('001','67','DADOS PARA DEBITO INCOMPATIVEL COM A IDENTIFICACAO DA EMISSAO DO BLOQUETO');
   INCLUI_ERRCNABR('001','88','ARQUIVO EM DUPLICIDADE');
   INCLUI_ERRCNABR('001','99','CONTRATO INEXISTENTE');
   COMMIT;
END;
/

BEGIN
-- Banco Mercantil 389

   INCLUI_ERRCNABR('389','01','CDIGO CLIENTE INVLIDO');
   INCLUI_ERRCNABR('389','02','NOSSO NMERO INVLIDO OU FAIXA INVLIDA');
   INCLUI_ERRCNABR('389','03','CGC/CPF DO CEDENTE INVLIDO');
   INCLUI_ERRCNABR('389','04','QUANTIDADE DE MOEDA INVLIDO');
   INCLUI_ERRCNABR('389','05','CDIGO DA OPERAO INVLIDO OU DIVERGE DO CONTRATO');
   INCLUI_ERRCNABR('389','06','CDIGO DO MOVIMENTO INVLIDO');
   INCLUI_ERRCNABR('389','07','DATA VENCIMENTO INVLIDO');
   INCLUI_ERRCNABR('389','08','VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('389','09','CDIGO DE ESPCIE INVLIDO');
   INCLUI_ERRCNABR('389','10','DATA DE EMISSO INVLIDA OU MAIOR QUE MOVIMENTO');
   INCLUI_ERRCNABR('389','11','INSTRUO INVLIDA');
   INCLUI_ERRCNABR('389','12','JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('389','13','DESCONTO AT INVLIDO, MAIOR VENCIMENTO OU MENOR EMISSO');
   INCLUI_ERRCNABR('389','14','VALOR DESCONTO INVLIDO OU MAIOR QUE VALOR DO TTULO');
   INCLUI_ERRCNABR('389','15','VALOR IOF INVLIDO OU MAIOR QUE VALOR DO TTULO');
   INCLUI_ERRCNABR('389','16','VALOR DO ABATIMENTO INVLIDO OU MAIOR QUE VALOR DO TTULO');
   INCLUI_ERRCNABR('389','17','NOME DO SACADO INVLIDO');
   INCLUI_ERRCNABR('389','18','ENDEREO DO SACADO INVLIDO');
   INCLUI_ERRCNABR('389','19','CEP NO CONTIDO NA TABELA');
   INCLUI_ERRCNABR('389','20','CDIGO DA MOEDA INVLIDO');
   INCLUI_ERRCNABR('389','21','SEU NMERO INVLIDO');
   INCLUI_ERRCNABR('389','22','J EXISTE NO CADASTRO DE TTULO');
   INCLUI_ERRCNABR('389','23','TTULO J BAIXADO');
   INCLUI_ERRCNABR('389','24','CDIGO MOEDA INVLIDO PARA DATA EMISSO');
   INCLUI_ERRCNABR('389','25','REJEITADO PELO GERENTE');
   INCLUI_ERRCNABR('389','40','AGNCIA/CONTRATO/CGC INVLIDO');
   INCLUI_ERRCNABR('389','41','TIPO DE FORMULRIO DO CONTRATO INVLIDO');
   INCLUI_ERRCNABR('389','42','CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('389','43','REGISTRO DO SACADO INVLIDO');
   INCLUI_ERRCNABR('389','44','NMERO PARCELA CARN INVLIDO');
   INCLUI_ERRCNABR('389','45','INTERVALO CARN INVLIDO');
   INCLUI_ERRCNABR('389','46','ERRO CPF/CGC INVLIDO DO SACADO (CARN)');
   INCLUI_ERRCNABR('389','47','ERRO QTDE. ALUNOS INFORMADOS');
   INCLUI_ERRCNABR('389','48','NOME DO SCIO DEVE SER INFORMADO');
   INCLUI_ERRCNABR('389','49','NMERO DO SCIO NO PODE SER ZEROS');
   INCLUI_ERRCNABR('389','50','CEP INVLIDO');
   INCLUI_ERRCNABR('389','51','NMERO DO DOCUMENTO INVLIDO');
   COMMIT;
END;
/

BEGIN
-- Banco Nossa Caixa 151

   INCLUI_ERRCNABR('151','01','CDIGO BANCO INVLIDO');
   INCLUI_ERRCNABR('151','02','CDIGO DO REGISTRO DETALHE INVLIDO');
   INCLUI_ERRCNABR('151','03','CDIGO SEGMENTO INVLIDO');
   INCLUI_ERRCNABR('151','04','CDIGO MOVIMENTO NO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('151','05','CDIGO MOVIMENTO INVLIDO');
   INCLUI_ERRCNABR('151','06','AGNCIA/CONTA/DV INVLIDO');
   INCLUI_ERRCNABR('151','07','NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('151','08','NOSSO NMERO DUPLICADO');
   INCLUI_ERRCNABR('151','09','CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('151','12','IDENTIFICAO DA EMISSO DO BLOQUETE INVLIDA');
   INCLUI_ERRCNABR('151','14','CARACTERSTICAS DA COBRANA INCOMPATVEIS');
   INCLUI_ERRCNABR('151','15','DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('151','16','DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSO');
   INCLUI_ERRCNABR('151','17','TTULO A CARGO DE BANCOS CORRESPONDENTES COM VENCIMENTO INFERIOR A 2 DIAS');
   INCLUI_ERRCNABR('151','18','VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('151','19','ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('151','20','ESPCIE NO PERMITIDA PARA A CARTEIRA');
   INCLUI_ERRCNABR('151','21','ACEITE INVLIDO');
   INCLUI_ERRCNABR('151','22','DATA EMISSO INVLIDA');
   INCLUI_ERRCNABR('151','23','DATA EMISSO POSTERIOR A DATA DE ENTRADA');
   INCLUI_ERRCNABR('151','24','CDIGO JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('151','25','VALOR/TAXA DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('151','26','CDIGO DESCONTO INVLIDO');
   INCLUI_ERRCNABR('151','27','VALOR DO DESCONTO MAIOR OU IGUAL AO VALOR DO TTULO');
   INCLUI_ERRCNABR('151','28','DATA DESCONTO INVLIDA');
   INCLUI_ERRCNABR('151','32','PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('151','33','PEDIDO DE PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('151','34','PEDIDO DE CANCELAMENTO/SUSTAO POR TTULO SEM INSTRUO DE PROTESTO');
   INCLUI_ERRCNABR('151','37','CDIGO DA MOEDA INVLIDO');
   INCLUI_ERRCNABR('151','38','NOME DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('151','39','ENDEREO DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('151','40','CEP INVLIDO');
   INCLUI_ERRCNABR('151','41','CEP SEM PRAA DE COBRANA (NO LOCALIZADO)');
   INCLUI_ERRCNABR('151','42','CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('151','43','CEP INCOMPATVEL COM A UNIDADE DA FEDERAO');
   INCLUI_ERRCNABR('151','44','UNIDADE DA FEDERAO INVLIDA');
   INCLUI_ERRCNABR('151','45','SACADOR/AVALISTA NO INFORMADO');
   INCLUI_ERRCNABR('151','50','TAXA DE MULTA INVLIDA');
   INCLUI_ERRCNABR('151','51','MOVIMENTO PARA TTULO NO CADASTRADO');
   INCLUI_ERRCNABR('151','53','ENTRADA PARA TTULO J CADASTRADO');
   INCLUI_ERRCNABR('151','54','CONTA MOVIMENTO INEXISTENTE/INVLIDA');
   INCLUI_ERRCNABR('151','55','PERCENTUAL CONTA MOVIMENTO INVLIDO');
   INCLUI_ERRCNABR('151','56','CPF/CNPJ DO SACADO INVLIDO');
   INCLUI_ERRCNABR('151','57','DATA DE VENCIMENTO FORA DE PARMETRO');
   INCLUI_ERRCNABR('151','58','PRAZO DE PROTESTO FORA DO LIMITE');
   INCLUI_ERRCNABR('151','59','EXCLUSO PARA TTULO EM CARTRIO');
   INCLUI_ERRCNABR('151','60','EXCLUSO PARA TTULO LIQUIDADO OU EXCLUDO');
   INCLUI_ERRCNABR('151','61','BANDA MAGNTICA INVLIDA');
   INCLUI_ERRCNABR('151','63','AUSNCIA DE "SEU NMERO"');
   INCLUI_ERRCNABR('151','84','BAIXA DE TTULO A PEDIDO/AUTOMTICA');
   INCLUI_ERRCNABR('151','85','TARIFA DE LIQUIDAO DE TTULO');
   INCLUI_ERRCNABR('151','86','TARIFA DE EMISSO DE BLOQUETES DA COBRANA DIRETA');
   INCLUI_ERRCNABR('151','87','TARIFA DE CUSTDIA DE TTULOS');
   INCLUI_ERRCNABR('151','88','TARIFA DE ENTRADA DE TTULOS');
   INCLUI_ERRCNABR('151','89','TARIFA DE EXTRATO DE POSIO');
   INCLUI_ERRCNABR('151','90','TARIFA DE MANUTENO DE TTULO VENCIDO');
   INCLUI_ERRCNABR('151','91','TARIFA DE SUSTAO');
   INCLUI_ERRCNABR('151','92','TARIFA DE PROTESTO');
   INCLUI_ERRCNABR('151','93','TARIFA DE OUTRAS INSTRUO');
   INCLUI_ERRCNABR('151','94','TARIFA DE OUTRAS OCORRNCIAS');
   INCLUI_ERRCNABR('151','96','CUSTAS DE PROTESTO');
   INCLUI_ERRCNABR('151','97','CUSTAS DE SUSTAO DO PROTESTO');
   INCLUI_ERRCNABR('151','98','CUSTAS DE CARTRIO DISTRIBUIDOR');
   INCLUI_ERRCNABR('151','99','CUSTAS DO EDITAL');
   COMMIT;
END;
/

BEGIN
-- Banco Real 275

   INCLUI_ERRCNABR('275','01','CDIGO DO BANCO INVLIDO');
   INCLUI_ERRCNABR('275','02','CDIGO DO REGISTRO DETALHE INVLIDO');
   INCLUI_ERRCNABR('275','03','CDIGO DO SEGMENTO INVLIDO');
   INCLUI_ERRCNABR('275','04','CDIGO DE MOVIMENTO NO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('275','05','CDIGO DE MOVIMENTO INVLIDO');
   INCLUI_ERRCNABR('275','06','TIPO/NMERO DE INSCRIO DO CEDENTE INVLIDOS');
   INCLUI_ERRCNABR('275','07','AGNCIA/CONTA/DV INVLIDO');
   INCLUI_ERRCNABR('275','08','NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('275','09','NOSSO NMERO DUPLICADO');
   INCLUI_ERRCNABR('275','10','CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('275','11','FORMA DE CADASTRAMENTO DO TTULO INVLIDO');
   INCLUI_ERRCNABR('275','12','TIPO DE DOCUMENTO INVLIDO');
   INCLUI_ERRCNABR('275','13','IDENTIFICAO DA EMISSO DO BLOQUETO INVLIDA');
   INCLUI_ERRCNABR('275','14','IDENTIFICAO DA DISTRIBUIO DO BLOQUETO INVLIDA');
   INCLUI_ERRCNABR('275','15','CARACTERSTICAS DA COBRANA INCOMPATVEIS');
   INCLUI_ERRCNABR('275','16','DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('275','17','DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSO');
   INCLUI_ERRCNABR('275','18','VENCIMENTO FORA DO PRAZO DE OPERAO');
   INCLUI_ERRCNABR('275','19','TTULO A CARGO DE BANCOS CORRESPONDENTES COM VENCIMENTO INFERIOR A XX DIAS');
   INCLUI_ERRCNABR('275','20','VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('275','21','ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('275','22','ESPCIE DO TTULO NO PERMITIDA PARA A CARTEIRA');
   INCLUI_ERRCNABR('275','23','ACEITE INVLIDO');
   INCLUI_ERRCNABR('275','24','DATA DA EMISSO INVLIDA');
   INCLUI_ERRCNABR('275','25','DATA DA EMISSO POSTERIOR A DATA DE ENTRADA');
   INCLUI_ERRCNABR('275','26','CDIGO DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('275','27','VALOR/TAXA DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('275','28','CDIGO DO DESCONTO INVLIDO');
   INCLUI_ERRCNABR('275','29','VALOR DO DESCONTO MAIOR OU IGUAL AO VALOR DO TTULO');
   INCLUI_ERRCNABR('275','30','DESCONTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('275','31','CONCESSO DE DESCONTO - J EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('275','32','VALOR DO IOF INVLIDO');
   INCLUI_ERRCNABR('275','33','VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('275','34','VALOR DO ABATIMENTO MAIOR OU IGUAL AO VALOR DO TTULO');
   INCLUI_ERRCNABR('275','35','VALOR A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('275','36','CONCESSO DE ABATIMENTO - J EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('275','37','CDIGO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('275','38','PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('275','39','PEDIDO DE PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('275','40','TTULO COM ORDEM DE PROTESTO EMITIDA');
   INCLUI_ERRCNABR('275','41','PEDIDO DE CANCELAMENTO/SUSTAO PARA TTULOS SEM INSTRUO DE PROTESTO');
   INCLUI_ERRCNABR('275','42','CDIGO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('275','43','PRAZO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('275','44','CDIGO DA MOEDA INVLIDO ');
   INCLUI_ERRCNABR('275','45','NOME DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('275','46','TIPO/NMERO DE INSCRIO DO SACADO INVLIDOS');
   INCLUI_ERRCNABR('275','47','ENDEREO DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('275','48','CEP INVLIDO');
   INCLUI_ERRCNABR('275','49','CEP SEM PRAA DE COBRANA (NO LOCALIZADO)');
   INCLUI_ERRCNABR('275','50','CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('275','51','CEP INCOMPATVEL COM A UNIDADE DA FEDERAO');
   INCLUI_ERRCNABR('275','52','UNIDADE DA FEDERAO INVLIDA');
   INCLUI_ERRCNABR('275','53','TIPO/NMERO DE INSCRIO DO SACADOR/AVALISTA INVLIDOS');
   INCLUI_ERRCNABR('275','54','SACADOR/AVALISTA NO INFORMADO');
   INCLUI_ERRCNABR('275','55','NOSSO NMERO NO BANCO CORRESPONDENTE NO INFORMADO');
   INCLUI_ERRCNABR('275','56','CDIGO DO BANCO CORRESPONDENTE NO INFORMADO');
   INCLUI_ERRCNABR('275','57','CDIGO DA MULTA INVLIDO');
   INCLUI_ERRCNABR('275','58','DATA DA MULTA INVLIDA');
   INCLUI_ERRCNABR('275','59','VALOR/PERCENTUAL DA MULTA INVLIDO');
   INCLUI_ERRCNABR('275','60','MOVIMENTO PARA TTULO NO CADASTRADO');
   INCLUI_ERRCNABR('275','61','ALTERAO DA AGNCIA COBRADORA/DV INVLIDA');
   INCLUI_ERRCNABR('275','62','TIPO DE IMPRESSO INVLIDO');
   INCLUI_ERRCNABR('275','63','ENTRADA PARA TTULO J CADASTRADO');
   INCLUI_ERRCNABR('275','64','NMERO DA LINHA INVLIDO');
   INCLUI_ERRCNABR('275','65','CDIGO DO BANCO PARA DBITO INVLIDO');
   INCLUI_ERRCNABR('275','66','AGNCIA/CONTA/DV PARA DBITO INVLIDO');
   INCLUI_ERRCNABR('275','67','DADOS PARA DBITO INCOMPATVEL COM A IDENTIFICAO DA EMISSO DO BLOQUETO');
   INCLUI_ERRCNABR('275','68','DBITO AUTOMTICO AGENDADO');
   INCLUI_ERRCNABR('275','69','DBITO NO AGENDADO - ERRO NOS DADOS DA REMESSA');
   INCLUI_ERRCNABR('275','70','DBITO NO AGENDADO - SACADO NO CONSTA DO CADASTRO DE AUTORIZANTE');
   INCLUI_ERRCNABR('275','71','DBITO NO AGENDADO - CEDENTE NO AUTORIZADO PELO SACADO ');
   INCLUI_ERRCNABR('275','72','DBITO NO AGENDADO - CEDENTE NO PARTICIPA DA MODALIDADE DBITO AUTOMTICO');
   INCLUI_ERRCNABR('275','73','DBITO NO AGENDADO - CDIGO DE MOEDA DIFERENTE DE REAL (R$)');
   INCLUI_ERRCNABR('275','74','DBITO NO AGENDADO - DATA VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('275','75','DBITO NO AGENDADO, CONFORME SEU PEDIDO, TTULO NO REGISTRADO');
   INCLUI_ERRCNABR('275','76','DBITO NO AGENDADO, TIPO/NUM. INSCRIO DO DEBITADO, INVLIDO');
   INCLUI_ERRCNABR('275','77','TRANSFERNCIA PARA DESCONTO NO PERMITIDA PARA A CARTEIRA DO TTULO');
   INCLUI_ERRCNABR('275','78','DATA INFERIOR OU IGUAL AO VENCIMENTO PARA DBITO AUTOMTICO');
   INCLUI_ERRCNABR('275','79','DATA JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('275','80','DATA DO DESCONTO INVLIDA');
   INCLUI_ERRCNABR('275','81','TENTATIVAS DE DBITO ESGOTADAS - BAIXADO');
   INCLUI_ERRCNABR('275','82','TENTATIVAS DE DBITO ESGOTADAS - PENDENTE');
   INCLUI_ERRCNABR('275','83','LIMITE EXCEDIDO');
   INCLUI_ERRCNABR('275','84','NMERO AUTORIZAO INEXISTENTE');
   INCLUI_ERRCNABR('275','85','TTULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('275','86','SEU NMERO INVLIDO');
   COMMIT;
END;
/

BEGIN
-- Banco Real 356

   INCLUI_ERRCNABR('356','01','CDIGO DO BANCO INVLIDO');
   INCLUI_ERRCNABR('356','02','CDIGO DO REGISTRO DETALHE INVLIDO');
   INCLUI_ERRCNABR('356','03','CDIGO DO SEGMENTO INVLIDO');
   INCLUI_ERRCNABR('356','04','CDIGO DE MOVIMENTO NO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('356','05','CDIGO DE MOVIMENTO INVLIDO');
   INCLUI_ERRCNABR('356','06','TIPO/NMERO DE INSCRIO DO CEDENTE INVLIDOS');
   INCLUI_ERRCNABR('356','07','AGNCIA/CONTA/DV INVLIDO');
   INCLUI_ERRCNABR('356','08','NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('356','09','NOSSO NMERO DUPLICADO');
   INCLUI_ERRCNABR('356','10','CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('356','11','FORMA DE CADASTRAMENTO DO TTULO INVLIDO');
   INCLUI_ERRCNABR('356','12','TIPO DE DOCUMENTO INVLIDO');
   INCLUI_ERRCNABR('356','13','IDENTIFICAO DA EMISSO DO BLOQUETO INVLIDA');
   INCLUI_ERRCNABR('356','14','IDENTIFICAO DA DISTRIBUIO DO BLOQUETO INVLIDA');
   INCLUI_ERRCNABR('356','15','CARACTERSTICAS DA COBRANA INCOMPATVEIS');
   INCLUI_ERRCNABR('356','16','DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('356','17','DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSO');
   INCLUI_ERRCNABR('356','18','VENCIMENTO FORA DO PRAZO DE OPERAO');
   INCLUI_ERRCNABR('356','19','TTULO A CARGO DE BANCOS CORRESPONDENTES COM VENCIMENTO INFERIOR A XX DIAS');
   INCLUI_ERRCNABR('356','20','VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('356','21','ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('356','22','ESPCIE DO TTULO NO PERMITIDA PARA A CARTEIRA');
   INCLUI_ERRCNABR('356','23','ACEITE INVLIDO');
   INCLUI_ERRCNABR('356','24','DATA DA EMISSO INVLIDA');
   INCLUI_ERRCNABR('356','25','DATA DA EMISSO POSTERIOR A DATA DE ENTRADA');
   INCLUI_ERRCNABR('356','26','CDIGO DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('356','27','VALOR/TAXA DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('356','28','CDIGO DO DESCONTO INVLIDO');
   INCLUI_ERRCNABR('356','29','VALOR DO DESCONTO MAIOR OU IGUAL AO VALOR DO TTULO');
   INCLUI_ERRCNABR('356','30','DESCONTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('356','31','CONCESSO DE DESCONTO - J EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('356','32','VALOR DO IOF INVLIDO');
   INCLUI_ERRCNABR('356','33','VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('356','34','VALOR DO ABATIMENTO MAIOR OU IGUAL AO VALOR DO TTULO');
   INCLUI_ERRCNABR('356','35','VALOR A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('356','36','CONCESSO DE ABATIMENTO - J EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('356','37','CDIGO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('356','38','PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('356','39','PEDIDO DE PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('356','40','TTULO COM ORDEM DE PROTESTO EMITIDA');
   INCLUI_ERRCNABR('356','41','PEDIDO DE CANCELAMENTO/SUSTAO PARA TTULOS SEM INSTRUO DE PROTESTO');
   INCLUI_ERRCNABR('356','42','CDIGO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('356','43','PRAZO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('356','44','CDIGO DA MOEDA INVLIDO ');
   INCLUI_ERRCNABR('356','45','NOME DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('356','46','TIPO/NMERO DE INSCRIO DO SACADO INVLIDOS');
   INCLUI_ERRCNABR('356','47','ENDEREO DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('356','48','CEP INVLIDO');
   INCLUI_ERRCNABR('356','49','CEP SEM PRAA DE COBRANA (NO LOCALIZADO)');
   INCLUI_ERRCNABR('356','50','CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('356','51','CEP INCOMPATVEL COM A UNIDADE DA FEDERAO');
   INCLUI_ERRCNABR('356','52','UNIDADE DA FEDERAO INVLIDA');
   INCLUI_ERRCNABR('356','53','TIPO/NMERO DE INSCRIO DO SACADOR/AVALISTA INVLIDOS');
   INCLUI_ERRCNABR('356','54','SACADOR/AVALISTA NO INFORMADO');
   INCLUI_ERRCNABR('356','55','NOSSO NMERO NO BANCO CORRESPONDENTE NO INFORMADO');
   INCLUI_ERRCNABR('356','56','CDIGO DO BANCO CORRESPONDENTE NO INFORMADO');
   INCLUI_ERRCNABR('356','57','CDIGO DA MULTA INVLIDO');
   INCLUI_ERRCNABR('356','58','DATA DA MULTA INVLIDA');
   INCLUI_ERRCNABR('356','59','VALOR/PERCENTUAL DA MULTA INVLIDO');
   INCLUI_ERRCNABR('356','60','MOVIMENTO PARA TTULO NO CADASTRADO');
   INCLUI_ERRCNABR('356','61','ALTERAO DA AGNCIA COBRADORA/DV INVLIDA');
   INCLUI_ERRCNABR('356','62','TIPO DE IMPRESSO INVLIDO');
   INCLUI_ERRCNABR('356','63','ENTRADA PARA TTULO J CADASTRADO');
   INCLUI_ERRCNABR('356','64','NMERO DA LINHA INVLIDO');
   INCLUI_ERRCNABR('356','65','CDIGO DO BANCO PARA DBITO INVLIDO');
   INCLUI_ERRCNABR('356','66','AGNCIA/CONTA/DV PARA DBITO INVLIDO');
   INCLUI_ERRCNABR('356','67','DADOS PARA DBITO INCOMPATVEL COM A IDENTIFICAO DA EMISSO DO BLOQUETO');
   INCLUI_ERRCNABR('356','68','DBITO AUTOMTICO AGENDADO');
   INCLUI_ERRCNABR('356','69','DBITO NO AGENDADO - ERRO NOS DADOS DA REMESSA');
   INCLUI_ERRCNABR('356','70','DBITO NO AGENDADO - SACADO NO CONSTA DO CADASTRO DE AUTORIZANTE');
   INCLUI_ERRCNABR('356','71','DBITO NO AGENDADO - CEDENTE NO AUTORIZADO PELO SACADO ');
   INCLUI_ERRCNABR('356','72','DBITO NO AGENDADO - CEDENTE NO PARTICIPA DA MODALIDADE DBITO AUTOMTICO');
   INCLUI_ERRCNABR('356','73','DBITO NO AGENDADO - CDIGO DE MOEDA DIFERENTE DE REAL (R$)');
   INCLUI_ERRCNABR('356','74','DBITO NO AGENDADO - DATA VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('356','75','DBITO NO AGENDADO, CONFORME SEU PEDIDO, TTULO NO REGISTRADO');
   INCLUI_ERRCNABR('356','76','DBITO NO AGENDADO, TIPO/NUM. INSCRIO DO DEBITADO, INVLIDO');
   INCLUI_ERRCNABR('356','77','TRANSFERNCIA PARA DESCONTO NO PERMITIDA PARA A CARTEIRA DO TTULO');
   INCLUI_ERRCNABR('356','78','DATA INFERIOR OU IGUAL AO VENCIMENTO PARA DBITO AUTOMTICO');
   INCLUI_ERRCNABR('356','79','DATA JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('356','80','DATA DO DESCONTO INVLIDA');
   INCLUI_ERRCNABR('356','81','TENTATIVAS DE DBITO ESGOTADAS - BAIXADO');
   INCLUI_ERRCNABR('356','82','TENTATIVAS DE DBITO ESGOTADAS - PENDENTE');
   INCLUI_ERRCNABR('356','83','LIMITE EXCEDIDO');
   INCLUI_ERRCNABR('356','84','NMERO AUTORIZAO INEXISTENTE');
   INCLUI_ERRCNABR('356','85','TTULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('356','86','SEU NMERO INVLIDO');
   COMMIT;
END;
/

BEGIN
-- Banco Banestes 021

   INCLUI_ERRCNABR('021','01','CDIGO DO BANCO INVLIDO');
   INCLUI_ERRCNABR('021','02','CDIGO DO REGISTRO DETALHE INVLIDO');
   INCLUI_ERRCNABR('021','03','CDIGO DO SEGMENTO INVLIDO');
   INCLUI_ERRCNABR('021','04','CDIGO DE MOVIMENTO NO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('021','05','CDIGO DE MOVIMENTO INVLIDO');
   INCLUI_ERRCNABR('021','06','TIPO/NMERO DE INSCRIO DO CEDENTE INVLIDOS');
   INCLUI_ERRCNABR('021','07','AGNCIA/CONTA/DV INVLIDO');
   INCLUI_ERRCNABR('021','08','NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('021','09','NOSSO NMERO DUPLICADO');
   INCLUI_ERRCNABR('021','10','CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('021','11','FORMA DE CADASTRAMENTO DO TTULO INVLIDO');
   INCLUI_ERRCNABR('021','12','TIPO DE DOCUMENTO INVLIDO');
   INCLUI_ERRCNABR('021','13','IDENTIFICAO DA EMISSO DO BLOQUETO INVLIDA');
   INCLUI_ERRCNABR('021','14','IDENTIFICAO DA DISTRIBUIO (POSTAGEM) DO BLOQUETO INVLIDA');
   INCLUI_ERRCNABR('021','15','CARACTERSTICAS DA COBRANA INCOMPATVEIS');
   INCLUI_ERRCNABR('021','16','DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('021','17','DATA DE VENCIMENTO ANTERIOR ADATA DE EMISSO ');
   INCLUI_ERRCNABR('021','18','VENCIMENTO FORA DO PRAZO DE OPERAO');
   INCLUI_ERRCNABR('021','19','TTULO A CARGO DE BANCOS CORRESPONDENTES COM VENCIMENTO INFERIOR A XX DIAS');
   INCLUI_ERRCNABR('021','20','VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('021','21','ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('021','22','ESPCIE DO TTULO NO PERMITIDA PARA A CARTEIRA');
   INCLUI_ERRCNABR('021','23','ACEITE INVLIDO');
   INCLUI_ERRCNABR('021','24','DATA DA EMISSO INVLIDA');
   INCLUI_ERRCNABR('021','25','DATA DA EMISSO POSTERIOR A DATA DE ENTRADA');
   INCLUI_ERRCNABR('021','26','CDIGO DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('021','27','VALOR/TAXA DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('021','28','CDIGO DO DESCONTO INVLIDO');
   INCLUI_ERRCNABR('021','29','VALOR DO DESCONTO MAIOR OU IGUAL AO VALOR DO TTULO');
   INCLUI_ERRCNABR('021','30','DESCONTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('021','31','CONCESSO DE DESCONTO - J EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('021','32','VALOR DO IOF INVLIDO');
   INCLUI_ERRCNABR('021','33','VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('021','34','VALOR DO ABATIMENTO MAIOR OU IGUAL AO VALOR DO TTULO');
   INCLUI_ERRCNABR('021','35','VALOR A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('021','36','CONCESSO DE ABATIMENTO - J EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('021','37','CDIGO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('021','38','PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('021','39','PEDIDO DE PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('021','40','TTULO COM ORDEM DE PROTESTO EMITIDA');
   INCLUI_ERRCNABR('021','41','PEDIDO DE CANCELAMENTO / SUSTAO PARA TTULOS SEM INSTRUO DE PROTESTO');
   INCLUI_ERRCNABR('021','42','CDIGO PARA BAIXA / DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('021','43','PRAZO PARA BAIXA / DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('021','44','CDIGO DA MOEDA INVLIDO');
   INCLUI_ERRCNABR('021','45','NOME DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('021','46','TIPO / NMERO DE INSCRIO DO SACADO INVLIDOS');
   INCLUI_ERRCNABR('021','47','ENDEREO DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('021','48','CEP INVLIDO');
   INCLUI_ERRCNABR('021','49','CEP SEM PRAA DE COBRANA (NO LOCALIZADO)');
   INCLUI_ERRCNABR('021','50','CEP REFERENTE A UM BANCOCORRESPONDENTE');
   INCLUI_ERRCNABR('021','51','CEP INCOMPATVEL COM A UNIDADE DA FEDERAO');
   INCLUI_ERRCNABR('021','52','UNIDADE DA FEDERAO INVLIDA');
   INCLUI_ERRCNABR('021','53','TIPO / NMERO DE INSCRIO DO SACADOR / AVALISTA INVLIDOS');
   INCLUI_ERRCNABR('021','54','SACADOR / AVALISTA NO INFORMADO');
   INCLUI_ERRCNABR('021','55','NOSSO NMERO NO BANCO CORRESPONDENTE NO INFORMADO');
   INCLUI_ERRCNABR('021','56','CDIGO DO BANCO CORRESPONDENTE NO INFORMADO');
   INCLUI_ERRCNABR('021','57','CDIGO DA MULTA INVLIDO');
   INCLUI_ERRCNABR('021','58','DATA DA MULTA INVLIDA');
   INCLUI_ERRCNABR('021','59','VALOR / PERCENTUAL DA MULTA INVLIDO');
   INCLUI_ERRCNABR('021','60','MOVIMENTO PARA TTULO NO CADASTRADO');
   INCLUI_ERRCNABR('021','61','ALTERAO DA AGNCIA COBRADORA / DV INVLIDA');
   INCLUI_ERRCNABR('021','62','TIPO DE IMPRESSO INVLIDO');
   INCLUI_ERRCNABR('021','63','ENTRADA PARA TTULO J CADASTRADO');
   INCLUI_ERRCNABR('021','64','NMERO DA LINHA INVLIDO');
   INCLUI_ERRCNABR('021','65','CDIGO DO BANCO PARA DBITO INVLIDO');
   INCLUI_ERRCNABR('021','66','AGNCIA / CONTA / DV PARA DBITO INVLIDO');
   INCLUI_ERRCNABR('021','67','DADOS PARA DBITO INCOMPATVEL COM A IDENTIFICAO DA EMISSO DO BLOQUETO');
   INCLUI_ERRCNABR('021','68','DBITO AUTOMTICO AGENDADO');
   INCLUI_ERRCNABR('021','69','DBITO NO AGENDADO - ERRO NOS DADOS DA REMESSA');
   INCLUI_ERRCNABR('021','70','DBITO NO AGENDADO - SACADO NO CONSTA DO CADASTRO DE AUTORIZANTE');
   INCLUI_ERRCNABR('021','71','DBITO NO SGENDADO - CEDENTE NO AUTORIZADO PELO SACADO');
   INCLUI_ERRCNABR('021','72','DBITO NO AGENDADO - CEDENTE NO PARTICIPA DA MODALIDADE DBITO AUTOMTICO');
   INCLUI_ERRCNABR('021','73','DBITO NO AGENDADO - CDIGO DE MOEDA DIFERENTE DE REAL (R$)');
   INCLUI_ERRCNABR('021','74','DBITO NO AGENDADO - DATA VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('021','75','DBITO NO AGENDADO, CONFORME SEU PEDIDO, TTULO NO REGISTRADO');
   INCLUI_ERRCNABR('021','76','DBITO NO AGENDADO, TIPO / NUM. INSCRIO DO DEBITADO, INVLIDO');
   INCLUI_ERRCNABR('021','77','TRANSFERNCIA PARA DESCONTO NO PERMITIDA PARA A CARTEIRA DO TTULO');
   INCLUI_ERRCNABR('021','78','DATA INFERIOR OU IGUAL AO VENCIMENTO PARA DBITO AUTOMTICO');
   INCLUI_ERRCNABR('021','79','DATA DO JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('021','80','DATA DO DESCONTO INVLIDA');
   INCLUI_ERRCNABR('021','81','TENTATIVAS DE DBITO ESGOTADAS - BAIXADO');
   INCLUI_ERRCNABR('021','82','TENTATIVAS DE DBITO ESGOTADAS - PENDENTE');
   INCLUI_ERRCNABR('021','83','LIMITE EXCEDIDO');
   INCLUI_ERRCNABR('021','84','NMERO AUTORIZAO INEXISTENTE');
   INCLUI_ERRCNABR('021','85','TTULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('021','86','SEU NMERO INVLIDO');
   INCLUI_ERRCNABR('021','98','ERRO NA FORMAO DO CARN');
   INCLUI_ERRCNABR('021','0199','[REMESSA REJEITADA] REMESSA EM DUPLICIDADE');
   INCLUI_ERRCNABR('021','0299','[REMESSA REJEITADA] ERRO NA SEQNCIA DO REGISTRO');
   INCLUI_ERRCNABR('021','0399','[REMESSA REJEITADA] CDIGO DO BANCO INVLIDO');
   INCLUI_ERRCNABR('021','0499','[REMESSA REJEITADA] CEDENTE NO CADASTRADO');
   INCLUI_ERRCNABR('021','0599','[REMESSA REJEITADA] REGISTRO NO  "HEADER"');
   INCLUI_ERRCNABR('021','0699','[REMESSA REJEITADA] ARQUIVO NO  REMESSA');
   INCLUI_ERRCNABR('021','0799','[REMESSA REJEITADA] SERVIO NO  COBRANA');
   INCLUI_ERRCNABR('021','0899','[REMESSA REJEITADA] CONTA CORRENTE DIFERENTE DO REGISTRO "HEADER"');
   INCLUI_ERRCNABR('021','0999','[REMESSA REJEITADA] CDIGO DE OCORRNCIA INVLIDO');
   INCLUI_ERRCNABR('021','1099','[REMESSA REJEITADA] ERRO NA SEQNCIA DO LOTE');
   INCLUI_ERRCNABR('021','1199','[REMESSA REJEITADA] NMERO DO LOTE DO REGISTRO "DETALHES"DIFERE DO REGISTRO DE "HEADER"');
   INCLUI_ERRCNABR('021','1299','[REMESSA REJEITADA] FALTA REGISTRO DE "TRAILLER" DO ARQUIVO');
   INCLUI_ERRCNABR('021','1399','[REMESSA REJEITADA] NMERO DO LOTE DO REGISTRO "TRAILLER" DIFERE DO REGISTRO DE "HEADER"');
   INCLUI_ERRCNABR('021','1499','[REMESSA REJEITADA] ERRO NA QUANTIDADE DE REGISTRO DO LOTE');
   INCLUI_ERRCNABR('021','1599','[REMESSA REJEITADA] NMERO DO LOTE DO REGISTRO "TRAILLER" INVLIDO');
   INCLUI_ERRCNABR('021','1699','[REMESSA REJEITADA] ERRO NA QUANTIDADE DE LOTES DO ARQUIVO');
   INCLUI_ERRCNABR('021','1799','[REMESSA REJEITADA] CDIGO DO SEGMENTO FORA DE ORDEM');
   INCLUI_ERRCNABR('021','1899','[REMESSA REJEITADA] CDIGO DO REGISTRO FORA DE ORDEM');
   INCLUI_ERRCNABR('021','1999','[REMESSA REJEITADA] CDIGO DO REGISTRO INVLIDO');
   INCLUI_ERRCNABR('021','9999','[REMESSA REJEITADA] OUTROS MOTIVOS');
   COMMIT;
END;
/

BEGIN
--Banco Caixa Econmica Federal
  INCLUI_ERRCNABR('104','01','CDIGO DO BANCO INVLIDO');
  INCLUI_ERRCNABR('104','02','CODIGO DO REGISTRO DETALHE INVALIDO');
  INCLUI_ERRCNABR('104','03','CODIGO DO SEGMENTO INVALIDO');
  INCLUI_ERRCNABR('104','05','CODIGO DE MOVIMENTO INVALIDO.');
  INCLUI_ERRCNABR('104','06','TIPO/NMERO DE INSCRIO DO CEDENTE INVLIDOS.');
  INCLUI_ERRCNABR('104','07','AGNCIA/CONTA/DV INVALIDO.');
  INCLUI_ERRCNABR('104','08','NOSSO NMERO INVLIDO.');
  INCLUI_ERRCNABR('104','09','NOSSO NMERO DUPLICADO.');
  INCLUI_ERRCNABR('104','10','CARTEIRA INVLIDA.');
  INCLUI_ERRCNABR('104','11','FORMA DE CADASTRAMENTO DO TTULO INVLIDO.');
  INCLUI_ERRCNABR('104','12','TIPO DE DOCUMENTO INVLIDO.');
  INCLUI_ERRCNABR('104','13','IDENTIFICAO DA EMISSO DO BLOQUETO INVLIDA.');
  INCLUI_ERRCNABR('104','14','IDENTIFICAO DA DISTRIBUIO DO BLOQUETO INVLIDA.');
  INCLUI_ERRCNABR('104','15','CARACTERSTICAS DE COBRANA INCOMPATVEIS.');
  INCLUI_ERRCNABR('104','16','DATA DE VENCIMENTO INVLIDA.');
  INCLUI_ERRCNABR('104','20','VALOR DO TTULO INVLID0.');
  INCLUI_ERRCNABR('104','21','ESPCIE DE TTULO INVLIDA.');
  INCLUI_ERRCNABR('104','23','ACEITE INVLIDO.');
  INCLUI_ERRCNABR('104','24','DATA DE EMISSO INVLIDA.');
  INCLUI_ERRCNABR('104','26','CDIGO DE JUROS DE MORA INVLIDO.');
  INCLUI_ERRCNABR('104','27','VALOR/TAXA DE JUROS DE MORA INVLIDO.');
  INCLUI_ERRCNABR('104','28','CDIGO DE DESCONTO INVLIDO.');
  INCLUI_ERRCNABR('104','29','VALOR DE DESCONTO MAIOR OU IGUAL AO VALOR DO TTULO.');
  INCLUI_ERRCNABR('104','30','DESCONTO A CONCEDER NO CONFERE.');
  INCLUI_ERRCNABR('104','32','VALOR DO IOF INVLIDO.');
  INCLUI_ERRCNABR('104','33','VALOR DO ABATIMENTO INVLIDO.');
  INCLUI_ERRCNABR('104','37','CDIGO PARA PROTESTO INVLIDO.');
  INCLUI_ERRCNABR('104','38','PRAZO PARA PROTESTO INVLIDO.');
  INCLUI_ERRCNABR('104','40','TTULO COM ORDEM DE PROTESTO EMITIDA.');
  INCLUI_ERRCNABR('104','42','CDIGO PARA BAIXA/DEVOLUO INVLIDO.');
  INCLUI_ERRCNABR('104','43','PRAZO PARA BAIXA/DEVOLUO INVLIDO.');
  INCLUI_ERRCNABR('104','44','CDIGO DA MOEDA INVLIDO.');
  INCLUI_ERRCNABR('104','45','NOME DO SACADO NO INFORMADO.');
  INCLUI_ERRCNABR('104','46','TIPO/NMERO DE INSCRIO DO SACADO INVLIDOS.');
  INCLUI_ERRCNABR('104','47','ENDEREO DO SACADO NO INFORMADO.');
  INCLUI_ERRCNABR('104','48','CEP INVLIDO.');
  INCLUI_ERRCNABR('104','49','CEP SEM PRAA DE COBRANA (NO LOCALIZADO).');
  INCLUI_ERRCNABR('104','52','UNIDADE DA FEDERAO INVLIDA.');
  INCLUI_ERRCNABR('104','53','TIPO/NMERO DE INSCRIO DO SACADOR/AVALISTA INVLIDOS.');
  INCLUI_ERRCNABR('104','57','CDIGO DA MULTA INVLIDO.');
  INCLUI_ERRCNABR('104','58','DATA DA MULTA INVLIDA.');
  INCLUI_ERRCNABR('104','59','VALOR/PERCENTUAL DA MULTA INVLIDO.');
  INCLUI_ERRCNABR('104','60','MOVIMENTO PARA TTULO NO CADASTRADO.');
  INCLUI_ERRCNABR('104','61','AGNCIA COBRADORA INVLIDA.');
  INCLUI_ERRCNABR('104','62','TIPO DE IMPRESSO INVLIDO.');
  INCLUI_ERRCNABR('104','63','ENTRADA PARA TTULO J CADASTRADO.');
  INCLUI_ERRCNABR('104','68','MOVIMENTAO INVLIDA PARA O TTULO.');
  INCLUI_ERRCNABR('104','69','ALTERAO DE DADOS INVLIDA.');
  INCLUI_ERRCNABR('104','70','APELIDO DO CLIENTE NO CADASTRADO.');
  INCLUI_ERRCNABR('104','71','ERRO NA COMPOSIO DO ARQUIVO.');
  INCLUI_ERRCNABR('104','72','LOTE DE SERVIO INVLIDO.');
  INCLUI_ERRCNABR('104','73','CDIGO DO CEDENTE INVLIDO.');
  INCLUI_ERRCNABR('104','74','CEDENTE NO PERTENCE A COBRANA  ELETRNICA/APELIDO NO CONFERE COM CEDENTE.');
  INCLUI_ERRCNABR('104','75','NOME DA EMPRESA INVLIDO.');
  INCLUI_ERRCNABR('104','76','NOME DO BANCO INVLIDO.');
  INCLUI_ERRCNABR('104','77','CDIGO DA REMESSA INVLIDO.');
  INCLUI_ERRCNABR('104','78','DATA/HORA DA GERAO DO ARQUIVO INVLIDA.');
  INCLUI_ERRCNABR('104','79','NMERO SEQUENCIAL DO ARQUIVO INVLIDO.');
  INCLUI_ERRCNABR('104','80','NMERO DA VERSO DO LAYOUT DO ARQUIVO/LOTE INVLIDO.');
  INCLUI_ERRCNABR('104','81','LITERAL REMESSA-TESTE VLIDA SOMENTE PARA FASE DE TESTES.');
  INCLUI_ERRCNABR('104','82','LITERAL REMESSA-TESTE OBRIGATRIO PARA FASE DE TESTES.');
  INCLUI_ERRCNABR('104','83','TIPO/NMERO DA INSCRIO DA EMPRESA INVLIDOS.');
  INCLUI_ERRCNABR('104','84','TIPO DE OPERAO INVLIDO.');
  INCLUI_ERRCNABR('104','85','TIPO DE SERVIO INVLIDO.');
  INCLUI_ERRCNABR('104','86','FORMA DE LANAMENTO INVLIDO.');
  INCLUI_ERRCNABR('104','87','NMERO DA REMESSA INVLIDO.');
  INCLUI_ERRCNABR('104','88','NMERO DA REMESSA MENOR/IGUAL QUE DA REMESSA ANTERIOR.');
  INCLUI_ERRCNABR('104','89','LOTE DE SERVIO DIVERGENTE.');
  INCLUI_ERRCNABR('104','90','NMERO SEQUENCIAL DO REGISTRO INVLIDO.');
  INCLUI_ERRCNABR('104','91','ERRO NA SEQUENCIAL DO SEGMENTO DO REGISTRO DETALHE.');
  INCLUI_ERRCNABR('104','92','CDIGO DE MOVIMENTO DIVERGENTE ENTRE GRUPO DE SEGMENTOS INVLIDO.');
  COMMIT;
END;
/
BEGIN
-- BANCO PORTUGUES 069
   INCLUI_ERRCNABR('069', '001', 'Cdigo do Banco invlido');
   INCLUI_ERRCNABR('069', '002', 'Cdigo do registro detalhe invlido');
   INCLUI_ERRCNABR('069', '004', 'Cdigo de ocorrncia no permitido para a carteira');
   INCLUI_ERRCNABR('069', '005', 'Cdigo de ocorrncia no numrico');
   INCLUI_ERRCNABR('069', '007', 'Agncia/Conta/dgito invlidos');
   INCLUI_ERRCNABR('069', '008', 'Nosso nmero invlido');
   INCLUI_ERRCNABR('069', '009', 'Banco Agncia Conta beneficirio no numrico');
   INCLUI_ERRCNABR('069', '010', 'Carteira invlida');
   INCLUI_ERRCNABR('069', '015', 'Caractersticas da cobrana incompatveis');
   INCLUI_ERRCNABR('069', '016', 'Data de vencimento invlida');
   INCLUI_ERRCNABR('069', '017', 'Data de vencimento anterior a data de emisso');
   INCLUI_ERRCNABR('069', '018', 'Vencimento fora do prazo de operao');
   INCLUI_ERRCNABR('069', '020', 'Valor do ttulo invlido');
   INCLUI_ERRCNABR('069', '021', 'Espcie do Ttulo invlida');
   INCLUI_ERRCNABR('069', '022', 'Espcie no permitida para a carteira');
   INCLUI_ERRCNABR('069', '024', 'Data de emisso invlida');
   INCLUI_ERRCNABR('069', '028', 'Cdigo de desconto via TeleBpn invlido');
   INCLUI_ERRCNABR('069', '029', 'Valor do desconto maior/igual ao valor do Ttulo');
   INCLUI_ERRCNABR('069', '030', 'Desconto a conceder no confere');
   INCLUI_ERRCNABR('069', '031', 'Concesso de desconto - J existe desconto anterior');
   INCLUI_ERRCNABR('069', '033', 'Valor do abatimento invlido');
   INCLUI_ERRCNABR('069', '034', 'Valor do abatimento maior/igual ao valor do Ttulo');
   INCLUI_ERRCNABR('069', '036', 'Concesso abatimento - J existe abatimento anterior');
   INCLUI_ERRCNABR('069', '038', 'Prazo para protesto invlido');
   INCLUI_ERRCNABR('069', '039', 'Pedido de protesto no permitido para o Ttulo');
   INCLUI_ERRCNABR('069', '040', 'Ttulo com ordem de protesto emitido');
   INCLUI_ERRCNABR('069', '041', 'Pedido cancelamento/sustao para Ttulo sem instruo de protesto');
   INCLUI_ERRCNABR('069', '042', 'Cdigo para baixa/devoluo invlido');
   INCLUI_ERRCNABR('069', '045', 'Nome do Sacado no informado');
   INCLUI_ERRCNABR('069', '046', 'Tipo/nmero de inscrio do Sacado invlidos');
   INCLUI_ERRCNABR('069', '047', 'Endereo do Sacado no informado');
   INCLUI_ERRCNABR('069', '048', 'CEP Invlido');
   INCLUI_ERRCNABR('069', '050', 'CEP referente a um Banco correspondente');
   INCLUI_ERRCNABR('069', '053', 'Tipo de inscrio do sacador avalista invlidos');
   INCLUI_ERRCNABR('069', '060', 'Movimento para Ttulo no cadastrado');
   INCLUI_ERRCNABR('069', '077', 'Transferncia para desconto no permitido para a carteira');
   INCLUI_ERRCNABR('069', '085', 'Ttulo com pagamento vinculado');
   INCLUI_ERRCNABR('069', '086', 'Seu nmero invlido');
   COMMIT;
END;
/
BEGIN
-- BANCO BANRISUL 041
   INCLUI_ERRCNABR('041', '01', 'Cdigo do Banco invlido');
   INCLUI_ERRCNABR('041', '02', 'Cdigo de registro detalhe invlido');
   INCLUI_ERRCNABR('041', '03', 'Cdigo do Segmento invlido');
   INCLUI_ERRCNABR('041', '04', 'Cdigo do movimento no permitido para a carteira');
   INCLUI_ERRCNABR('041', '05', 'Cdigo do movimento invlido');
   INCLUI_ERRCNABR('041', '06', 'Tipo/Nmero de inscrio do cedente invlido ');
   INCLUI_ERRCNABR('041', '07', 'Agncia/conta/DV invlido');
   INCLUI_ERRCNABR('041', '08', 'Nosso Nmero invlido');
   INCLUI_ERRCNABR('041', '09', 'Nosso nmero duplicado');
   INCLUI_ERRCNABR('041', '10', 'Carteira invlida');
   INCLUI_ERRCNABR('041', '11', 'Forma de cadastramento do ttulo invlido');
   INCLUI_ERRCNABR('041', '12', 'Tipo de documento invlido');
   INCLUI_ERRCNABR('041', '13', 'Identificao da emisso do bloqueto invlido');
   INCLUI_ERRCNABR('041', '14', 'Identificao da distribuio do bloqueto invlido');
   INCLUI_ERRCNABR('041', '15', 'Caractersticas da cobrana incompatveis - carteira/moeda:');
   INCLUI_ERRCNABR('041', '16', 'Data de vencimento invlida:');
   INCLUI_ERRCNABR('041', '17', 'Data de vencimento anterior a data de emisso');
   INCLUI_ERRCNABR('041', '18', 'Vencimento fora do prazo de operao');
   INCLUI_ERRCNABR('041', '19', 'Ttulo a cargo de Bancos Correspondentes com vencimento inferior a XX dias');
   INCLUI_ERRCNABR('041', '20', 'Valor do ttulo invlido (no numrico)');
   INCLUI_ERRCNABR('041', '21', 'Espcie do ttulo invlida (arquivo de registro)');
   INCLUI_ERRCNABR('041', '22', 'Espcie no permetida para a carteira');
   INCLUI_ERRCNABR('041', '23', 'Aceite invlido - verifica contedo vlido');
   INCLUI_ERRCNABR('041', '24', 'Data de emisso invlida - verifica se a data  numrica e se est no formato vlido');
   INCLUI_ERRCNABR('041', '25', 'Data de emisso posterior a data de processamento');
   INCLUI_ERRCNABR('041', '26', 'Cdigo de juros de mora invlido');
   INCLUI_ERRCNABR('041', '27', 'Valor/taxa de juros de mora invlido');
   INCLUI_ERRCNABR('041', '28', 'Cdigo do desconto invlido');
   INCLUI_ERRCNABR('041', '29', 'Valor do desconto maior ou igual ao valor do ttulo');
   INCLUI_ERRCNABR('041', '30', 'Desconto a conceder no confere:');
   INCLUI_ERRCNABR('041', '32', 'Valor do IOF invlido');
   INCLUI_ERRCNABR('041', '33', 'Valor do abatimento invlido');
   INCLUI_ERRCNABR('041', '34', 'Valor do abatimento maior ou igual ao valor do ttulo');
   INCLUI_ERRCNABR('041', '35', 'Abatimento a conceder no confere');
   INCLUI_ERRCNABR('041', '36', 'Concesso de abatimento - j existe abatimento anterior');
   INCLUI_ERRCNABR('041', '37', 'Cdigo para protesto invlido - rejeita o ttulo se o campo for diferente de branco, 0, 1 ou 3');
   INCLUI_ERRCNABR('041', '38', 'Prazo para protesto invlido - se o cdigo for 1 verifica se o campo  numrico');
   INCLUI_ERRCNABR('041', '39', 'Pedido de protesto no permitido para o ttulo - no permite protesto para as carteiras R, S e N');
   INCLUI_ERRCNABR('041', '40', 'Ttulo com ordem de protesto emitida (para retorno de alterao)');
   INCLUI_ERRCNABR('041', '41', 'Pedido de cancelamento/sustao de protesto invlido');
   INCLUI_ERRCNABR('041', '42', 'Cdigo para baixa/devoluo ou instruo invlido - verifica se o cdigo  branco, 0, 1 ou 2');
   INCLUI_ERRCNABR('041', '43', 'Prazo para baixa/devoluo invlido - se o cdigo  1 verifica se o campo prazo  numrico');
   INCLUI_ERRCNABR('041', '44', 'Cdigo da moeda invlido');
   INCLUI_ERRCNABR('041', '45', 'Nome do sacado invlido ou alterao do sacado no permitida');
   INCLUI_ERRCNABR('041', '46', 'Tipo/nmero de inscrio do sacado invlido');
   INCLUI_ERRCNABR('041', '47', 'Endereo no informado ou alterao de endereo no permitida');
   INCLUI_ERRCNABR('041', '48', 'CEP invlido ou alterao de CEP no permitida');
   INCLUI_ERRCNABR('041', '49', 'CEP sem praa de cobrana ou alterao de cidade no permitida');
   INCLUI_ERRCNABR('041', '50', 'CEP referente a um Banco Correspondente');
   INCLUI_ERRCNABR('041', '51', 'CEP incompatvel com a unidade da federao');
   INCLUI_ERRCNABR('041', '52', 'Unidade de Federao invlida ou alterao de UF no permitida');
   INCLUI_ERRCNABR('041', '53', 'Tipo/Nmero de inscrio do Sacador/Avalista invlido');
   INCLUI_ERRCNABR('041', '54', 'Sacador/Avalista no informado - para espcie AD o nome do Sacador  obrigatrio');
   INCLUI_ERRCNABR('041', '57', 'Cdigo da multa invlido');
   INCLUI_ERRCNABR('041', '58', 'Data da multa invlida');
   INCLUI_ERRCNABR('041', '59', 'Valor/percentual da multa invlido');
   INCLUI_ERRCNABR('041', '60', 'Movimento para ttulo no cadastrado - alterao ou devoluo');
   INCLUI_ERRCNABR('041', '62', 'Tipo de impresso invlido - Segmento 3S ');
   INCLUI_ERRCNABR('041', '63', 'Entrada para ttulo j cadastrado');
   INCLUI_ERRCNABR('041', '79', 'Data de juros de mora invlido - valida data ou prazo na instruo de juros');
   INCLUI_ERRCNABR('041', '80', 'Data do desconto invlida - valida data ou prazo da instruo de desconto');
   INCLUI_ERRCNABR('041', '86', 'Seu nmero invlido (para retorno de alterao)');
   COMMIT;
END;
/
BEGIN
-- BANCO SANTANDER 033

   INCLUI_ERRCNABR('033','01','CDIGO DO BANCO INVLIDO');
   INCLUI_ERRCNABR('033','02','CDIGO DO REGISTRO DETALHE INVLIDO');
   INCLUI_ERRCNABR('033','03','CDIGO DO SEGMENTO INVLIDO');
   INCLUI_ERRCNABR('033','04','CDIGO DE MOVIMENTO NO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('033','05','CDIGO DE MOVIMENTO INVLIDO');
   INCLUI_ERRCNABR('033','06','TIPO/NMERO DE INSCRIO DO CEDENTE INVLIDOS');
   INCLUI_ERRCNABR('033','07','AGNCIA/CONTA/DV INVLIDO');
   INCLUI_ERRCNABR('033','08','NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('033','09','NOSSO NMERO DUPLICADO');
   INCLUI_ERRCNABR('033','10','CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('033','11','FORMA DE CADASTRAMENTO DO TTULO INVLIDO');
   INCLUI_ERRCNABR('033','12','TIPO DE DOCUMENTO INVLIDO');
   INCLUI_ERRCNABR('033','13','IDENTIFICAO DA EMISSO DO BLOQUETO INVLIDA');
   INCLUI_ERRCNABR('033','14','IDENTIFICAO DA DISTRIBUIO DO BLOQUETO INVLIDA');
   INCLUI_ERRCNABR('033','15','CARACTERSTICAS DA COBRANA INCOMPATVEIS');
   INCLUI_ERRCNABR('033','16','DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('033','17','DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSO');
   INCLUI_ERRCNABR('033','18','VENCIMENTO FORA DO PRAZO DE OPERAO');
   INCLUI_ERRCNABR('033','19','TTULO A CARGO DE BANCOS CORRESPONDENTES COM VENCIMENTO INFERIOR A XX DIAS');
   INCLUI_ERRCNABR('033','20','VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('033','21','ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('033','22','ESPCIE DO TTULO NO PERMITIDA PARA A CARTEIRA');
   INCLUI_ERRCNABR('033','23','ACEITE INVLIDO');
   INCLUI_ERRCNABR('033','24','DATA DA EMISSO INVLIDA');
   INCLUI_ERRCNABR('033','25','DATA DA EMISSO POSTERIOR A DATA DE ENTRADA');
   INCLUI_ERRCNABR('033','26','CDIGO DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('033','27','VALOR/TAXA DE JUROS DE MORA INVLIDO');
   INCLUI_ERRCNABR('033','28','CDIGO DO DESCONTO INVLIDO');
   INCLUI_ERRCNABR('033','29','VALOR DO DESCONTO MAIOR OU IGUAL AO VALOR DO TTULO');
   INCLUI_ERRCNABR('033','30','DESCONTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('033','31','CONCESSO DE DESCONTO - J EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('033','32','VALOR DO IOF INVLIDO');
   INCLUI_ERRCNABR('033','33','VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('033','34','VALOR DO ABATIMENTO MAIOR OU IGUAL AO VALOR DO TTULO');
   INCLUI_ERRCNABR('033','35','VALOR A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('033','36','CONCESSO DE ABATIMENTO - J EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('033','37','CDIGO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('033','38','PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('033','39','PEDIDO DE PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('033','40','TTULO COM ORDEM DE PROTESTO EMITIDA');
   INCLUI_ERRCNABR('033','41','PEDIDO DE CANCELAMENTO/SUSTAO PARA TTULOS SEM INSTRUO DE PROTESTO');
   INCLUI_ERRCNABR('033','42','CDIGO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('033','43','PRAZO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('033','44','CDIGO DA MOEDA INVLIDO ');
   INCLUI_ERRCNABR('033','45','NOME DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('033','46','TIPO/NMERO DE INSCRIO DO SACADO INVLIDOS');
   INCLUI_ERRCNABR('033','47','ENDEREO DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('033','48','CEP INVLIDO');
   INCLUI_ERRCNABR('033','49','CEP SEM PRAA DE COBRANA (NO LOCALIZADO)');
   INCLUI_ERRCNABR('033','50','CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('033','51','CEP INCOMPATVEL COM A UNIDADE DA FEDERAO');
   INCLUI_ERRCNABR('033','52','UNIDADE DA FEDERAO INVLIDA');
   INCLUI_ERRCNABR('033','53','TIPO/NMERO DE INSCRIO DO SACADOR/AVALISTA INVLIDOS');
   INCLUI_ERRCNABR('033','54','SACADOR/AVALISTA NO INFORMADO');
   INCLUI_ERRCNABR('033','55','NOSSO NMERO NO BANCO CORRESPONDENTE NO INFORMADO');
   INCLUI_ERRCNABR('033','56','CDIGO DO BANCO CORRESPONDENTE NO INFORMADO');
   INCLUI_ERRCNABR('033','57','CDIGO DA MULTA INVLIDO');
   INCLUI_ERRCNABR('033','58','DATA DA MULTA INVLIDA');
   INCLUI_ERRCNABR('033','59','VALOR/PERCENTUAL DA MULTA INVLIDO');
   INCLUI_ERRCNABR('033','60','MOVIMENTO PARA TTULO NO CADASTRADO');
   INCLUI_ERRCNABR('033','61','ALTERAO DA AGNCIA COBRADORA/DV INVLIDA');
   INCLUI_ERRCNABR('033','62','TIPO DE IMPRESSO INVLIDO');
   INCLUI_ERRCNABR('033','63','ENTRADA PARA TTULO J CADASTRADO');
   INCLUI_ERRCNABR('033','64','NMERO DA LINHA INVLIDO');
   INCLUI_ERRCNABR('033','A4','SACADO DDA');
   COMMIT;
END;
/
BEGIN
-- BANCO SOFISA
   INCLUI_ERRCNABR('637', '03', 'CEP invlido  No temos cobrador  Cobrador no Localizado');
   INCLUI_ERRCNABR('637', '04', 'Sigla do Estado invlida');
   INCLUI_ERRCNABR('637', '05', 'Data de Vencimento invlida ou fora do prazo mnimo');
   INCLUI_ERRCNABR('637', '06', 'Cdigo do Banco invlido');
   INCLUI_ERRCNABR('637', '08', 'Nome do sacado no informado');
   INCLUI_ERRCNABR('637', '10', 'Logradouro no informado');
   INCLUI_ERRCNABR('637', '14', 'Registro em duplicidade');
   INCLUI_ERRCNABR('637', '19', 'Data de desconto invlida ou maior que a data de vencimento');
   INCLUI_ERRCNABR('637', '20', 'Valor de IOF no numrico');
   INCLUI_ERRCNABR('637', '22', 'Valor de desconto + abatimento maior que o valor do ttulo');
   INCLUI_ERRCNABR('637','25', 'CGC ou CPF do sacado invlido (aceito com restries)');
   INCLUI_ERRCNABR('637','26', 'Espcies de documento invlida (difere de 01...10,13 e 99)');
   INCLUI_ERRCNABR('637','27', 'Data de emisso do ttulo invlida');
   INCLUI_ERRCNABR('637','28', 'Seu nmero no informado');
   INCLUI_ERRCNABR('637','29', 'CEP  igual a espao ou zeros; ou no numrico');
   INCLUI_ERRCNABR('637','30', 'Valor do ttulo no numrico ou invlido');
   INCLUI_ERRCNABR('637','36', 'Valor de permanncia no numrico');
   INCLUI_ERRCNABR('637','37', 'Valor de permanncia inconsistente, pois, dentro de um ms, ser maior que o valor do ttulo');
   INCLUI_ERRCNABR('637','38', 'Valor de desconto/abatimento no numrico ou invlido');
   INCLUI_ERRCNABR('637','39', 'Valor de abatimento no numrico');
   INCLUI_ERRCNABR('637','42', 'Ttulo j existente em nossos registros. Nosso nmero no aceito');
   INCLUI_ERRCNABR('637','43', 'Ttulo enviado em duplicidade nesse movimento');
   INCLUI_ERRCNABR('637','44', 'Ttulo zerado ou em branco; ou no numrico na remessa');
   INCLUI_ERRCNABR('637','46', 'Ttulo enviado fora da faixa de Nosso Nmero, estipulada para o cliente.');
   INCLUI_ERRCNABR('637','53', 'Prazo de vencimento do ttulo excede ao da contratao');
   INCLUI_ERRCNABR('637','54', 'Banco informado no  nosso correspondente 140-142');
   INCLUI_ERRCNABR('637','55', 'Banco correspondente informado no cobra este CEP ou no possui faixas de CEP cadastradas');
   INCLUI_ERRCNABR('637','56', 'Nosso nmero no correspondente no foi informado');
   INCLUI_ERRCNABR('637','57', 'Remessa contendo duas instrues incompatveis  no protestar e dias de protesto ou prazo para protesto invlido.');
   INCLUI_ERRCNABR('637','58', 'Entradas Rejeitadas  Reprovado no Represamento para Anlise');
   INCLUI_ERRCNABR('637','60', 'CGC/CPF do sacado invlido  ttulo recusado');
   INCLUI_ERRCNABR('637','87', 'Excede Prazo mximo entre emisso e vencimento');
   INCLUI_ERRCNABR('637','AG', 'Movimento no permitido  Ttulo  vista ou contra apresentao');
   INCLUI_ERRCNABR('637','AK', 'Ttulo pertence a outro cliente');
   INCLUI_ERRCNABR('637','AL', 'Sacado impedido de entrar nesta cobrana');
   INCLUI_ERRCNABR('637','AY', 'Ttulo deve estar em aberto e vencido para acatar protesto');
   INCLUI_ERRCNABR('637','BC', 'Anlise gerencial-sacado invlido p/operao crdito');
   INCLUI_ERRCNABR('637','BD', 'Anlise gerencial-sacado inadimplente');
   INCLUI_ERRCNABR('637','BE', 'Anlise gerencial-sacado difere do exigido');
   INCLUI_ERRCNABR('637','BF', 'Anlise gerencial-vencto excede vencto da operao de crdito');
   INCLUI_ERRCNABR('637','BG', 'Anlise gerencial-sacado com baixa liquidez');
   INCLUI_ERRCNABR('637','BH', 'Anlise gerencial-sacado excede concentrao');
   INCLUI_ERRCNABR('637','CB', 'Ttulo possui protesto efetivado/a efetivar hoje');
   INCLUI_ERRCNABR('637','CC', 'Valor de iof incompatvel com a espcie documento');
   INCLUI_ERRCNABR('637','CD', 'Efetivao de protesto sem agenda vlida');
   INCLUI_ERRCNABR('637','CE', 'Ttulo no aceito - pessoa fsica');
   INCLUI_ERRCNABR('637','CF', 'Excede prazo mximo da entrada ao vencimento');
   INCLUI_ERRCNABR('637','CG', 'Ttulo no aceito  por anlise gerencial');
   INCLUI_ERRCNABR('637','CH', 'Ttulo em espera  em anlise pelo banco');
   COMMIT;
END;
/

BEGIN
-- BANCO SICREDI
   INCLUI_ERRCNABR('748', '01', 'Cdigo do Banco invlido');
   INCLUI_ERRCNABR('748', '02', 'Cdigo do registro detalhe invlido');
   INCLUI_ERRCNABR('748', '03', 'Cdigo da Ocorrncia invlido');
   INCLUI_ERRCNABR('748', '04', 'Cdigo da Ocorrncia no permitido para a carteira');
   INCLUI_ERRCNABR('748', '05', 'Cdigo de Ocorrncia no numrico');
   INCLUI_ERRCNABR('748', '07', 'Cooperativa/agncia/conta/dgito invlidos');
   INCLUI_ERRCNABR('748', '08', 'Nosso nmero invlido');
   INCLUI_ERRCNABR('748', '09', 'Nosso nmero duplicado');
   INCLUI_ERRCNABR('748', '10', 'Carteira invlida');
   INCLUI_ERRCNABR('748', '14', 'Ttulo Protestado');
   INCLUI_ERRCNABR('748', '15', 'Cooperativa/agncia/conta/nosso nmero invlidos');
   INCLUI_ERRCNABR('748', '16', 'Data de vencimento invlida');
   INCLUI_ERRCNABR('748', '17', 'Data de vencimento anterior  data de emisso');
   INCLUI_ERRCNABR('748', '18', 'Vencimento fora do prazo de operao');
   INCLUI_ERRCNABR('748', '20', 'Valor do ttulo invlido');
   INCLUI_ERRCNABR('748', '21', 'Espcie do ttulo invlida');
   INCLUI_ERRCNABR('748', '22', 'Espcie no permitida para a carteira');
   INCLUI_ERRCNABR('748', '24', 'Data de emisso invlida');
   INCLUI_ERRCNABR('748', '29', 'Valor de desconto maior/igual ao valor do ttulo');
   INCLUI_ERRCNABR('748', '31', 'Concesso de desconto - existe desconto anterior');
   INCLUI_ERRCNABR('748', '33', 'Valor do abatimento invlido');
   INCLUI_ERRCNABR('748', '34', 'Valor do abatimento maior/igual ao valor do ttulo');
   INCLUI_ERRCNABR('748', '36', 'Concesso de abatimento - existe abatimento anterior');
   INCLUI_ERRCNABR('748', '38', 'Prazo para protesto invlido');
   INCLUI_ERRCNABR('748', '39', 'Pedido para protesto no permitido para o ttulo');
   INCLUI_ERRCNABR('748', '40', 'Ttulo com ordem de protesto emitida');
   INCLUI_ERRCNABR('748', '41', 'Pedido cancelamento/sustao sem instruo de de protesto');
   INCLUI_ERRCNABR('748', '44', 'Cooperativa de crdito/agncia cedente no prevista');
   INCLUI_ERRCNABR('748', '45', 'Nome do sacado invlido');
   INCLUI_ERRCNABR('748', '46', 'Tipo/nmero de inscrio do sacado invlidos');
   INCLUI_ERRCNABR('748', '47', 'Endereo do sacado no informado');
   INCLUI_ERRCNABR('748', '48', 'CEP irregular');
   INCLUI_ERRCNABR('748', '49', 'Nmero de inscrio do sacador/avalista invlido');
   INCLUI_ERRCNABR('748', '50', 'Sacador/avalista no informado');
   INCLUI_ERRCNABR('748', '60', 'Movimento para ttulo no cadastrado');
   INCLUI_ERRCNABR('748', '63', 'Entrada para ttulo j cadastrado');
   INCLUI_ERRCNABR('748', 'A',  'Aceito');
   INCLUI_ERRCNABR('748', 'D', ' Desprezado');
   INCLUI_ERRCNABR('748', 'A1', 'Praa do Sacado no cadastrada');
   INCLUI_ERRCNABR('748', 'A2', 'Tipo de cobrana do ttulo divergente com a praa do sacado');
   INCLUI_ERRCNABR('748', 'A3', 'Cooperativa/agncia depositaria divergente: atualiza o cadastro de praas da Coop./agncia cedente');
   INCLUI_ERRCNABR('748', 'A4', 'Cedente no cadastrado ou possui CGC/CIC invlido');
   INCLUI_ERRCNABR('748', 'A5', 'Sacado no cadastrado');
   INCLUI_ERRCNABR('748', 'A6', 'Data da instruo/ocorrncia invlida');
   INCLUI_ERRCNABR('748', 'A7', 'Ocorrncia no pode ser comandada');
   INCLUI_ERRCNABR('748', 'A8', 'Recebimento da liquidao fora do SICREDI - via compensao eletrnica');
   INCLUI_ERRCNABR('748', 'B4', 'Tipo de moeda invlido');
   INCLUI_ERRCNABR('748', 'B5', 'Tipo de desconto/juros invlido');
   INCLUI_ERRCNABR('748', 'B6', 'Mensagem padro no cadastrada');
   INCLUI_ERRCNABR('748', 'B7', 'Seu nmero invlido');
   INCLUI_ERRCNABR('748', 'B8', 'Percentual de multa invlido');
   INCLUI_ERRCNABR('748', 'B9', 'Valor ou percentual de juros invlido');
   INCLUI_ERRCNABR('748', 'C1', 'Data limite para concesso de desconto invlida');
   INCLUI_ERRCNABR('748', 'C2', 'Aceite do ttulo invlido');
   INCLUI_ERRCNABR('748', 'C3', 'Campo alterado na instruo: 31 - Alterao de outros dados, invlido');
   INCLUI_ERRCNABR('748', 'C4', 'Ttulo ainda no foi confirmado pela centralizadora');
   INCLUI_ERRCNABR('748', 'C5', 'Ttulo rejeitado pela centralizadora');
   INCLUI_ERRCNABR('748', 'C6', 'Ttulo j liquidado');
   INCLUI_ERRCNABR('748', 'C7', 'Ttulo j baixado');
   INCLUI_ERRCNABR('748', 'C8', 'Existe mesma instruo pendente de confirmao para este ttulo');
   INCLUI_ERRCNABR('748', 'C9', 'Instruo prvia de concesso de abatimento no existe ou no confirmada');
   INCLUI_ERRCNABR('748', 'D1', 'Ttulo dentro do prazo de vencimentos (em dia)');
   INCLUI_ERRCNABR('748', 'D2', 'Espcie de documento no permite protesto de ttulo');
   INCLUI_ERRCNABR('748', 'D3', 'Ttulo possui instruo de baixa pendente de confirmao');
   INCLUI_ERRCNABR('748', 'D4', 'Quantidade de mensagens padro excede o limite permitido');
   INCLUI_ERRCNABR('748', 'D5', 'Quantidade invlida no pedido de bloquetos pr-impressos da cobrana sem registro');
   INCLUI_ERRCNABR('748', 'D6', 'Tipo de impresso invlida para cobrana sem registro');
   INCLUI_ERRCNABR('748', 'D7', 'Cidade ou Estado do sacado no informado');
   INCLUI_ERRCNABR('748', 'D8', 'Sequncia para composio do nosso nmero do ano atual esgotada');
   INCLUI_ERRCNABR('748', 'D9', 'Registro mensagem para ttulo no cadastrado');
   INCLUI_ERRCNABR('748', 'E2', 'Registro complementar ao cadastro do ttulo da cobrana com e sem registro no cadastrado');
   INCLUI_ERRCNABR('748', 'E3', 'Tipo de postagem invlido, diferente de S, N e branco');
   INCLUI_ERRCNABR('748', 'E4', 'Pedido de bloquetos pr-impressos');
   INCLUI_ERRCNABR('748', 'E5', 'Confirmao/rejeio para pedidos de bloquetos no cadastrado');
   INCLUI_ERRCNABR('748', 'E6', 'Sacador/avalista no cadastrado');
   INCLUI_ERRCNABR('748', 'E7', 'Informao para atualizao do valor do ttulo para protesto invlido');
   INCLUI_ERRCNABR('748', 'E8', 'Tipo de impresso invlido, diferente de A, B e branco');
   INCLUI_ERRCNABR('748', 'E9', 'Cdigo do sacado do ttulo divergente com o cdigo da cooperativa de crdito');
   INCLUI_ERRCNABR('748', 'F1', 'Liquidado no sistema do cliente');
   INCLUI_ERRCNABR('748', 'F2', 'Baixado no sistema do cliente');
   INCLUI_ERRCNABR('748', 'F3', 'Instruo invlida, este ttulo est caucionado/descontado');
   INCLUI_ERRCNABR('748', 'F4', 'Instruo fixa com caracteres invlidos');
   INCLUI_ERRCNABR('748', 'F6', 'Nosso nmero / nmero da parcela fora de sequencia - total de parcelas invlido');
   INCLUI_ERRCNABR('748', 'F7', 'Falta de comprovante de prestao de servios');
   INCLUI_ERRCNABR('748', 'F8', 'Nome do cedente incompleto/incorreto');
   INCLUI_ERRCNABR('748', 'F9', 'CNPJ/CPF incompatvel com o nome do sacado / sacador avalista');
   INCLUI_ERRCNABR('748', 'G1', 'CNPJ/CPF do sacador incompatvel com a espcie');
   INCLUI_ERRCNABR('748', 'G2', 'Ttulo aceito: sem a assinatura do sacado');
   INCLUI_ERRCNABR('748', 'G3', 'Ttulo aceito: rasurado ou rasgado');
   INCLUI_ERRCNABR('748', 'G4', 'Ttulo aceito: falta ttulo (cooperativa/ag. cedente dever envi-lo');
   INCLUI_ERRCNABR('748', 'G5', 'Praa de pagamento incomptivel com o endereo');
   INCLUI_ERRCNABR('748', 'G6', 'Ttulo aceito: sem endosso ou cedente irregular');
   INCLUI_ERRCNABR('748', 'G7', 'Ttulo aceito: valor por extenso diferente do valor numrico');
   INCLUI_ERRCNABR('748', 'G8', 'Saldo maior que o valor do ttulo');
   INCLUI_ERRCNABR('748', 'G9', 'Tipo de endosso invlido');
   INCLUI_ERRCNABR('748', 'H1', 'Nome sacador incompleto/incorreto');
   INCLUI_ERRCNABR('748', 'H2', 'Sustao judicial');
   INCLUI_ERRCNABR('748', 'H3', 'Sacado no encontrado');
   INCLUI_ERRCNABR('748', 'H4', 'Alterao da carteira');
   INCLUI_ERRCNABR('748', 'H5', 'Recebimento da liquidao fora da rede SICREDI - VLB inferior - Via compensao');
   INCLUI_ERRCNABR('748', 'H6', 'Recebimento da liquidao fora da rede SICREDI - VLB superior - Via compensao');
   INCLUI_ERRCNABR('748', 'H7', 'Espcie de documento necessita cedente ou avalista PJ');
   INCLUI_ERRCNABR('748', 'H8', 'Recebimento da liquidao fora da rede SICREDI - Contingncia Via Compe');
   INCLUI_ERRCNABR('748', 'H9', 'Dados do ttulo no conferem com disquete');
   INCLUI_ERRCNABR('748', 'I1', 'Sacado e sacador avalista so a mesma pessoa');
   INCLUI_ERRCNABR('748', 'I2', 'Aguardar um dia til aps o vencimento para protestar');
   INCLUI_ERRCNABR('748', 'I3', 'Data do vencimento rasurada');
   INCLUI_ERRCNABR('748', 'I4', 'Vencimento - extenso no confere com nmero');
   INCLUI_ERRCNABR('748', 'I5', 'Falta data de vencimento no ttulo');
   INCLUI_ERRCNABR('748', 'I6', 'DM/DMI sem comprovante autenticado ou declarao');
   INCLUI_ERRCNABR('748', 'I7', 'Comprovante ilegvel para conferncia e microfilmagem');
   INCLUI_ERRCNABR('748', 'I8', 'Nome solicitado no confere com emitente ou sacado');
   INCLUI_ERRCNABR('748', 'I9', 'Confirmar se so 2 emitentes. Se sim, indicar os dados dos 2');
   INCLUI_ERRCNABR('748', 'J1', 'Endereo do sacado igual ao do sacador ou do portador');
   INCLUI_ERRCNABR('748', 'J2', 'Endereo do apresentante incompleto ou no informado');
   INCLUI_ERRCNABR('748', 'J3', 'Rua/nmero inexistente no endereo');
   INCLUI_ERRCNABR('748', 'J4', 'Falta endosso do favorecido para o apresentante');
   INCLUI_ERRCNABR('748', 'J5', 'Data de emisso rasurada');
   INCLUI_ERRCNABR('748', 'J6', 'Falta assinatura do sacador no ttulo');
   INCLUI_ERRCNABR('748', 'J7', 'Nome do apresentante no informado/incompleto/incorreto');
   INCLUI_ERRCNABR('748', 'J8', 'Erro de preenchimento de ttulo');
   INCLUI_ERRCNABR('748', 'J9', 'Ttulo com direito de regresso vencido');
   INCLUI_ERRCNABR('748', 'K1', 'Ttulo apresentado em duplicidade');
   INCLUI_ERRCNABR('748', 'K2', 'Ttulo j protestado');
   INCLUI_ERRCNABR('748', 'K3', 'Letra de cambio vencida - falta aceite do sacado');
   INCLUI_ERRCNABR('748', 'K4', 'Falta declarao de saldo assinada no ttulo');
   INCLUI_ERRCNABR('748', 'K5', 'Contrato de cambio - Falta conta grfica');
   INCLUI_ERRCNABR('748', 'K6', 'Ausncia do documento fsico');
   INCLUI_ERRCNABR('748', 'K7', 'Sacado falecido');
   INCLUI_ERRCNABR('748', 'K8', 'Sacado apresentou quitao do ttulo');
   INCLUI_ERRCNABR('748', 'K9', 'Ttulo de outra jurisdio territorial');
   INCLUI_ERRCNABR('748', 'L1', 'Ttulo com emisso anterior a concordata do sacado');
   INCLUI_ERRCNABR('748', 'L2', 'Sacado consta na lista de falncia');
   INCLUI_ERRCNABR('748', 'L3', 'Apresentante no aceita publicao de edital');
   INCLUI_ERRCNABR('748', 'L4', 'Dados do Sacado em Branco ou invlido');
   INCLUI_ERRCNABR('748', 'L5', 'Cdigo do Sacado na agncia cedente est duplicado');
   INCLUI_ERRCNABR('748', 'M1', 'Reconhecimento da dvida pelo Sacado');
   INCLUI_ERRCNABR('748', 'M2', 'No reconhecimento da dvida pelo Sacado');
   INCLUI_ERRCNABR('748', 'X1', 'Regularizao Centralizadora - Rede SICREDI');
   INCLUI_ERRCNABR('748', 'X2', 'Regularizao Centralizadora - Compensao');
   INCLUI_ERRCNABR('748', 'X3', 'Regularizao Centralizadora - Banco correspondente');
   INCLUI_ERRCNABR('748', 'X4', 'Regularizao Centralizadora - VLB Inferior - via compensao');
   INCLUI_ERRCNABR('748', 'X5', 'Regularizao Centralizadora - VLB Inferior - via compensao');
   INCLUI_ERRCNABR('748', 'X0', 'Pago com cheque');
   INCLUI_ERRCNABR('748', 'X6', 'Pago com cheque - bloqueado 24 horas');
   INCLUI_ERRCNABR('748', 'X7', 'Pago com cheque - bloqueado 48 horas');
   INCLUI_ERRCNABR('748', 'X8', 'Pago com cheque - bloqueado 72 horas');
   INCLUI_ERRCNABR('748', 'X9', 'Pago com cheque - bloqueado 96 horas');
   INCLUI_ERRCNABR('748', 'XA', 'Pago com cheque - bloqueado 120 horas');
   INCLUI_ERRCNABR('748', 'XB', 'Pago com cheque - bloqueado 144 horas');
   COMMIT;
END;
/
BEGIN
-- BANCO SICOOB
   INCLUI_ERRCNABR('756', '0200', '[Entrada confirmada] Ocorrncia aceita');
   INCLUI_ERRCNABR('756', '0217', '[Entrada confirmada] Data de vencimento anterior a data de emisso');
   INCLUI_ERRCNABR('756', '0221', '[Entrada confirmada] Espcie do Ttulo invlido');
   INCLUI_ERRCNABR('756', '0224', '[Entrada confirmada] Data da emisso invlida');
   INCLUI_ERRCNABR('756', '0238', '[Entrada confirmada] Prazo para protesto invlido');
   INCLUI_ERRCNABR('756', '0239', '[Entrada confirmada] Pedido para protesto no permitido para ttulo');
   INCLUI_ERRCNABR('756', '0243', '[Entrada confirmada] Prazo para baixa e devoluo invlido');
   INCLUI_ERRCNABR('756', '0245', '[Entrada confirmada] Nome do Sacado invlido');
   INCLUI_ERRCNABR('756', '0246', '[Entrada confirmada] Tipo/num. de inscrio do Sacado invlidos');
   INCLUI_ERRCNABR('756', '0247', '[Entrada confirmada] Endereo do Sacado no informado');
   INCLUI_ERRCNABR('756', '0248', '[Entrada confirmada] CEP irregular');
   INCLUI_ERRCNABR('756', '0250', '[Entrada confirmada] CEP referente a Banco correspondente');
   INCLUI_ERRCNABR('756', '0253', '[Entrada confirmada] N de inscrio do Sacador/avalista invlidos (CPF/CGC)');
   INCLUI_ERRCNABR('756', '0254', '[Entrada confirmada] Sacador/avalista no informado');
   INCLUI_ERRCNABR('756', '0267', '[Entrada confirmada] Dbito automtico agendado');
   INCLUI_ERRCNABR('756', '0268', '[Entrada confirmada] Dbito no agendado  Erro nos dados de remessa');
   INCLUI_ERRCNABR('756', '0269', '[Entrada confirmada] Dbito no agendado  Sacado no consta no cadastro de autorizante');
   INCLUI_ERRCNABR('756', '0270', '[Entrada confirmada] Dbito no agendado  Cedente no autorizado pelo Sacado');
   INCLUI_ERRCNABR('756', '0271', '[Entrada confirmada] Dbito no agendado  Cedente no participa da modalidade de dbito automtico');
   INCLUI_ERRCNABR('756', '0272', '[Entrada confirmada] Dbito no agendado  Cdigo de moeda diferente de R$');
   INCLUI_ERRCNABR('756', '0273', '[Entrada confirmada] Dbito no agendado  Data de vencimento invlida');
   INCLUI_ERRCNABR('756', '0275', '[Entrada confirmada] Dbito no agendado  Tipo do nmero de inscrio do sacado debitado invlido');
   INCLUI_ERRCNABR('756', '0286', '[Entrada confirmada] Seu nmero do documento invlido');
   INCLUI_ERRCNABR('756', '0302', '[Entrada Rejeitada] Cdigo do registro detalhe invlido');
   INCLUI_ERRCNABR('756', '0303', '[Entrada Rejeitada] Cdigo da ocorrncia invlida');
   INCLUI_ERRCNABR('756', '0304', '[Entrada Rejeitada] Cdigo de ocorrncia no permitida para a carteira');
   INCLUI_ERRCNABR('756', '0305', '[Entrada Rejeitada] Cdigo de ocorrncia no numrico');
   INCLUI_ERRCNABR('756', '0307', '[Entrada Rejeitada] Agncia/conta/Digito  Invlido');
   INCLUI_ERRCNABR('756', '0308', '[Entrada Rejeitada] Nosso nmero invlido');
   INCLUI_ERRCNABR('756', '0309', '[Entrada Rejeitada] Nosso nmero duplicado');
   INCLUI_ERRCNABR('756', '0310', '[Entrada Rejeitada] Carteira invlida');
   INCLUI_ERRCNABR('756', '0316', '[Entrada Rejeitada] Data de vencimento invlida');
   INCLUI_ERRCNABR('756', '0318', '[Entrada Rejeitada] Vencimento fora do prazo de operao');
   INCLUI_ERRCNABR('756', '0320', '[Entrada Rejeitada] Valor do Ttulo invlido');
   INCLUI_ERRCNABR('756', '0321', '[Entrada Rejeitada] Espcie do Ttulo invlida');
   INCLUI_ERRCNABR('756', '0322', '[Entrada Rejeitada] Espcie no permitida para a carteira');
   INCLUI_ERRCNABR('756', '0324', '[Entrada Rejeitada] Data de emisso invlida');
   INCLUI_ERRCNABR('756', '0338', '[Entrada Rejeitada] Prazo para protesto invlido');
   INCLUI_ERRCNABR('756', '0344', '[Entrada Rejeitada] Agncia Cedente no prevista');
   INCLUI_ERRCNABR('756', '0350', '[Entrada Rejeitada] CEP irregular  Banco Correspondente');
   INCLUI_ERRCNABR('756', '0363', '[Entrada Rejeitada] Entrada para Ttulo j cadastrado');
   INCLUI_ERRCNABR('756', '0368', '[Entrada Rejeitada] Dbito no agendado  Erro nos dados de remessa');
   INCLUI_ERRCNABR('756', '0369', '[Entrada Rejeitada] Dbito no agendado  Sacado no consta no cadastro de autorizante');
   INCLUI_ERRCNABR('756', '0370', '[Entrada Rejeitada] Dbito no agendado  Cedente no autorizado pelo Sacado');
   INCLUI_ERRCNABR('756', '0371', '[Entrada Rejeitada] Dbito no agendado  Cedente no participa da modalidade de dbito automtico');
   INCLUI_ERRCNABR('756', '0372', '[Entrada Rejeitada] Dbito no agendado  Cdigo de moeda diferente de R$');
   INCLUI_ERRCNABR('756', '0373', '[Entrada Rejeitada] Dbito no agendado  Data de vencimento invlida');
   INCLUI_ERRCNABR('756', '0374', '[Entrada Rejeitada] Dbito no agendado  Conforme seu pedido, Ttulo no registrado');
   INCLUI_ERRCNABR('756', '0375', '[Entrada Rejeitada] Dbito no agendado  Tipo de nmero de inscrio do debitado invlido');
   INCLUI_ERRCNABR('756', '0910', '[Baixado Automaticamente via Arquivo] Baixa comandada pelo cliente');
   INCLUI_ERRCNABR('756', '1000', '[Baixado Conforme Instrues da Agncia] Baixa Comandada');
   INCLUI_ERRCNABR('756', '1014', '[Baixado Conforme Instrues da Agncia] Ttulo Protestado');
   INCLUI_ERRCNABR('756', '1015', '[Baixado Conforme Instrues da Agncia] Ttulo excludo');
   INCLUI_ERRCNABR('756', '2448', '[Entrada Rejeitada por CEP irregular] CEP invlido');
   INCLUI_ERRCNABR('756', '2704', '[Baixa Rejeitada] Cdigo de ocorrncia no permitido para a carteira');
   INCLUI_ERRCNABR('756', '2707', '[Baixa Rejeitada] Agncia/Conta/dgito invlidos');
   INCLUI_ERRCNABR('756', '2708', '[Baixa Rejeitada] Nosso nmero invlido');
   INCLUI_ERRCNABR('756', '2710', '[Baixa Rejeitada] Carteira invlida');
   INCLUI_ERRCNABR('756', '2715', '[Baixa Rejeitada] Carteira/Agncia/Conta/nosso nmero invlidos');
   INCLUI_ERRCNABR('756', '2740', '[Baixa Rejeitada] Ttulo com ordem de protesto emitido');
   INCLUI_ERRCNABR('756', '2742', '[Baixa Rejeitada] Cdigo para baixa/devoluo via Telebradesco invlido');
   INCLUI_ERRCNABR('756', '2760', '[Baixa Rejeitada] Movimento para Ttulo no cadastrado');
   INCLUI_ERRCNABR('756', '2777', '[Baixa Rejeitada] Transferncia para desconto no permitido para a carteira');
   INCLUI_ERRCNABR('756', '2785', '[Baixa Rejeitada] Ttulo com pagamento vinculado');
   INCLUI_ERRCNABR('756', '2803', '[Dbito de Tarifas/Custas] Tarifa de sustao');
   INCLUI_ERRCNABR('756', '2804', '[Dbito de Tarifas/Custas] Tarifa de protesto');
   INCLUI_ERRCNABR('756', '2808', '[Dbito de Tarifas/Custas] Custas de protesto');
   INCLUI_ERRCNABR('756', '3001', '[Alterao de Outros Dados Rejeitados] Cdigo do Banco invlido');
   INCLUI_ERRCNABR('756', '3004', '[Alterao de Outros Dados Rejeitados] Cdigo de ocorrncia no permitido para a carteira');
   INCLUI_ERRCNABR('756', '3005', '[Alterao de Outros Dados Rejeitados] Cdigo da ocorrncia no numrico');
   INCLUI_ERRCNABR('756', '3008', '[Alterao de Outros Dados Rejeitados] Nosso nmero invlido');
   INCLUI_ERRCNABR('756', '3015', '[Alterao de Outros Dados Rejeitados] Caracterstica da cobrana imcoptivel');
   INCLUI_ERRCNABR('756', '3016', '[Alterao de Outros Dados Rejeitados] Data de vencimento invlido');
   INCLUI_ERRCNABR('756', '3017', '[Alterao de Outros Dados Rejeitados] Data de vencimento anterior a data de emisso');
   INCLUI_ERRCNABR('756', '3018', '[Alterao de Outros Dados Rejeitados] Vencimento fora do prazo de operao');
   INCLUI_ERRCNABR('756', '3024', '[Alterao de Outros Dados Rejeitados] Data de emisso Invlida');
   INCLUI_ERRCNABR('756', '3029', '[Alterao de Outros Dados Rejeitados] Valor do desconto maior/igual ao valor do Ttulo');
   INCLUI_ERRCNABR('756', '3030', '[Alterao de Outros Dados Rejeitados] Desconto a conceder no confere');
   INCLUI_ERRCNABR('756', '3031', '[Alterao de Outros Dados Rejeitados] Concesso de desconto j existente (Desconto anterior)');
   INCLUI_ERRCNABR('756', '3033', '[Alterao de Outros Dados Rejeitados] Valor do abatimento invlido');
   INCLUI_ERRCNABR('756', '3034', '[Alterao de Outros Dados Rejeitados] Valor do abatimento maior/igual ao valor do Ttulo');
   INCLUI_ERRCNABR('756', '3038', '[Alterao de Outros Dados Rejeitados] Prazo para protesto invlido');
   INCLUI_ERRCNABR('756', '3039', '[Alterao de Outros Dados Rejeitados] Pedido de protesto no permitido para o Ttulo');
   INCLUI_ERRCNABR('756', '3040', '[Alterao de Outros Dados Rejeitados] Ttulo com ordem de protesto emitido');
   INCLUI_ERRCNABR('756', '3042', '[Alterao de Outros Dados Rejeitados] Cdigo para baixa/devoluo invlido');
   INCLUI_ERRCNABR('756', '3060', '[Alterao de Outros Dados Rejeitados] Movimento para Ttulo no cadastrado');
   INCLUI_ERRCNABR('756', '3085', '[Alterao de Outros Dados Rejeitados] Ttulo com Pagamento Vinculado');
   INCLUI_ERRCNABR('756', '3201', '[Instruo Rejeitada] Cdigo do Banco invlido');
   INCLUI_ERRCNABR('756', '3202', '[Instruo Rejeitada] Cdigo do registro detalhe invlido');
   INCLUI_ERRCNABR('756', '3204', '[Instruo Rejeitada] Cdigo de ocorrncia no permitido para a carteira');
   INCLUI_ERRCNABR('756', '3205', '[Instruo Rejeitada] Cdigo de ocorrncia no numrico');
   INCLUI_ERRCNABR('756', '3207', '[Instruo Rejeitada] Agncia/Conta/dgito invlidos');
   INCLUI_ERRCNABR('756', '3208', '[Instruo Rejeitada] Nosso nmero invlido');
   INCLUI_ERRCNABR('756', '3210', '[Instruo Rejeitada] Carteira invlida');
   INCLUI_ERRCNABR('756', '3215', '[Instruo Rejeitada] Caractersticas da cobrana incompatveis');
   INCLUI_ERRCNABR('756', '3216', '[Instruo Rejeitada] Data de vencimento invlida');
   INCLUI_ERRCNABR('756', '3217', '[Instruo Rejeitada] Data de vencimento anterior a data de emisso');
   INCLUI_ERRCNABR('756', '3218', '[Instruo Rejeitada] Vencimento fora do prazo de operao');
   INCLUI_ERRCNABR('756', '3220', '[Instruo Rejeitada] Valor do ttulo invlido');
   INCLUI_ERRCNABR('756', '3221', '[Instruo Rejeitada] Espcie do Ttulo invlida');
   INCLUI_ERRCNABR('756', '3222', '[Instruo Rejeitada] Espcie no permitida para a carteira');
   INCLUI_ERRCNABR('756', '3224', '[Instruo Rejeitada] Data de emisso invlida');
   INCLUI_ERRCNABR('756', '3228', '[Instruo Rejeitada] Cdigo de desconto via Telebradesco invlido');
   INCLUI_ERRCNABR('756', '3229', '[Instruo Rejeitada] Valor do desconto maior/igual ao valor do Ttulo');
   INCLUI_ERRCNABR('756', '3230', '[Instruo Rejeitada] Desconto a conceder no confere');
   INCLUI_ERRCNABR('756', '3231', '[Instruo Rejeitada] Concesso de desconto  J existe desconto anterior');
   INCLUI_ERRCNABR('756', '3233', '[Instruo Rejeitada] Valor do abatimento invlido');
   INCLUI_ERRCNABR('756', '3234', '[Instruo Rejeitada] Valor do abatimento maior/igual ao valor do Ttulo');
   INCLUI_ERRCNABR('756', '3236', '[Instruo Rejeitada] Concesso abatimento  J existe abatimento anterior');
   INCLUI_ERRCNABR('756', '3238', '[Instruo Rejeitada] Prazo para protesto invlido');
   INCLUI_ERRCNABR('756', '3239', '[Instruo Rejeitada] Pedido de protesto no permitido para o Ttulo');
   INCLUI_ERRCNABR('756', '3240', '[Instruo Rejeitada] Ttulo com ordem de protesto emitido');
   INCLUI_ERRCNABR('756', '3241', '[Instruo Rejeitada] Pedido cancelamento/sustao para Ttulo sem instruo de protesto');
   INCLUI_ERRCNABR('756', '3242', '[Instruo Rejeitada] Cdigo para baixa/devoluo invlido');
   INCLUI_ERRCNABR('756', '3245', '[Instruo Rejeitada] Nome do Sacado no informado');
   INCLUI_ERRCNABR('756', '3246', '[Instruo Rejeitada] Tipo/nmero de inscrio do Sacado invlidos');
   INCLUI_ERRCNABR('756', '3247', '[Instruo Rejeitada] Endereo do Sacado no informado');
   INCLUI_ERRCNABR('756', '3248', '[Instruo Rejeitada] CEP Invlido');
   INCLUI_ERRCNABR('756', '3250', '[Instruo Rejeitada] CEP referente a um Banco correspondente');
   INCLUI_ERRCNABR('756', '3253', '[Instruo Rejeitada] Tipo de inscrio do sacador avalista invlidos');
   INCLUI_ERRCNABR('756', '3260', '[Instruo Rejeitada] Movimento para Ttulo no cadastrado');
   INCLUI_ERRCNABR('756', '3285', '[Instruo Rejeitada] Ttulo com pagamento vinculado');
   INCLUI_ERRCNABR('756', '3286', '[Instruo Rejeitada] Seu nmero invlido');
   INCLUI_ERRCNABR('756', '3581', '[Desagendamento do Dbito Automtico] Tentativas esgotadas, baixado');
   INCLUI_ERRCNABR('756', '3582', '[Desagendamento do Dbito Automtico] Tentativas esgotadas, pendente');
   COMMIT;
END;
/
BEGIN
   --Banco Daycoval
	INCLUI_ERRCNABR('707', '0303', '[Entrada Rejeitada] CEP invlido  No temos cobrador  Cobrador no Localizado');
	INCLUI_ERRCNABR('707', '0304', '[Entrada Rejeitada] Sigla do Estado invlida');
	INCLUI_ERRCNABR('707', '0305', '[Entrada Rejeitada] Data de Vencimento invlida ou fora do prazo mnimo');
	INCLUI_ERRCNABR('707', '0306', '[Entrada Rejeitada] Cdigo do Banco invlido');
	INCLUI_ERRCNABR('707', '0308', '[Entrada Rejeitada] Nome do sacado no informado');
	INCLUI_ERRCNABR('707', '0310', '[Entrada Rejeitada] Logradouro no informado');
	INCLUI_ERRCNABR('707', '0314', '[Entrada Rejeitada] Registro em duplicidade');
	INCLUI_ERRCNABR('707', '0319', '[Entrada Rejeitada] Data de desconto invlida ou maior que a data de vencimento');
	INCLUI_ERRCNABR('707', '0320', '[Entrada Rejeitada] Valor de IOF no numrico');
	INCLUI_ERRCNABR('707', '0322', '[Entrada Rejeitada] Valor de desconto + abatimento maior que o valor do ttulo');
	INCLUI_ERRCNABR('707', '0325', '[Entrada Rejeitada] CNPJ ou CPF do sacado invlido (aceito com restries)');
	INCLUI_ERRCNABR('707', '0326', '[Entrada Rejeitada] Espcies de documento invlida (difere de 01...10,13 e 99)');
	INCLUI_ERRCNABR('707', '0327', '[Entrada Rejeitada] Data de emisso do ttulo invlida');
	INCLUI_ERRCNABR('707', '0328', '[Entrada Rejeitada] Seu nmero no informado');
	INCLUI_ERRCNABR('707', '0329', '[Entrada Rejeitada] CEP  igual a espao ou zeros; ou no numrico');
	INCLUI_ERRCNABR('707', '0330', '[Entrada Rejeitada] Valor do ttulo no numrico ou invlido');
	INCLUI_ERRCNABR('707', '0336', '[Entrada Rejeitada] Valor de permanncia no numrico');
	INCLUI_ERRCNABR('707', '0337', '[Entrada Rejeitada] Valor de permanncia inconsistente, pois, dentro de um ms, ser maior que o valor do ttulo');
	INCLUI_ERRCNABR('707', '0338', '[Entrada Rejeitada] Valor de desconto/abatimento no numrico ou invlido');
	INCLUI_ERRCNABR('707', '0339', '[Entrada Rejeitada] Valor de abatimento no numrico');
	INCLUI_ERRCNABR('707', '0342', '[Entrada Rejeitada] Ttulo j existente em nossos registros. Nosso nmero no aceito');
	INCLUI_ERRCNABR('707', '0343', '[Entrada Rejeitada] Ttulo enviado em duplicidade nesse movimento');
	INCLUI_ERRCNABR('707', '0344', '[Entrada Rejeitada] Ttulo zerado ou em branco; ou no numrico na remessa');
	INCLUI_ERRCNABR('707', '0346', '[Entrada Rejeitada] Ttulo enviado fora da faixa de Nosso Nmero, estipulada para o cliente.');
	INCLUI_ERRCNABR('707', '0351', '[Entrada Rejeitada] Tipo/Nmero de Inscrio Sacador/Avalista Invlido');
	INCLUI_ERRCNABR('707', '0353', '[Entrada Rejeitada] Prazo de vencimento do ttulo excede ao da contratao');
	INCLUI_ERRCNABR('707', '0354', '[Entrada Rejeitada] Banco informado no  nosso correspondente 140-142');
	INCLUI_ERRCNABR('707', '0355', '[Entrada Rejeitada] Banco correspondente informado no cobra este CEP ou no possui faixas de CEP cadastradas');
	INCLUI_ERRCNABR('707', '0356', '[Entrada Rejeitada] Nosso nmero no correspondente no foi informado');
	INCLUI_ERRCNABR('707', '0357', '[Entrada Rejeitada] Remessa contendo duas instrues incompatveis  no protestar e dias de protesto ou prazo para protesto invlido.');
	INCLUI_ERRCNABR('707', '0358', '[Entrada Rejeitada] Entrada Rejeitada  Reprovado no Represamento para Anlise');
	INCLUI_ERRCNABR('707', '0360', '[Entrada Rejeitada] CNPJ/CPF do sacado invlido  ttulo recusado');
	INCLUI_ERRCNABR('707', '0387', '[Entrada Rejeitada] Excede Prazo mximo entre emisso e vencimento');
	INCLUI_ERRCNABR('707', '0399', '[Entrada Rejeitada] Ttulo no acatado pelo banco  entrar em contato Gerente da conta');
	INCLUI_ERRCNABR('707', '03AE', '[Entrada Rejeitada] Ttulo no possui abatimento');
	INCLUI_ERRCNABR('707', '03AG', '[Entrada Rejeitada] Movimento no permitido  Ttulo  vista ou contra apresentao');
	INCLUI_ERRCNABR('707', '03AK', '[Entrada Rejeitada] Ttulo pertence a outro cliente');
	INCLUI_ERRCNABR('707', '03AL', '[Entrada Rejeitada] Sacado impedido de entrar nesta cobrana');
	INCLUI_ERRCNABR('707', '03AY', '[Entrada Rejeitada] Ttulo deve estar em aberto e vencido para acatar protesto');
	INCLUI_ERRCNABR('707', '03BC', '[Entrada Rejeitada] Anlise gerencial-sacado invlido p/operao crdito');
	INCLUI_ERRCNABR('707', '03BD', '[Entrada Rejeitada] Anlise gerencial-sacado inadimplente');
	INCLUI_ERRCNABR('707', '03BE', '[Entrada Rejeitada] Anlise gerencial-sacado difere do exigido');
	INCLUI_ERRCNABR('707', '03BF', '[Entrada Rejeitada] Anlise gerencial-vencto excede vencto da operao de crdito');
	INCLUI_ERRCNABR('707', '03BG', '[Entrada Rejeitada] Anlise gerencial-sacado com baixa liquidez');
	INCLUI_ERRCNABR('707', '03BH', '[Entrada Rejeitada] Anlise gerencial-sacado excede concentrao');
	INCLUI_ERRCNABR('707', '03CB', '[Entrada Rejeitada] Ttulo possui protesto efetivado/a efetivar hoje');
	INCLUI_ERRCNABR('707', '03CC', '[Entrada Rejeitada] Valor de iof incompatvel com a espcie documento');
	INCLUI_ERRCNABR('707', '03CD', '[Entrada Rejeitada] Efetivao de protesto sem agenda vlida');
	INCLUI_ERRCNABR('707', '03CE', '[Entrada Rejeitada] Ttulo no aceito - pessoa fsica');
	INCLUI_ERRCNABR('707', '03CF', '[Entrada Rejeitada] Excede prazo mximo da entrada ao vencimento');
	INCLUI_ERRCNABR('707', '03CG', '[Entrada Rejeitada] Ttulo no aceito  por anlise gerencial');
	INCLUI_ERRCNABR('707', '03CH', '[Entrada Rejeitada] Ttulo em espera  em anlise pelo banco');
	INCLUI_ERRCNABR('707', '03CJ', '[Entrada Rejeitada] Anlise gerencial-vencto do titulo abaixo przcurto');
	INCLUI_ERRCNABR('707', '03CK', '[Entrada Rejeitada] Anlise gerencial-vencto do titulo abaixo przlongo');
	INCLUI_ERRCNABR('707', '03CS', '[Entrada Rejeitada] Ttulo rejeitado pela checagem de duplicatas');
	INCLUI_ERRCNABR('707', '03CT', '[Entrada Rejeitada] Ttulo j baixado');
	INCLUI_ERRCNABR('707', '03DA', '[Entrada Rejeitada] Anlise gerencial  Entrada de Ttulo Descontado com limite cancelado');
	INCLUI_ERRCNABR('707', '03DB', '[Entrada Rejeitada] Anlise gerencial  Entrada de Ttulo Descontado com limite vencido');
	INCLUI_ERRCNABR('707', '03DC', '[Entrada Rejeitada] Anlise gerencial - cedente com limite cancelado');
	INCLUI_ERRCNABR('707', '03DD', '[Entrada Rejeitada] Anlise gerencial  cedente  sacado e teve seu limite cancelado');
	INCLUI_ERRCNABR('707', '03DE', '[Entrada Rejeitada] Anlise gerencial - apontamento no Serasa');
	INCLUI_ERRCNABR('707', '03DG', '[Entrada Rejeitada] Endereo sacador/avalista no informado');
	INCLUI_ERRCNABR('707', '03DH', '[Entrada Rejeitada] Cep do sacador/avalista no informado');
	INCLUI_ERRCNABR('707', '03DI', '[Entrada Rejeitada] Cidade do sacador/avalista no informado');
	INCLUI_ERRCNABR('707', '03DJ', '[Entrada Rejeitada] Estado do sacador/avalista invlido ou n informado');
	INCLUI_ERRCNABR('707', '03DM', '[Entrada Rejeitada] Cliente sem Cdigo de Flash cadastrado no cobrador');
	INCLUI_ERRCNABR('707', '03DN', '[Entrada Rejeitada] Ttulo Descontado com Prazo ZERO  Recusado');
	INCLUI_ERRCNABR('707', '03DO', '[Entrada Rejeitada] Ttulo em Prejuzo');
	INCLUI_ERRCNABR('707', '03DP', '[Entrada Rejeitada] Data de Referncia menor que a Data de Emisso do Ttulo');
	INCLUI_ERRCNABR('707', '03DT', '[Entrada Rejeitada] Nosso Nmero do Correspondente no deve ser informado');
	INCLUI_ERRCNABR('707', '03EB', '[Entrada Rejeitada] HSBC no aceita endereo de sacado com mais de 38 caracteres');
	INCLUI_ERRCNABR('707', '1505', '[Baixa Rejeitada] Solicitao de baixa para ttulo j baixado ou liquidado');
	INCLUI_ERRCNABR('707', '1506', '[Baixa Rejeitada] Solicitao de baixa para ttulo no registrado no sistema');
	INCLUI_ERRCNABR('707', '1508', '[Baixa Rejeitada] Solicitao de baixa para ttulo em float');
	INCLUI_ERRCNABR('707', '1605', '[Instruo Rejeitada] Solicitao de baixa para ttulo j baixado ou liquidado');
	INCLUI_ERRCNABR('707', '1604', '[Instruo Rejeitada] Data de Vencimento no numrica ou invlida');
	INCLUI_ERRCNABR('707', '1614', '[Instruo Rejeitada] Registro em duplicidade');
	INCLUI_ERRCNABR('707', '1620', '[Instruo Rejeitada] Campo livre informado');
	INCLUI_ERRCNABR('707', '1621', '[Instruo Rejeitada] Ttulo no registrado no sistema');
	INCLUI_ERRCNABR('707', '1622', '[Instruo Rejeitada] Ttulo baixada ou liquidado');
	INCLUI_ERRCNABR('707', '1627', '[Instruo Rejeitada] Instruo no aceita, pr no ter sido emitida ordem de protesto ao cartrio');
	INCLUI_ERRCNABR('707', '1628', '[Instruo Rejeitada] Ttulo tem instruo de cartrio ativa');
	INCLUI_ERRCNABR('707', '1629', '[Instruo Rejeitada] Ttulo no tem instruo de cartrio ativa');
	INCLUI_ERRCNABR('707', '1630', '[Instruo Rejeitada] Existe instruo de no protestar, ativa para o ttulo');
	INCLUI_ERRCNABR('707', '1637', '[Instruo Rejeitada] Ttulo Descontado - Instruo no permitida para a carteira');
	INCLUI_ERRCNABR('707', '1638', '[Instruo Rejeitada] Valor do abatimento no numrico ou maior que a soma do valor do ttulo + pemanncia + multa');
	INCLUI_ERRCNABR('707', '1639', '[Instruo Rejeitada] Ttulo em cartrio');
	INCLUI_ERRCNABR('707', '1640', '[Instruo Rejeitada] Instruo recusada - cobrana vinculada / caucionada');
	INCLUI_ERRCNABR('707', '1699', '[Instruo Rejeitada] Ocorrncia desconhecida na remessa');
	COMMIT;
END;
/
BEGIN
-- BANCO ALFA 025

   INCLUI_ERRCNABR('025', '0200', '[ENTRADA CONFIRMADA] OCORRNCIA ACEITA');
   INCLUI_ERRCNABR('025', '0217', '[ENTRADA CONFIRMADA] DATA VENCIMENTO ANTERIOR A DATA DE EMISSO');
   INCLUI_ERRCNABR('025', '0221', '[ENTRADA CONFIRMADA] ESPCIE DO TTULO INVLIDO');
   INCLUI_ERRCNABR('025', '0224', '[ENTRADA CONFIRMADA] DATA DA EMISSO INVLIDA');
   INCLUI_ERRCNABR('025', '0238', '[ENTRADA CONFIRMADA] PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('025', '0239', '[ENTRADA CONFIRMADA] PEDIDO P.PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('025', '0243', '[ENTRADA CONFIRMADA] PRAZO PARA BAIXA DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('025', '0245', '[ENTRADA CONFIRMADA] NOME DO SACADO INVALIDO');
   INCLUI_ERRCNABR('025', '0246', '[ENTRADA CONFIRMADA] TIPO/NUM. DE INSCRIO DO SACADO INVLIDOS');
   INCLUI_ERRCNABR('025', '0247', '[ENTRADA CONFIRMADA] ENDEREO DO SACADO INVLIDO');
   INCLUI_ERRCNABR('025', '0248', '[ENTRADA CONFIRMADA] CEP INVLIDO');
   INCLUI_ERRCNABR('025', '0250', '[ENTRADA CONFIRMADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('025', '0253', '[ENTRADA CONFIRMADA] N INCR. SACADOR/AVALISTA INVLIDOS (CNPJ/CPF)');
   INCLUI_ERRCNABR('025', '0254', '[ENTRADA CONFIRMADA] SACADOR/AVALISTA NO INFORMADO');
   INCLUI_ERRCNABR('025', '0267', '[ENTRADA CONFIRMADA] DB. AUTOMTICO AGENDADO');
   INCLUI_ERRCNABR('025', '0268', '[ENTRADA CONFIRMADA] DB. NO AGENDADO ERRO NOS DADOS DE REMESSA');
   INCLUI_ERRCNABR('025', '0269', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - SACADO NO CONSTA NO CAD. AUTORIZANTE');
   INCLUI_ERRCNABR('025', '0270', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - CEDENTE NO AUTORIZADO PELO SACADO');
   INCLUI_ERRCNABR('025', '0271', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - CEDENTE NO CADASTRADO P/ DBITO AUTOMTICO');
   INCLUI_ERRCNABR('025', '0272', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - CDIGO DE MOEDA DIFERENTE DE R$');
   INCLUI_ERRCNABR('025', '0273', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('025', '0275', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - TIPO NMERO DE INSCRIO DO DEBITADO INVLIDO');
   INCLUI_ERRCNABR('025', '0286', '[ENTRADA CONFIRMADA] SEU NMERO INVLIDO');
   INCLUI_ERRCNABR('025', '0302', '[ENTRADA REJEITADA] CDIGO DO REGISTRO DETALHE INVLIDO');
   INCLUI_ERRCNABR('025', '0303', '[ENTRADA REJEITADA] CDIGO DA OCORRNCIA INVLIDO');
   INCLUI_ERRCNABR('025', '0304', '[ENTRADA REJEITADA] CD. DA OCORR. NO PERMITIDA P/A CARTEIRA');
   INCLUI_ERRCNABR('025', '0305', '[ENTRADA REJEITADA] CD. DA OCORRNCIA NO NUMRICA');
   INCLUI_ERRCNABR('025', '0308', '[ENTRADA REJEITADA] NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('025', '0309', '[ENTRADA REJEITADA] NOSSO NMERO DUPLICADO');
   INCLUI_ERRCNABR('025', '0310', '[ENTRADA REJEITADA] CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('025', '0316', '[ENTRADA REJEITADA] DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('025', '0318', '[ENTRADA REJEITADA] VENCIMENTO FORA DO PRAZO DE OPERAO');
   INCLUI_ERRCNABR('025', '0320', '[ENTRADA REJEITADA] VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('025', '0321', '[ENTRADA REJEITADA] ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('025', '0322', '[ENTRADA REJEITADA] ESPCIE NO PERMITIDA P/ CARTEIRA');
   INCLUI_ERRCNABR('025', '0324', '[ENTRADA REJEITADA] DATA DE EMISSO INVLIDA');
   INCLUI_ERRCNABR('025', '0350', '[ENTRADA REJEITADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('025', '0363', '[ENTRADA REJEITADA] ENTRADA P/TTULO J CADASTRADO');
   INCLUI_ERRCNABR('025', '0368', '[ENTRADA REJEITADA] DB. NO AGENDADO - ERRO NOS DADOS DE REMESSA');
   INCLUI_ERRCNABR('025', '0369', '[ENTRADA REJEITADA] DB. NO AGENDADO - SACADO NO CONSTA NO CAD. DE AUTORIZANTE');
   INCLUI_ERRCNABR('025', '0370', '[ENTRADA REJEITADA] DB. NO AGENDADO - CEDENTE NO AUTORIZADO PELO SACADO');
   INCLUI_ERRCNABR('025', '0371', '[ENTRADA REJEITADA] DB. NO AGENDADO - CEDENTE NO CADASTRADO P/ DBITO AUTOMTICO');
   INCLUI_ERRCNABR('025', '0372', '[ENTRADA REJEITADA] DB. NO AGENDADO - CDIGO DE MOEDA DIFERENTE DE R$');
   INCLUI_ERRCNABR('025', '0373', '[ENTRADA REJEITADA] DB. NO AGENDADO - DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('025', '0374', '[ENTRADA REJEITADA] DB. NO AGENDADO, CONFORME SEU PEDIDO, TTULO NO REGISTRADO');
   INCLUI_ERRCNABR('025', '0375', '[ENTRADA REJEITADA] DB. NO AGENDADO - TIPO NMERO DE INSCRIO DO DEBITADO INVLIDO');
   INCLUI_ERRCNABR('025', '06  ', '[LIQUIDAO NORMAL] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '0910', '[BAIXADO AUT. VIA ARQUIVO] BAIXA COMANDADA PELO CLIENTE');
   INCLUI_ERRCNABR('025', '1000', '[BAIXADO CONF. INST. AG.] BAIXA COMANDADA');
   INCLUI_ERRCNABR('025', '1014', '[BAIXADO CONF. INST. AG.] TTULO  PROTESTADO');
   INCLUI_ERRCNABR('025', '1015', '[BAIXADO CONF. INST. AG.] TTULO EXCLUDO');
   INCLUI_ERRCNABR('025', '11  ', '[EM SER (TTULO PENDENTE)] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '12  ', '[ABATIMENTO CONCEDIDO] -SEM MOTIVO');
   INCLUI_ERRCNABR('025', '13  ', '[ABATIMENTO CANCELADO] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '14  ', '[VENCIMENTO ALTERADO] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '15  ', '[LIQUIDAO EM CARTRIO] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '17  ', '[LIQUIDAO APS BAIXA] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '18  ', '[ACERTO DE DEPOSITRIA] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '19  ', '[CONF.RECEB.INST. PROTESTO ] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '20  ', '[CONF.RECEB.INST.SUST.PROT.] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '21  ', '[ACERTO CONT. PARTICIPANTE] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '23  ', '[ENTRADA TTULO EM CARTRIO] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '2448', '[ENTRADA REJEITADA] CEP INVLIDO');
   INCLUI_ERRCNABR('025', '2707', '[BAIXA REJEITADA] AGNCIA/CONTA/DV. INVLIDO');
   INCLUI_ERRCNABR('025', '2708', '[BAIXA REJEITADA] NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('025', '2710', '[BAIXA REJEITADA] CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('025', '2715', '[BAIXA REJEITADA] CARTEIRA/AG./CONTA/NUM. INVLIDOS');
   INCLUI_ERRCNABR('025', '2740', '[BAIXA REJEITADA] TTULO COM ORDEM DE PROTESTO');
   INCLUI_ERRCNABR('025', '2742', '[BAIXA REJEITADA] CDIGO P/BAIXA/DEV; VIA TELEB. INVLIDO');
   INCLUI_ERRCNABR('025', '2760', '[BAIXA REJEITADA] MOVIMENTO P/TTULO NO CADASTRADO');
   INCLUI_ERRCNABR('025', '2803', '[DB. DE TARIFAS/CUSTOS] TARIFA DE SUSTAO(valor informado-posio 176  188)');
   INCLUI_ERRCNABR('025', '2808', '[DB. DE TARIFAS/CUSTOS] CUSTAS DE PROTESTO(valor informado-posio 189  201)');
   INCLUI_ERRCNABR('025', '2804', '[DB. DE TARIFAS/CUSTOS] TARIFA DE PROTESTO (valor informado-posio 176  188)');
   INCLUI_ERRCNABR('025', '3001', '[ALTERAO/DADOS REJEITADOS] CDIGO DO BANCO INVLIDO');
   INCLUI_ERRCNABR('025', '3004', '[ALTERAO/DADOS REJEITADOS] CDIGO DE OCORRNCIA NO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('025', '3005', '[ALTERAO/DADOS REJEITADOS] CDIGO DA OCORRNCIA NO NUMRICO');
   INCLUI_ERRCNABR('025', '3008', '[ALTERAO/DADOS REJEITADOS] NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('025', '3015', '[ALTERAO/DADOS REJEITADOS] CARACTERSTICAS  DA COBRANA INCOMPATVEIS');
   INCLUI_ERRCNABR('025', '3016', '[ALTERAO/DADOS REJEITADOS] DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('025', '3017', '[ALTERAO/DADOS REJEITADOS] DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSO');
   INCLUI_ERRCNABR('025', '3018', '[ALTERAO/DADOS REJEITADOS] VENCIMENTO FORA DO PRAZO DE OPERAO');
   INCLUI_ERRCNABR('025', '3024', '[ALTERAO/DADOS REJEITADOS] DATA DA EMISSO INVLIDA');
   INCLUI_ERRCNABR('025', '3029', '[ALTERAO/DADOS REJEITADOS] VALOR DESC. MAIOR/IGUAL AO VALOR DO TTULO');
   INCLUI_ERRCNABR('025', '3030', '[ALTERAO/DADOS REJEITADOS] DESCONTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('025', '3031', '[ALTERAO/DADOS REJEITADOS] CONCESSO DE DESCONTO J EXISTENTE - DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('025', '3033', '[ALTERAO/DADOS REJEITADOS] VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('025', '3034', '[ALTERAO/DADOS REJEITADOS] VALOR ABAT. MAIOR/IGUAL VALOR DO TTULO');
   INCLUI_ERRCNABR('025', '3038', '[ALTERAO/DADOS REJEITADOS] PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('025', '3039', '[ALTERAO/DADOS REJEITADOS] PEDIDO DE PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('025', '3040', '[ALTERAO/DADOS REJEITADOS] TTULO COM ORDEM DE PROTESTO EMITIDO');
   INCLUI_ERRCNABR('025', '3042', '[ALTERAO/DADOS REJEITADOS] CDIGO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('025', '3060', '[ALTERAO/DADOS REJEITADOS] MOVIMENTO PARA TTULO NO CADASTRADO');
   INCLUI_ERRCNABR('025', '3085', '[ALTERAO/DADOS REJEITADOS] TTULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('025', '3201', '[INSTRUO REJEITADA] CDIGO DO BANCO INVLIDO');
   INCLUI_ERRCNABR('025', '3204', '[INSTRUO REJEITADA] CDIGO DE OCORRNCIA NO PERMITIDO PARA A CARTEIRA');
   INCLUI_ERRCNABR('025', '3215', '[INSTRUO REJEITADA] CARACTERSTICAS DA COBRANA INCOMPATVEIS');
   INCLUI_ERRCNABR('025', '3216', '[INSTRUO REJEITADA] DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('025', '3217', '[INSTRUO REJEITADA] DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSO');
   INCLUI_ERRCNABR('025', '3218', '[INSTRUO REJEITADA] VENCIMENTO FORA DO PRAZO DE OPERAO');
   INCLUI_ERRCNABR('025', '3220', '[INSTRUO REJEITADA] VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('025', '3221', '[INSTRUO REJEITADA] ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('025', '3223', '[INSTRUO REJEITADA] ACEITE INVLIDO');
   INCLUI_ERRCNABR('025', '3224', '[INSTRUO REJEITADA] DATA DE EMISSO INVLIDA');
   INCLUI_ERRCNABR('025', '3228', '[INSTRUO REJEITADA] CDIGO DO DESCONTO INVLIDO');
   INCLUI_ERRCNABR('025', '3229', '[INSTRUO REJEITADA] VALOR DO DESCONTO MAIOR/IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('025', '3230', '[INSTRUO REJEITADA] DESCONTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('025', '3231', '[INSTRUO REJEITADA] CONCESSO DE DESCONTO-J EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('025', '3233', '[INSTRUO REJEITADA] VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('025', '3234', '[INSTRUO REJEITADA] VALOR DO ABATIMENTO MAIOR/IGUAL AO VALOR ANTERIOR');
   INCLUI_ERRCNABR('025', '3236', '[INSTRUO REJEITADA] CONCESSO DE ABATIMENTO-J EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('025', '3238', '[INSTRUO REJEITADA] PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('025', '3239', '[INSTRUO REJEITADA] PEDIDO DE PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('025', '3240', '[INSTRUO REJEITADA] TTULO COM ORDEM DE PROTESTO EMITIDO');
   INCLUI_ERRCNABR('025', '3241', '[INSTRUO REJEITADA] PEDIDO DE CANCELAMENTO P/ TTULOS S/INSTRUO PROTESTO');
   INCLUI_ERRCNABR('025', '3242', '[INSTRUO REJEITADA] CDIGO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('025', '3245', '[INSTRUO REJEITADA] NOME DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('025', '3246', '[INSTRUO REJEITADA] TIPO/NMERO DE INCRIO DO SACADO INVLIDOS');
   INCLUI_ERRCNABR('025', '3247', '[INSTRUO REJEITADA] ENDEREO DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('025', '3248', '[INSTRUO REJEITADA] CEP INVLIDO');
   INCLUI_ERRCNABR('025', '3250', '[INSTRUO REJEITADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('025', '3253', '[INSTRUO REJEITADA] TIPO/NMERO DE INSCRIO DO SACADOR AVALISTA INVLIDOS');
   INCLUI_ERRCNABR('025', '3260', '[INSTRUO REJEITADA] MOVIMENTO PARA TTULO NO CADASTRADO');
   INCLUI_ERRCNABR('025', '3285', '[INSTRUO REJEITADA] TTULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('025', '3286', '[INSTRUO REJEITADA] SEU NMERO INVLIDO');
   INCLUI_ERRCNABR('025', '33  ', '[CONFIRMAO ALTERAO DADOS] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '34  ', '[RETIRADO CARTRIO E PENDENTE] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '3581', '[CANCELAMENTO DEB. AUTOM.] TENTATIVAS ESGOTADAS, BAIXADO');
   INCLUI_ERRCNABR('025', '3582', '[CANCELAMENTO DEB. AUTOM.] TENTATIVAS ESGOTADAS, PENDENTE');
   COMMIT;
END;
/
BEGIN
-- BANCO BRR 394
   INCLUI_ERRCNABR('394', '0200', '[ENTRADA CONFIRMADA] OCORRNCIA ACEITA');
   INCLUI_ERRCNABR('394', '0217', '[ENTRADA CONFIRMADA] DATA VENCIMENTO ANTERIOR A DATA DE EMISSO');
   INCLUI_ERRCNABR('394', '0221', '[ENTRADA CONFIRMADA] ESPCIE DO TTULO INVLIDO');
   INCLUI_ERRCNABR('394', '0224', '[ENTRADA CONFIRMADA] DATA DA EMISSO INVLIDA');
   INCLUI_ERRCNABR('394', '0238', '[ENTRADA CONFIRMADA] PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('394', '0239', '[ENTRADA CONFIRMADA] PEDIDO P.PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('394', '0243', '[ENTRADA CONFIRMADA] PRAZO PARA BAIXA DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('394', '0245', '[ENTRADA CONFIRMADA] NOME DO SACADO INVALIDO');
   INCLUI_ERRCNABR('394', '0246', '[ENTRADA CONFIRMADA] TIPO/NUM. DE INSCRIO DO SACADO INVLIDOS');
   INCLUI_ERRCNABR('394', '0247', '[ENTRADA CONFIRMADA] ENDEREO DO SACADO INVLIDO');
   INCLUI_ERRCNABR('394', '0248', '[ENTRADA CONFIRMADA] CEP INVLIDO');
   INCLUI_ERRCNABR('394', '0250', '[ENTRADA CONFIRMADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('394', '0253', '[ENTRADA CONFIRMADA] N INCR. SACADOR/AVALISTA INVLIDOS (CNPJ/CPF)');
   INCLUI_ERRCNABR('394', '0254', '[ENTRADA CONFIRMADA] SACADOR/AVALISTA NO INFORMADO');
   INCLUI_ERRCNABR('394', '0267', '[ENTRADA CONFIRMADA] DB. AUTOMTICO AGENDADO');
   INCLUI_ERRCNABR('394', '0268', '[ENTRADA CONFIRMADA] DB. NO AGENDADO ERRO NOS DADOS DE REMESSA');
   INCLUI_ERRCNABR('394', '0269', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - SACADO NO CONSTA NO CAD. AUTORIZANTE');
   INCLUI_ERRCNABR('394', '0270', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - CEDENTE NO AUTORIZADO PELO SACADO');
   INCLUI_ERRCNABR('394', '0271', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - CEDENTE NO CADASTRADO P/ DBITO AUTOMTICO');
   INCLUI_ERRCNABR('394', '0272', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - CDIGO DE MOEDA DIFERENTE DE R$');
   INCLUI_ERRCNABR('394', '0273', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('394', '0275', '[ENTRADA CONFIRMADA] DB. NO AGENDADO - TIPO NMERO DE INSCRIO DO DEBITADO INVLIDO');
   INCLUI_ERRCNABR('394', '0286', '[ENTRADA CONFIRMADA] SEU NMERO INVLIDO');
   INCLUI_ERRCNABR('394', '0302', '[ENTRADA REJEITADA] CDIGO DO REGISTRO DETALHE INVLIDO');
   INCLUI_ERRCNABR('394', '0303', '[ENTRADA REJEITADA] CDIGO DA OCORRNCIA INVLIDO');
   INCLUI_ERRCNABR('394', '0304', '[ENTRADA REJEITADA] CD. DA OCORR. NO PERMITIDA P/A CARTEIRA');
   INCLUI_ERRCNABR('394', '0305', '[ENTRADA REJEITADA] CD. DA OCORRNCIA NO NUMRICA');
   INCLUI_ERRCNABR('394', '0308', '[ENTRADA REJEITADA] NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('394', '0309', '[ENTRADA REJEITADA] NOSSO NMERO DUPLICADO');
   INCLUI_ERRCNABR('394', '0310', '[ENTRADA REJEITADA] CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('394', '0316', '[ENTRADA REJEITADA] DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('394', '0318', '[ENTRADA REJEITADA] VENCIMENTO FORA DO PRAZO DE OPERAO');
   INCLUI_ERRCNABR('394', '0320', '[ENTRADA REJEITADA] VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('394', '0321', '[ENTRADA REJEITADA] ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('394', '0322', '[ENTRADA REJEITADA] ESPCIE NO PERMITIDA P/ CARTEIRA');
   INCLUI_ERRCNABR('394', '0324', '[ENTRADA REJEITADA] DATA DE EMISSO INVLIDA');
   INCLUI_ERRCNABR('394', '0350', '[ENTRADA REJEITADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('394', '0363', '[ENTRADA REJEITADA] ENTRADA P/TTULO J CADASTRADO');
   INCLUI_ERRCNABR('394', '0368', '[ENTRADA REJEITADA] DB. NO AGENDADO - ERRO NOS DADOS DE REMESSA');
   INCLUI_ERRCNABR('394', '0369', '[ENTRADA REJEITADA] DB. NO AGENDADO - SACADO NO CONSTA NO CAD. DE AUTORIZANTE');
   INCLUI_ERRCNABR('394', '0370', '[ENTRADA REJEITADA] DB. NO AGENDADO - CEDENTE NO AUTORIZADO PELO SACADO');
   INCLUI_ERRCNABR('394', '0371', '[ENTRADA REJEITADA] DB. NO AGENDADO - CEDENTE NO CADASTRADO P/ DBITO AUTOMTICO');
   INCLUI_ERRCNABR('394', '0372', '[ENTRADA REJEITADA] DB. NO AGENDADO - CDIGO DE MOEDA DIFERENTE DE R$');
   INCLUI_ERRCNABR('394', '0373', '[ENTRADA REJEITADA] DB. NO AGENDADO - DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('394', '0374', '[ENTRADA REJEITADA] DB. NO AGENDADO, CONFORME SEU PEDIDO, TTULO NO REGISTRADO');
   INCLUI_ERRCNABR('394', '0375', '[ENTRADA REJEITADA] DB. NO AGENDADO - TIPO NMERO DE INSCRIO DO DEBITADO INVLIDO');
   INCLUI_ERRCNABR('394', '06  ', '[LIQUIDAO NORMAL] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '0910', '[BAIXADO AUT. VIA ARQUIVO] BAIXA COMANDADA PELO CLIENTE');
   INCLUI_ERRCNABR('394', '1000', '[BAIXADO CONF. INST. AG.] BAIXA COMANDADA');
   INCLUI_ERRCNABR('394', '1014', '[BAIXADO CONF. INST. AG.] TTULO  PROTESTADO');
   INCLUI_ERRCNABR('394', '1015', '[BAIXADO CONF. INST. AG.] TTULO EXCLUDO');
   INCLUI_ERRCNABR('394', '11  ', '[EM SER (TTULO PENDENTE)] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '12  ', '[ABATIMENTO CONCEDIDO] -SEM MOTIVO');
   INCLUI_ERRCNABR('394', '13  ', '[ABATIMENTO CANCELADO] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '14  ', '[VENCIMENTO ALTERADO] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '15  ', '[LIQUIDAO EM CARTRIO] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '17  ', '[LIQUIDAO APS BAIXA] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '18  ', '[ACERTO DE DEPOSITRIA] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '19  ', '[CONF.RECEB.INST. PROTESTO ] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '20  ', '[CONF.RECEB.INST.SUST.PROT.] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '21  ', '[ACERTO CONT. PARTICIPANTE] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '23  ', '[ENTRADA TTULO EM CARTRIO] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '2448', '[ENTRADA REJEITADA] CEP INVLIDO');
   INCLUI_ERRCNABR('394', '2707', '[BAIXA REJEITADA] AGNCIA/CONTA/DV. INVLIDO');
   INCLUI_ERRCNABR('394', '2708', '[BAIXA REJEITADA] NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('394', '2710', '[BAIXA REJEITADA] CARTEIRA INVLIDA');
   INCLUI_ERRCNABR('394', '2715', '[BAIXA REJEITADA] CARTEIRA/AG./CONTA/NUM. INVLIDOS');
   INCLUI_ERRCNABR('394', '2740', '[BAIXA REJEITADA] TTULO COM ORDEM DE PROTESTO');
   INCLUI_ERRCNABR('394', '2742', '[BAIXA REJEITADA] CDIGO P/BAIXA/DEV; VIA TELEB. INVLIDO');
   INCLUI_ERRCNABR('394', '2760', '[BAIXA REJEITADA] MOVIMENTO P/TTULO NO CADASTRADO');
   INCLUI_ERRCNABR('394', '2803', '[DB. DE TARIFAS/CUSTOS] TARIFA DE SUSTAO(valor informado-posio 176  188)');
   INCLUI_ERRCNABR('394', '2808', '[DB. DE TARIFAS/CUSTOS] CUSTAS DE PROTESTO(valor informado-posio 189  201)');
   INCLUI_ERRCNABR('394', '2804', '[DB. DE TARIFAS/CUSTOS] TARIFA DE PROTESTO (valor informado-posio 176  188)');
   INCLUI_ERRCNABR('394', '3001', '[ALTERAO/DADOS REJEITADOS] CDIGO DO BANCO INVLIDO');
   INCLUI_ERRCNABR('394', '3004', '[ALTERAO/DADOS REJEITADOS] CDIGO DE OCORRNCIA NO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('394', '3005', '[ALTERAO/DADOS REJEITADOS] CDIGO DA OCORRNCIA NO NUMRICO');
   INCLUI_ERRCNABR('394', '3008', '[ALTERAO/DADOS REJEITADOS] NOSSO NMERO INVLIDO');
   INCLUI_ERRCNABR('394', '3015', '[ALTERAO/DADOS REJEITADOS] CARACTERSTICAS  DA COBRANA INCOMPATVEIS');
   INCLUI_ERRCNABR('394', '3016', '[ALTERAO/DADOS REJEITADOS] DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('394', '3017', '[ALTERAO/DADOS REJEITADOS] DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSO');
   INCLUI_ERRCNABR('394', '3018', '[ALTERAO/DADOS REJEITADOS] VENCIMENTO FORA DO PRAZO DE OPERAO');
   INCLUI_ERRCNABR('394', '3024', '[ALTERAO/DADOS REJEITADOS] DATA DA EMISSO INVLIDA');
   INCLUI_ERRCNABR('394', '3029', '[ALTERAO/DADOS REJEITADOS] VALOR DESC. MAIOR/IGUAL AO VALOR DO TTULO');
   INCLUI_ERRCNABR('394', '3030', '[ALTERAO/DADOS REJEITADOS] DESCONTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('394', '3031', '[ALTERAO/DADOS REJEITADOS] CONCESSO DE DESCONTO J EXISTENTE - DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('394', '3033', '[ALTERAO/DADOS REJEITADOS] VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('394', '3034', '[ALTERAO/DADOS REJEITADOS] VALOR ABAT. MAIOR/IGUAL VALOR DO TTULO');
   INCLUI_ERRCNABR('394', '3038', '[ALTERAO/DADOS REJEITADOS] PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('394', '3039', '[ALTERAO/DADOS REJEITADOS] PEDIDO DE PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('394', '3040', '[ALTERAO/DADOS REJEITADOS] TTULO COM ORDEM DE PROTESTO EMITIDO');
   INCLUI_ERRCNABR('394', '3042', '[ALTERAO/DADOS REJEITADOS] CDIGO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('394', '3060', '[ALTERAO/DADOS REJEITADOS] MOVIMENTO PARA TTULO NO CADASTRADO');
   INCLUI_ERRCNABR('394', '3085', '[ALTERAO/DADOS REJEITADOS] TTULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('394', '3201', '[INSTRUO REJEITADA] CDIGO DO BANCO INVLIDO');
   INCLUI_ERRCNABR('394', '3204', '[INSTRUO REJEITADA] CDIGO DE OCORRNCIA NO PERMITIDO PARA A CARTEIRA');
   INCLUI_ERRCNABR('394', '3215', '[INSTRUO REJEITADA] CARACTERSTICAS DA COBRANA INCOMPATVEIS');
   INCLUI_ERRCNABR('394', '3216', '[INSTRUO REJEITADA] DATA DE VENCIMENTO INVLIDA');
   INCLUI_ERRCNABR('394', '3217', '[INSTRUO REJEITADA] DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSO');
   INCLUI_ERRCNABR('394', '3218', '[INSTRUO REJEITADA] VENCIMENTO FORA DO PRAZO DE OPERAO');
   INCLUI_ERRCNABR('394', '3220', '[INSTRUO REJEITADA] VALOR DO TTULO INVLIDO');
   INCLUI_ERRCNABR('394', '3221', '[INSTRUO REJEITADA] ESPCIE DO TTULO INVLIDA');
   INCLUI_ERRCNABR('394', '3223', '[INSTRUO REJEITADA] ACEITE INVLIDO');
   INCLUI_ERRCNABR('394', '3224', '[INSTRUO REJEITADA] DATA DE EMISSO INVLIDA');
   INCLUI_ERRCNABR('394', '3228', '[INSTRUO REJEITADA] CDIGO DO DESCONTO INVLIDO');
   INCLUI_ERRCNABR('394', '3229', '[INSTRUO REJEITADA] VALOR DO DESCONTO MAIOR/IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('394', '3230', '[INSTRUO REJEITADA] DESCONTO A CONCEDER NO CONFERE');
   INCLUI_ERRCNABR('394', '3231', '[INSTRUO REJEITADA] CONCESSO DE DESCONTO-J EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('394', '3233', '[INSTRUO REJEITADA] VALOR DO ABATIMENTO INVLIDO');
   INCLUI_ERRCNABR('394', '3234', '[INSTRUO REJEITADA] VALOR DO ABATIMENTO MAIOR/IGUAL AO VALOR ANTERIOR');
   INCLUI_ERRCNABR('394', '3236', '[INSTRUO REJEITADA] CONCESSO DE ABATIMENTO-J EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('394', '3238', '[INSTRUO REJEITADA] PRAZO PARA PROTESTO INVLIDO');
   INCLUI_ERRCNABR('394', '3239', '[INSTRUO REJEITADA] PEDIDO DE PROTESTO NO PERMITIDO PARA O TTULO');
   INCLUI_ERRCNABR('394', '3240', '[INSTRUO REJEITADA] TTULO COM ORDEM DE PROTESTO EMITIDO');
   INCLUI_ERRCNABR('394', '3241', '[INSTRUO REJEITADA] PEDIDO DE CANCELAMENTO P/ TTULOS S/INSTRUO PROTESTO');
   INCLUI_ERRCNABR('394', '3242', '[INSTRUO REJEITADA] CDIGO PARA BAIXA/DEVOLUO INVLIDO');
   INCLUI_ERRCNABR('394', '3245', '[INSTRUO REJEITADA] NOME DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('394', '3246', '[INSTRUO REJEITADA] TIPO/NMERO DE INCRIO DO SACADO INVLIDOS');
   INCLUI_ERRCNABR('394', '3247', '[INSTRUO REJEITADA] ENDEREO DO SACADO NO INFORMADO');
   INCLUI_ERRCNABR('394', '3248', '[INSTRUO REJEITADA] CEP INVLIDO');
   INCLUI_ERRCNABR('394', '3250', '[INSTRUO REJEITADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('394', '3253', '[INSTRUO REJEITADA] TIPO/NMERO DE INSCRIO DO SACADOR AVALISTA INVLIDOS');
   INCLUI_ERRCNABR('394', '3260', '[INSTRUO REJEITADA] MOVIMENTO PARA TTULO NO CADASTRADO');
   INCLUI_ERRCNABR('394', '3285', '[INSTRUO REJEITADA] TTULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('394', '3286', '[INSTRUO REJEITADA] SEU NMERO INVLIDO');
   INCLUI_ERRCNABR('394', '33  ', '[CONFIRMAO ALTERAO DADOS] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '34  ', '[RETIRADO CARTRIO E PENDENTE] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '3581', '[CANCELAMENTO DEB. AUTOM.] TENTATIVAS ESGOTADAS, BAIXADO');
   INCLUI_ERRCNABR('394', '3582', '[CANCELAMENTO DEB. AUTOM.] TENTATIVAS ESGOTADAS, PENDENTE');
   COMMIT;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('INCLUI_ERRCNABR','6.39.005'); END;
/
